#ifndef _qed_comm_h_
#define _qed_comm_h_
/*
 * comm.h : Definitionen zur Kommunikation ber diverse Protokolle.
*/

/* VA-Protokol ************************************************************/
#include "vaproto.h"

BOOLEAN	call_help		(CONST UBYTE *str);
/*
 * Schickt ein AC_HELP an das angemeldete Hilfe-ACC.
*/

BOOLEAN	call_hyp			(CONST UBYTE *data);
/*
 * Schickt data an ST-Guide.
*/

VOID 		send_vastart	(WORD id, CONST UBYTE *data);
/*
 * Schickt VA_START an id
*/


/* SE-Protokol ************************************************************/
#include "seproto.h"

typedef struct {
		UBYTE		Name[9];		/* GEM-Name der Shell */
		BOOLEAN	aktiv;		/* aktivierte Shell */
} ShellEntry;

/* globale Variablen */
EXTERN	ShellEntry	SE_Shells[];
EXTERN	PATH			SE_Makefile;
EXTERN	BOOLEAN		SE_Activ;


VOID	setupShellMenu(BOOLEAN text_win);
/*
 * Setzt das Shell-Men 
*/

VOID	hndl_SEprotokol	(WORD *msg);
/* 
 * Wertet die von der Shell kommenden Messages aus 
*/

VOID	hndl_ESprotokol	(WORD menuitem);
/* 
 * Wertet die im men ausgewhlten Aktionen aus und schickt sie der Shell 
*/


/* Drag&Drop **************************************************************/

VOID	hndl_DD				(WORD *msg);
/*
 * Wickelt Drag&Drop komplett ab.
*/

/* Sonstiges **************************************************************/

VOID 		init_comm		(VOID);
/* Alloziert einen globalen String (MemProt!!) */

VOID		term_comm		(VOID);
/* Meldet ggf. SE-Verbindung ab und gibt globalen String frei. */

#endif
