#include <string.h>		/* strlen */
#include <nkcc.h>

#include "global.h"
#include "block.h"		/* blk_demark, blk_mark */
#include "clipbrd.h"
#include "comm.h"
#include "edit.h"			/* restore_edit, make_chg */
#include "event.h"		/* abbruch */
#include "icon.h"
#include "obj.h"
#include "qed.h"
#include "rsc.h"
#include "scroll.h"		/* COPYB */
#include "set.h"
#include "tasten.h"		/* get_undo_col */
#include "text.h"
#include "windows.h"
#include "find.h"


/* exportierte Variablen ***************************************************/

UmlautEncoding	umlaut_from,
					umlaut_to;

/*****************************************************************************/

#define SETANZ 		5

#define M_CURSOR		0		/* Werte fr modus von start_suche */
#define M_TSTART		1
#define M_TENDE		2
#define M_ANFBLOCK	3
#define M_ENDBLOCK	4

LOCAL LINEP 	start;
LOCAL WORD  	text_len, text_x, 
					last_op = -1;
LOCAL LONG		text_y;
LOCAL BOOLEAN	in_block;
LOCAL SET		wort_set;

/* Variablen, die ber set_suchmode gesetzt werden */
/* !!! muessen bei match gesichet werden !!! */
LOCAL BOOLEAN	quantor, runter, grkl, wort, modus, round, line_start;
LOCAL WORD		muster_len;
LOCAL UBYTE 	muster_txt[80];
LOCAL SET		group[SETANZ];
LOCAL WORD		setanz;
LOCAL WORD		delta[256];

/* lokale Prototypen *****************************************************/
LOCAL BOOLEAN	build_popup	(POPUP *tree);
LOCAL VOID 		hist_popup	(OBJECT *tree, WORD obj);

/*=======================================================================*/

LOCAL VOID init_suche(TEXTP t_ptr, WORD modus)
{
	in_block = FALSE;
	if (modus==M_ANFBLOCK)
	{
		in_block = TRUE;
		start = t_ptr->p1;
		text_y = t_ptr->z1;
		text_x = t_ptr->x1;
		if (t_ptr->z2==text_y)
			text_len = t_ptr->x2-t_ptr->x1;
		else
			text_len = start->len-text_x;
	}
	else if (modus==M_ENDBLOCK)
	{
		in_block = TRUE;
		start = t_ptr->p2;
		text_y = t_ptr->z2;
		if (t_ptr->z1==text_y)
		{
			text_x = t_ptr->x1;
			text_len = t_ptr->x2-t_ptr->x1;
		}
		else
		{
			text_x = 0;
			text_len = t_ptr->x2;
		}
	}
	else if (modus==M_CURSOR)
	{
		if (t_ptr->block && t_ptr->cursor) in_block = TRUE;
		start = t_ptr->cursor_line;
		text_y = t_ptr->ypos;
		if (runter)
		{
			text_x = t_ptr->xpos;
			text_len = start->len-t_ptr->xpos;
			if (text_len>0)
			{
				text_x++;
				text_len--;
			}
			else if (!IS_LAST(start))
			{
				NEXT(start);
				text_y++;
				text_x = 0;
				text_len = start->len;
			}
		}
		else
		{
			text_x = 0;
			text_len = t_ptr->xpos;
			if (text_len>0)
			{
				text_len--;
			}
			else if (!IS_FIRST(start))
			{
				VORG(start);
				text_y--;
				text_len = start->len;
			}
		}
	}
	else if (modus==M_TSTART)
	{
		start = FIRST(&t_ptr->text);
		text_x = 0;
		text_len = start->len;
		text_y = 0;
	}
	else
	{
		start = LAST(&t_ptr->text);
		text_x = 0;
		text_len = start->len;
		text_y = t_ptr->text.lines-1;
	}
	setcpy(wort_set,t_ptr->loc_opt->wort_set);
}

LOCAL WORD suche1(LINEP col, WORD x, WORD str_len, WORD *such_len,
						UBYTE*(*call)(UBYTE*,WORD,UBYTE*,WORD*))
/* runter */
{
	UBYTE	*ptr, *str, *str2;

	if (quantor)
	{
		if (x>0 && line_start)									/* Muster am Anfang finden */
			return -1;
		if (x+str_len<col->len && muster_len>=2 && 
			 muster_txt[muster_len-2]=='[' && muster_txt[muster_len-1]==0xFC)
			return -1;
	}
	ptr = TEXT(col);
	str = ptr+x;
	str2 = (*call)(str, str_len, muster_txt, such_len);
	if (str2==NULL) return -1;
	if (wort)
	{
		while (!(str2==ptr || !setin(wort_set,str2[-1])) ||
				 !(str2[*such_len]==EOS || !setin(wort_set,str2[*such_len])))
		{
			str2++;
			str_len -= (short)(str2 - str);
			str = str2;
			str2 = (*call)(str, str_len, muster_txt, such_len);
			if (str2==NULL) return -1;
		}
	}
	return (short)(str2 - ptr);
}

LOCAL WORD suche2(LINEP col, WORD x, WORD str_len, WORD *such_len,
						UBYTE*(*call)(UBYTE*,WORD,UBYTE*,WORD*))
/* rauf */
{
	WORD	x2, merk;

	merk = 0;
	while (TRUE)
	{
		x2 = suche1(col, x, str_len, such_len, call);
		if (x2==-1) break;
		x2++;									/* Weiter suchen */
		str_len -= x2-x;					/* Restlnge */
		merk = x = x2;
	}
	return merk-1;
}

LOCAL UBYTE *STRSTR(UBYTE *str_anf, WORD str_len, UBYTE *mstr_anf, WORD *found_len)
/* Suche ohne Quantoren */
{
	UBYTE	*mstr, *str;
	WORD	i, mstr_len = muster_len;

	*found_len = mstr_len;
	str_anf += mstr_len;
	str_len -= mstr_len;
	mstr_anf += mstr_len;
	while (str_len>=0)
	{
		str = str_anf;
		mstr = mstr_anf;
		i = mstr_len;
		while(TRUE)
		{
			if (*(--mstr)!=*(--str)) break;		/* Match fehlgeschlagen */
			if ((--i)<=0) return(str);		/* gefunden */
			if (*(--mstr)!=*(--str)) break;		/* Match fehlgeschlagen */
			if ((--i)<=0) return(str);		/* gefunden */
			if (*(--mstr)!=*(--str)) break;		/* Match fehlgeschlagen */
			if ((--i)<=0) return(str);		/* gefunden */
			if (*(--mstr)!=*(--str)) break;		/* Match fehlgeschlagen */
			if ((--i)<=0) return(str);		/* gefunden */
		}
		i = delta[str_anf[-1]];
		str_anf += i;										/* weiterrcken */
		str_len -= i;
	}
	return(NULL);
}

LOCAL UBYTE *STRSTR1(UBYTE *str_anf, WORD str_len, UBYTE *mstr_anf, WORD *found_len)
/* Suche ohne Quantoren (Gross/Klein) */
{
	UBYTE	*mstr, *str, s;
	WORD	i, mstr_len = muster_len;

	*found_len = mstr_len;
	str_anf += mstr_len;
	str_len -= mstr_len;
	mstr_anf += mstr_len;
	while (str_len>=0)
	{
		str = str_anf;
		mstr = mstr_anf;
		i = mstr_len;
		while (TRUE)
		{
			s = *(--str);
			if (s>='a' && s<='z') s-=32;
			else if (s=='') s = '';
			else if (s=='') s = '';
			else if (s=='') s = '';
			if (*(--mstr)!=s) break;					/* Match fehlgeschlagen */
			if ((--i)<=0) return (str);				/* gefunden */
		}
		s = str_anf[-1];
		if (s>='a' && s<='z') s-=32;
		else if (s=='') s = '';
		else if (s=='') s = '';
		else if (s=='') s = '';
		i = delta[s];
		str_anf += i;										/* weiterrcken */
		str_len -= i;
	}
	return(NULL);
}

LOCAL UBYTE *STRSTR2(UBYTE *str_anf, WORD str_len, UBYTE *mstr_anf, WORD *found_len)
/* Suche mit Quantoren (rekursiv) */
{
	UBYTE	*str, *mstr, m, s;
	WORD	len, anz;

	if (line_start)										/* Muster am Anfang finden */
		anz = 1;
	else
		anz = str_len+1;									/* Anzahl der Tests */
	while ((--anz)>=0)									/* auch len=0 kann Treffer sein */
	{
		mstr = mstr_anf;									/* Muster reset */
		str = str_anf;										/* String reset */
		len = str_len;
		while (TRUE)
		{
			m = *mstr++;									/* neue Zeichen holen */
			s = *str;
			if (m==EOS)										/* Muster komplett gefunden */
			{
				*found_len = (short)(str - str_anf);
				return str_anf;
			}
			if (len==0)
				s = EOS;

			if (m=='*')
			{
				BOOLEAN	save = line_start;

				line_start = FALSE;
				str = STRSTR2(str, len, mstr, found_len);
				line_start = save;
				if (str==NULL)
					return NULL;
				*found_len += (short)(str - str_anf);
				return str_anf;
			}
			if (!grkl)
			{
				if (s>='a' && s<='z') s-=32;
				else if (s=='') s = '';
				else if (s=='') s = '';
				else if (s=='') s = '';
			}
			if (m=='[')
			{
				m = *mstr++;								/* nach '[' folgt ein Infozeichen */
				if (m==0xFF)							/* echtes '[' */
				{
					if (s!='[') break;
				}
				else if (m==0xFE)								/* Wortende (letztes in Muster) */
				{
					if (len==0 || !setin(wort_set,s))
					{
						*found_len = (short)(str - str_anf);
						return str_anf;
					}
					break;
				}
				else if (m==0xFC)							/* Zeilenende */
				{
					if (len==0)
					{
						*found_len = (short)(str - str_anf);
						return str_anf;
					}
					break;
				}
				else											/* Wildcard */
				{
					if (!setin(group[m-1],s)) break;
				}
			}
			else 												/* normale Zeichen und '?' */
				if (m!=s && m!='?') break;

			if (len==0) break;
			str++; len--;									/* nchstes Zeichen */
		}
		str_anf++;											/* String ein Zeichen weiter */
		str_len--;
	}
	return NULL;
}

/* rein : start, text_x, text_len, text_y */
/* raus : start, text_x, text_len, text_y */
/* -1:Abbruch, 0:nichts gefunden 1:gefunden */

LOCAL WORD suchen2(TEXTP t_ptr, WORD *such_len)
{
	UBYTE*	(*call)	(UBYTE*,WORD,UBYTE*,WORD*);
	LONG	y;
	LINEP	lauf;
	WORD	step, x;

	x = text_x;
	y = text_y;
	lauf = start;
	if (muster_len==0) return 0;
	step = 70;
	if (quantor)
		call = STRSTR2;
	else if (grkl)
		call = STRSTR;
	else
		call = STRSTR1;
	if (runter)
	{
		while (TRUE)
		{
			if ((text_x=suche1(lauf,x,text_len,such_len,call))>=0)
			{
				text_y = y;
				start = lauf;
				return 1;
			}
			NEXT(lauf);	y++; x = 0;	text_len = lauf->len;
			if (IS_TAIL(lauf)) return 0;
			if (in_block)
			{
				if (y>t_ptr->z2) return 0;
				if (y==t_ptr->z2)
				{
					x = 0;
					text_len = t_ptr->x2;
				}
			}
			if ((--step)==0)
			{
				if (abbruch() && note(2,BREAK)==1) return -1;
				step = 70;
			}
		}
	}
	else
	{
		while (TRUE)
		{
			if ((text_x=suche2(lauf,x,text_len,such_len,call))>=0)
			{
				text_y = y;
				start = lauf;
				return 1;
			}
			VORG(lauf);
			if (IS_HEAD(lauf)) return 0;
			y--;
			x = 0;
			text_len = lauf->len;
			if (in_block)
			{
				if (y<t_ptr->z1) return 0;
				if (y==t_ptr->z1)
				{
					x = t_ptr->x1;
					text_len = lauf->len-x;
				}
			}
			if ((--step)==0)
			{
				if (abbruch() && note(2,BREAK)==1) return -1;
				step = 70;
			}
		}
	}
}

/* rein : start, text_x, text_len, text_y */
/* raus : start, text_x, text_len, text_y */
/* -1:Abbruch, 0:nichts gefunden 1:gefunden */

LOCAL WORD suchen(TEXTP t_ptr, WORD *such_len)
{
	WORD	erg;

	erg = suchen2(t_ptr, such_len);
	if (erg==0 && round)
	{
		WORD	m;

		beep();
		if (in_block)
		{
			if (runter)
				m = M_ANFBLOCK;
			else
				m = M_ENDBLOCK;
		}
		else
		{
			if (runter)
				m = M_TSTART;
			else
				m = M_TENDE;
		}
		init_suche(t_ptr,m);
		erg = suchen2(t_ptr, such_len);
	}
	return erg;
}

/* ====================================================================== */

VOID set_suchmode(UBYTE *Muster, BOOLEAN Grkl, BOOLEAN Quantor, BOOLEAN Runter, 
			BOOLEAN Wort, BOOLEAN Global, BOOLEAN Block, BOOLEAN Round)
{
	UBYTE	*ptr, *d, help[80];
	BOOLEAN	invers;

	strcpy(muster_txt, Muster);
	grkl = Grkl;
	quantor = Quantor;
	runter = Runter;
	wort = Wort;
	round = Round;
	setanz = 0;
	if (!grkl) xstrupr(muster_txt);
	if (quantor)
	{
		d = help;
		ptr = muster_txt;
		if (*ptr=='^')
		{
			line_start = TRUE;
			ptr++;
		}
		else
			line_start = FALSE;

		for (; *ptr; ptr++)
		{
			*d++ = *ptr;
			if (*ptr=='$' && ptr[1]==EOS)
			{
				d[-1] = '[';
				*d++ = 0xFC;
			}
			else if (*ptr=='[' && setanz<SETANZ)
			{
				UBYTE *merk = ptr;

				ptr++;
				invers = FALSE;
				if (*ptr=='^')
				{
					invers = TRUE;
					ptr++;
				}
				setclr(group[setanz]);
				while(*ptr && *ptr!=']')
				{
					if (ptr[0]=='-' && ptr[-1]!='[' && ptr[1]!=']')
					{
						UBYTE i;

						ptr++;
						for (i=ptr[-2]; i<*ptr; i++)
							setincl(group[setanz],i);
					}
					else
						setincl(group[setanz],*ptr++);
				}
				if (*ptr)							/* Keine ']' gefunden */
				{
					if (invers)
						setnot(group[setanz]);
					setanz++;
					*d++ = setanz;					/* immer einen grer (weil nie Null) */
				}
				else
				{
					*d++ = 0xFF;					/* Echtes '[' */
					ptr = merk;						/* Neu Scannen */
				}
			}
		}
		if (wort && d>help)						/* nur Worte und berhaupt ein Muster */
		{
			*d++ = '[';
			*d++ = 0xFE;							/* Wortende */
		}
		*d = EOS;
		strcpy(muster_txt,help);
		muster_len = (short) strlen(muster_txt);
	}
	else
	{
		WORD i,j;

		muster_len = (short) strlen(muster_txt);
		for (i=0; i<256; i++) delta[i] = muster_len;
		j = muster_len-1;
		for (i=0; i<j; i++) delta[muster_txt[i]] = j-i;
	}
	if (Global)
	{
		if (runter)
			modus = M_TSTART;
		else
			modus = M_TENDE;
	}
	else
	{
		if (Block)
		{
			if (runter)
				modus = M_ANFBLOCK;
			else
				modus = M_ENDBLOCK;
		}
		else
			modus = M_CURSOR;
	}
}

WORD start_find(TEXTP t_ptr, BOOLEAN quiet)
{
	WORD	len, erg;

	last_op = 1;
	Busy_mouse();
	init_suche(t_ptr, modus);			/* Suchzeiger an den Start bringen */
	erg = suchen(t_ptr,&len);
	Last_mouse();
	if (erg == 1 && !quiet)
	{
		if (!in_block) 
			blk_demark(t_ptr);
		else 
			t_ptr->cursor = TRUE;
		t_ptr->cursor_line = start;
		t_ptr->xpos = text_x;
		t_ptr->ypos = text_y;
		make_chg(t_ptr->link,POS_CHANGE,0);
		if (!in_block)
		{
			blk_mark(t_ptr,0);
			t_ptr->xpos = text_x+len;
			blk_mark(t_ptr,1);
		}
		restore_edit();
	}
	return erg;
}

WORD start_replace(TEXTP t_ptr, BOOLEAN special)
{
	WORD	delta, erg,
			such_len, rpl_len;
	LONG	anz;

	last_op = 2;
	Busy_mouse();
	rpl_len  = (short) strlen(r_str);
	anz = 0L;
	init_suche(t_ptr, modus);
	while((erg=suchen(t_ptr, &such_len))==1)
	{
		delta = rpl_len-such_len;
		if (start->len+delta>MAX_LINE_LEN)
		{
			note(1,TOOLONG);
			erg = -1;
			break;
		}
		text_len = start->len-text_x;
		t_ptr->cursor_line = start;
		t_ptr->xpos = text_x;
		t_ptr->ypos = text_y;
		if (r_modus!=RP_ALL)				/* Optional oder einzeln */
		{
			blk_demark(t_ptr);
			make_chg(t_ptr->link,POS_CHANGE,0);
			restore_edit();
			if (r_modus==RP_OPT)
			{
				WORD antw;

				blk_mark(t_ptr,0);
				t_ptr->xpos = text_x+such_len;
				blk_mark(t_ptr,1);
				restore_edit();
				antw = note(1, REPOPT);
				if (antw==2)					/* Nicht ersetzen */
				{
					if (runter)
					{
						text_x++;
						text_len--;
					}
					else
					{
						text_len = text_x+such_len-1;
						text_x = 0;
					}
					continue;
				}
				if (antw==3)
				{
					erg = -1;
					break;
				}
				blk_demark(t_ptr);
			}
		}
		anz ++;
		get_undo_col(t_ptr);
		COPYB(REALLOC(&start,text_x,delta),r_str,rpl_len);
		t_ptr->cursor_line = start;
		if (r_modus != RP_ALL)
		{
			make_chg(t_ptr->link,LINE_CHANGE,t_ptr->ypos);
			restore_edit();
			if (r_modus == RP_FIRST) break;
		}
		if (runter)
		{
			text_x += rpl_len;
			text_len += delta;
			text_len -= rpl_len;
		}
		else
		{
			text_len = text_x;
			text_x = 0;
		}
	}
	Last_mouse();
	if (anz > 0L)
	{
		t_ptr->moved++;
		make_chg(t_ptr->link,POS_CHANGE,0);			/* wg. `*'  */
		if (r_modus==RP_ALL)
		{
			if (t_ptr->block && !special)
			{
				t_ptr->p1 = get_line(&t_ptr->text,t_ptr->z1);
				t_ptr->p2 = get_line(&t_ptr->text,t_ptr->z2);
				blk_demark(t_ptr);
			}
			make_chg(t_ptr->link,TOTAL_CHANGE,0);
		}
		if (r_modus != RP_FIRST && !special)
			inote (1, REPMSG, anz);
		if (erg!=-1)
			erg = 1;
	}
	else
		if (erg!=-1) erg = 0;
	if (!special)
		restore_edit();
	return erg;
}

WORD do_next(TEXTP t_ptr)
{
	WORD	erg;
	BOOLEAN	runter;

	runter = (global_shift) ? (!s_runter) : s_runter;
	set_suchmode(s_str, s_grkl, s_quant, runter, s_wort, FALSE, FALSE, s_round);
	if (last_op == 1)
		erg = start_find(t_ptr,FALSE);
	else if (last_op == 2)
		erg = start_replace(t_ptr, FALSE);
	else
		erg = -1;
	return erg;
}

BOOLEAN match(const UBYTE *str, const UBYTE *m)
{
	UBYTE	*where, M[80];
	WORD	i;

	BOOLEAN	Quantor, Runter, Grkl, Wort, Modus, Round, Line_start;
	WORD	Muster_len;
	UBYTE	Muster[80];
	SET	Group[SETANZ];
	WORD	Setanz;
	WORD	Delta[256];
	
	Quantor = quantor;
	Runter = runter;
	Grkl = grkl;
	Wort = wort;
	Modus = modus;
	Round = round;
	Line_start = line_start;
	Muster_len = muster_len;
	COPYB(Muster, muster_txt,80);
	for (i=0; i<SETANZ; i++)
		setcpy(Group[i], group[i]);
	Setanz = setanz;
	COPYW(Delta, delta, 256 * (short)sizeof(WORD));

	M[0] = '^';							/* match mu vorne anfangen */
	strcpy(M+1,m);
	strcat(M,"$");						/* match mu hinten enden */
	set_suchmode(M, TRUE, TRUE, TRUE, FALSE, FALSE, FALSE, FALSE);
	where = STRSTR2((UBYTE*)str, (short) strlen(str), muster_txt, &i);
	quantor = Quantor;
	runter = Runter;
	grkl = Grkl;
	wort = Wort;
	modus = Modus;
	round = Round;
	line_start = Line_start;
	muster_len = Muster_len;
	COPYB(muster_txt, Muster,80);
	for (i=0; i<SETANZ; i++)
		setcpy(group[i], Group[i]);
	setanz = Setanz;
	COPYW(delta, Delta, 256 * (short) sizeof(WORD));
	return (where==str);
}

/*****************************************************************************/

typedef enum {auml, Auml, ouml, Ouml, uuml, Uuml, eszet} UmlautName;

LOCAL	UBYTE	Umlaute[4][7] =
				{ /*                                  */
				  { 0x84, 0x8E, 0x94, 0x99, 0x81, 0x9A, 0x9E},	/* Atari */
				  { 0xE4, 0xC4, 0xF6, 0xD6, 0xFC, 0xDC, 0xDF},	/* Latin */
				  { 0x8A, 0x80, 0x9A, 0x85, 0x9F, 0x86, 0xA7},	/* Mac */
				  { 0x84, 0x8E, 0x94, 0x99, 0x81, 0x9A, 0xE1},	/* PC */
				};
				
VOID	change_umlaute(TEXTP t_ptr)
{
	UmlautName	n;
	UBYTE			such_str[80],
					repl_str[80];
	WORD			repl_mode;
	BOOLEAN		block;
			
	/* Such- und Ersetzparameter sichern */
	strcpy(such_str, s_str);
	strcpy(repl_str, r_str);
	repl_mode = r_modus;
	desire_x = t_ptr->xpos;
	desire_y = t_ptr->ypos;
		
	/* Ersetzen ohne Nachfrage */
	r_modus = RP_ALL;
	
	block = t_ptr->block;	
	s_str[1] = EOS;
	r_str[1] = EOS;
	for (n = auml; n <= eszet; n++)
	{
		s_str[0] = Umlaute[umlaut_from][n];
		r_str[0] = Umlaute[umlaut_to][n];
		set_suchmode(s_str, TRUE, FALSE, TRUE, FALSE, !block, block, FALSE);
		start_replace(t_ptr, TRUE);
	}
	
	Icon_edit(t_ptr->link, DO_GOTO);

	strcpy(s_str, such_str);
	strcpy(r_str, repl_str);
	r_modus = repl_mode;
}

/* die Dialoge *************************************************************/

/*
 * Die folgenden Tastenroutine wird bei den MyDials fr die 'Find'-Dialoge
 * eingeklickt, damit bei ^V im Editfeld jenes erst einmal gelscht wird!!
 */
LOCAL WORD myKeys(OBJECT *tree, WORD edit_obj, WORD next_obj, WORD kr, WORD ks, WORD *onext_obj, UWORD *okr)
{
	UWORD	nkc_key, ascii;
	WORD	cpos;
	
	nkc_key = normkey(ks, kr);
	ascii = nkc_key & 0x00FF;
	if ( ((nkc_key & (NKF_FUNC|NKF_CTRL)) == (NKF_FUNC|NKF_CTRL) ) && 
		( ascii == 'V' ) )
	{
		cpos = 0;
		set_ptext(tree, edit_obj, "");
		dial_setcpos(tree, edit_obj, &cpos);
		draw_Objc(tree, edit_obj, 1);
	}
	return NIL;			/* MyDials sollen nun ^V auswerten! */
}


#define	HIST_LEN		44

LOCAL BOOLEAN build_popup(POPUP *pop)
{
	UBYTE	str[HIST_LEN + 1];
	WORD	i, len;
	
	if (s_history[0][0] == EOS)
		return FALSE;
	
	strcpy(str, s_history[0]);
	len = (short) strlen(str);
	len = min(HIST_LEN, len);
	if (len < HIST_LEN)
		for (i=len; i<HIST_LEN; i++)
			strcat(str, " ");
	
	create_popup(pop, HIST_ANZ, str, (short)strlen(str));
	for (i = 1; i < HIST_ANZ; i++)
	{
		if (s_history[i][0] != EOS)
		{
			len = (short) strlen(s_history[i]);
			len = min(HIST_LEN, len);
			strncpy(str, s_history[i], len);
			str[len] = EOS;
			append_popup(pop, str);
		}						
	}
	if (pop->tree == NULL)
		return FALSE;
		
	dial_fix(pop->tree, FALSE);
	return TRUE;
}

LOCAL VOID hist_popup(OBJECT* tree, WORD obj)
{
	WORD	pos_x, pos_y, y;
	POPUP	pop;
	
	if (build_popup(&pop))
	{
		objc_offset(tree, obj, &pos_x, &pos_y);
		y = popup_menu(pop.tree, 1, pos_x, pos_y, NIL , FALSE, 1 ,NULL);
		y -= pop.first_item;
		if (y >= 0)
		{
			set_ptext(tree, obj, s_history[y]);
			draw_Objc(tree, obj, 1);
		}
		free_popup(&pop);
	}
}


/* Suchen in Projekten */
BOOLEAN prjfind_dial (VOID)
{
	WORD		antw;
	DIALINFO	dial;
	BOOLEAN	quit = FALSE;
		
	do_icon(iclipbrd, DO_UPDATE);		/* damit man im Dialog den aktuellen Block hat! */

	hide_objc(fhilfe, FHOK, FALSE);	
	do_flags(fhilfe, FHOK, DEFAULT);
	hide_objc(fhilfe, FHNEXT,TRUE);		
	undo_flags(fhilfe, FHNEXT, DEFAULT);
	hide_objc(fhilfe, FHRAUS, TRUE);

	set_ptext(find, FTEXT, s_str);
	set_state(find, FGRKL, s_grkl);
	set_state(find, FWILD, s_quant);
	set_state(find, FWORT, s_wort);
	set_state(find, FRUNTER, s_runter);
	set_state(find, FRAUF, !s_runter);
	
	Arrow_mouse();
	open_dial(find, FALSE, NULL, &dial);
	set_Keybd(myKeys);
	dial_draw(&dial);
	do
	{
		antw = dial_do(&dial, FTEXT) & 0x7FFF;
		switch (antw)
		{
			case FHIST :
				hist_popup(find, FTEXT);
				break;
			case FHELP :
				HndlDial(fhilfe, 0, FALSE, NULL, NULL);
				break;
			default:
				quit = TRUE;
				break;
		}
		undo_state(find, antw, SELECTED);
		draw_Objc(find, antw, 1);
	}
	while (!quit);
	dial_end(&dial);
	Last_mouse();
	if (antw == FOK)
	{
		get_ptext(find, FTEXT, s_str);
		s_grkl	= get_state(find, FGRKL);
		s_quant	= get_state(find, FWILD);
		s_wort	= get_state(find, FWORT);
		s_runter = get_state(find, FRUNTER);
		if (s_str[0]!=EOS && strcmp(s_history[0],s_str)!=0)
		{
			MOVE((UBYTE*)(s_history+1), (UBYTE*)s_history, (HIST_ANZ-1) * (short) sizeof(s_history[0]));
			strcpy(s_history[0],s_str);
		}
		set_suchmode(s_str, s_grkl, s_quant, s_runter, s_wort, TRUE, FALSE, FALSE);
		return TRUE;
	}
	return FALSE;
}


/* Suchen/Ersetzen in Texten */
/* 0: Abbruch 1: Suchen 2: Ersetzen */
WORD textfind_dial(BOOLEAN block)
{
	WORD		antw, d;
	BOOLEAN	quit = FALSE;
	DIALINFO	dial;
	
	do_icon(iclipbrd, DO_UPDATE);

	hide_objc(fhilfe, FHOK, TRUE);		
	undo_flags(fhilfe, FHOK, DEFAULT);
	hide_objc(fhilfe, FHNEXT, FALSE);		
	do_flags(fhilfe, FHNEXT, DEFAULT);
	hide_objc(fhilfe, FHRAUS, FALSE);
	
	set_ptext(replace, RPTEXT1, s_str);
	set_ptext(replace, RPTEXT2, r_str);
	set_state(replace, RPGRKL, s_grkl);
	set_state(replace, RPWILD, s_quant);
	set_state(replace, RPWORT, s_wort);
	set_state(replace, RPRUNTER, s_runter);
	set_state(replace, RPRAUF, !s_runter);
	set_state(replace, RPGLOBAL, s_global);
	hide_objc(replace, RPBLOCK, !block); 
	set_state(replace, RPBLOCK, block);
	hide_objc(replace, RPCURSOR, block); 
	set_state(replace, RPCURSOR, !block);
	set_state(replace, RPROUND, s_round);
	set_state(replace, (block)?RPBLOCK:RPCURSOR, !s_global);
	set_state(replace, RPFIRST, r_modus==RP_FIRST);
	set_state(replace, RPALL, r_modus==RP_ALL);
	set_state(replace, RPOPTION, r_modus==RP_OPT);

	Arrow_mouse();
	open_dial(replace, FALSE, NULL, &dial);
	set_Keybd(myKeys);
	dial_draw(&dial);
	do
	{
		antw = dial_do(&dial, RPTEXT1) & 0x7FFF;
		switch (antw)
		{
			case RPHIST :
				hist_popup(replace, RPTEXT1);
				break;
			case RPHELP :
				d = HndlDial(fhilfe, 0, FALSE, NULL, NULL);
				if (d == FHNEXT)
					HndlDial(rphilfe, 0, FALSE, NULL, NULL);
				break;
			default:
				quit = TRUE;
				break;
		}
		undo_state(replace, antw, SELECTED);
		draw_Objc(replace, antw, 1);
	}
	while (!quit);
	dial_end(&dial);
	Last_mouse();
	if (antw == RPOK || antw == RPERSATZ)
	{
		get_ptext(replace, RPTEXT1, s_str);
		get_ptext(replace, RPTEXT2, r_str);
		s_grkl	= get_state(replace,RPGRKL);
		s_quant	= get_state(replace,RPWILD);
		s_wort	= get_state(replace,RPWORT);
		s_runter = get_state(replace,RPRUNTER);
		s_global = get_state(replace,RPGLOBAL);
		s_round  = get_state(replace,RPROUND);
		if (get_state(replace,RPFIRST))
			r_modus = RP_FIRST;
		else if (get_state(replace,RPALL))
			r_modus = RP_ALL;
		else
			r_modus = RP_OPT;
		if (s_str[0]!=EOS && strcmp(s_history[0],s_str)!=0)
		{
			MOVE((UBYTE*)(s_history+1), (UBYTE*)s_history, (HIST_ANZ-1) * (short) sizeof(s_history[0]));
			strcpy(s_history[0],s_str);
		}
		set_suchmode(s_str, s_grkl, s_quant, s_runter, s_wort, s_global, block, s_round);
		return((antw == RPOK) ? 1 : 2);
	}
	return(0);
}


/* Suchen auf Disk */
BOOLEAN diskfind_dial (UBYTE *df_path, UBYTE *df_name)
{
	PATH		name, short_str;
	UBYTE		*p;
	WORD		antw;
	FSEL		fsel;
	BOOLEAN 	quit = FALSE;
	DIALINFO	dial;
		
	do_icon(iclipbrd, DO_UPDATE);
	if (df_path[0]!=EOS)
	{
		make_shortpath(df_path,short_str,20);
		fill_ptext(diskfind,DFPATH,short_str);
	}
	else
		fill_ptext(diskfind,DFPATH,"");
	strcpy(name,df_path);
	set_ptext(diskfind,DFFILE,df_name);
	set_ptext(diskfind,DFSTR,"");
	set_state(diskfind,DFREK,df_rekursiv);
	set_state(diskfind,DFGRKL,s_grkl);
	set_state(diskfind,DFWILD,s_quant);
	set_state(diskfind,DFWORT,s_wort);
	set_state(diskfind,DFRAUF,!s_runter);
	set_state(diskfind,DFRUNTER,s_runter);

	Arrow_mouse();
	open_dial(diskfind, FALSE, NULL, &dial);
	set_Keybd(myKeys);
	dial_draw(&dial);
	do
	{
		antw = dial_do(&dial, DFFILE) & 0x7FFF;
		switch (antw)
		{
			case DFHIST:
				hist_popup(diskfind, DFSTR);
				break;
			case DFFSBOX:
				strcpy(fsel.suffix,"*.*");
				strcpy(fsel.name,"");
				select_file(&fsel, name, strings(SELPATHSTR));
				if (name[0]!=EOS)
				{
					p = strrchr (name, '\\');
					p[1] = EOS;
					make_shortpath(name, short_str, 20);
					fill_ptext(diskfind, DFPATH, short_str);
				}
				dial_draw(&dial);
				break;
			case DFHELP :
				HndlDial(dfhilfe, 0, FALSE, NULL, NULL);
				break;
			default:
				quit = TRUE;
				break;
		}
		undo_state(diskfind, antw, SELECTED);
		draw_Objc(diskfind, antw, 1);
	}
	while (!quit);
	dial_end(&dial);
	Last_mouse();
	if (antw == DFOK)
	{
		get_ptext(diskfind,DFSTR,s_str);
		get_ptext(diskfind,DFFILE,df_name);
		df_rekursiv = get_state(diskfind,DFREK);
		s_runter	= get_state(diskfind,DFRUNTER);
		s_grkl	= get_state(diskfind,DFGRKL);
		s_quant	= get_state(diskfind,DFWILD);
		s_wort	= get_state(diskfind,DFWORT);
		strcpy(df_path,name);
		if (s_str[0]!=EOS && strcmp(s_history[0],s_str)!=0)
		{
			MOVE((UBYTE*)(s_history+1), (UBYTE*)s_history, (HIST_ANZ-1) * (short)sizeof(s_history[0]));
			strcpy(s_history[0],s_str);
		}
		set_suchmode(s_str, s_grkl, s_quant, s_runter, s_wort, TRUE, FALSE, FALSE);
		return (TRUE);
	}
	return(FALSE);
}


BOOLEAN umlaut_dial(VOID)
{
	WORD				antw;
	UmlautEncoding f, t;
	BOOLEAN			ret;
	
	for (f = Atari; f <= PC; f++)
	{
		if (global_shift)
		{
			set_state(umlautkonv, UKVST + f, (umlaut_to == f)); 
			set_state(umlautkonv, UKNST + f, (umlaut_from == f)); 
		}
		else
		{
			set_state(umlautkonv, UKVST + f, (umlaut_from == f)); 
			set_state(umlautkonv, UKNST + f, (umlaut_to == f)); 
		}
	}

	Arrow_mouse();
	antw = HndlDial(umlautkonv, 0, FALSE, NULL, NULL);
	if (antw == UKSTART)
	{
		if (get_state(umlautkonv, UKVST))
			f = Atari;
		if (get_state(umlautkonv, UKVLATIN))
			f = Latin;
		if (get_state(umlautkonv, UKVMAC))
			f = Mac;
		if (get_state(umlautkonv, UKVPC))
			f = PC;

		if (get_state(umlautkonv, UKNST))
			t = Atari;
		if (get_state(umlautkonv, UKNLATIN))
			t = Latin;
		if (get_state(umlautkonv, UKNMAC))
			t = Mac;
		if (get_state(umlautkonv, UKNPC))
			t = PC;
		
		if (f != t)
		{
			umlaut_from = f;
			umlaut_to = t;
			ret = TRUE;
		}
		else
		{
			note(1, NOKONV);
			ret = FALSE;
		}
	}
	else
		ret = FALSE;
	Last_mouse();
	return ret;
}
