#include <aes.h>
#include <vdi.h>
#include <string.h>
#include <stdlib.h>

#include "global.h"
#include "obj.h"
#include "qed.h"
#include "rsc.h"
#include "windows.h"
#include "xfsl.h"
#include "xufsl.h"
#include "fontsel.h"

/*
 * exportierte Variablen
 */
FONTINFO	winFont;		
FONTINFO	druckFont;

/*
 * Funktionen
 */

LOCAL WORD set_fsize(WORD vdi_handle, WORD f_id, WORD f_size)
{
	UBYTE	size[32];
	WORD	ret;

	vst_font(vdi_handle, f_id);
	f_size = vst_point (vdi_handle, f_size, &ret,&ret,&ret,&ret);
	itoa (f_size, size, 10);
	fill_ptext (fontsel, FGROESSE, size);
	return f_size;
}


LOCAL WORD next_fsize(WORD vdi_handle, WORD f_size)
{
	WORD s, s_neu, s_old, ret;

	s = 1000;
	s_old = s_neu = vst_point (vdi_handle, s, &ret,&ret,&ret,&ret);
	while (s_neu>f_size)
	{
		s = min(s_neu-1,s-1);
		s_old = s_neu;
		s_neu = vst_point (vdi_handle, s, &ret,&ret,&ret,&ret);
	}
	return s_old;
}


LOCAL WORD prev_fsize(WORD vdi_handle, WORD f_size)
{
	WORD s, s_neu, ret;

	s = f_size;
	s_neu = vst_point (vdi_handle, s, &ret,&ret,&ret,&ret);
	while (s_neu>=f_size)
	{
		s = min(s_neu-1,s-1);
		if (s<=0) return f_size;
		s_neu = vst_point (vdi_handle, s, &ret,&ret,&ret,&ret);
	}
	return s_neu;
}


BOOLEAN	select_font(WORD vdi_handle, WORD dev, BOOLEAN use_ufsl)
{
	FONTINFO	*font;
	BOOLEAN	show_font;
	WORD		antw, f_id, f_size, f_nr;
	UBYTE		name[34];
	DIALINFO	dial;
		
	Arrow_mouse();
	if (dev != WINFONT)				/* Demotext zeigen? */
	{
		show_font = FALSE;
		font = &druckFont;
	}
	else
	{
		show_font = TRUE;
		font = &winFont;
	}
	
	f_id = font->ID;
	f_size = font->Size;

	if (use_ufsl)
	{
		LONG	v;
		WORD	ret, d;
				
		if (getcookie('xFSL', &v))
		{
			xFSL	*xfsl;

			xfsl = (xFSL *)v;
			ret = xfsl->fsl_input(vdi_handle, (FF_ALL), strings(SELFONTSTR), &f_id, &f_size);
			if (ret == 1)
			{
				font->ID = f_id;
				font->Size = f_size;
				for (d = 1; d <= 100; d++)
				if (font->ID == vqt_name(vdi_handle, d, font->Name))
				{
					font->Index = d;
					break;
				}
				return TRUE;
			}
			return FALSE;
		}
		else if (getcookie('UFSL', &v))
		{
			xUFSL_struct	*ufsl;
			ULONG				flags=0xFFFF;
			WORD				attr = 0, color = 1, skew = 0;
			FW_INFO			width={0,0,0};

			ufsl = (xUFSL_struct *)v;
			flags = UFS_SIZE_CHANGE|
					  UFS_GDOS_FONTS|
					  UFS_PROP_FONTS;/*|
					  UFS_WIND_DIALOG;*/

			if (ufsl->id == xUFS_ID) 
			{
				if ((ufsl->version <= 0x103))
				{
					ret = ufsl->font_selexinput(vdi_handle, flags, strings(SELFONTSTR),
												      "info", 1, 1, &f_id, &f_size, 
														&width, &attr, &color, &skew);
				}
				else
				{
					ret = ufsl->font_selexinput(vdi_handle, flags, strings(SELFONTSTR), 
														 "info", 1, 1, &f_id, &f_size, 
														 &width, &attr, &color, &skew);
				}
			}
			else 
			{
            ufsl->dialtyp = UFS_DIALOG;/*WINDOW;*/
            ret = ufsl->fontsel_input(vdi_handle, font->Anz, (flags & UFS_PROP_FONTS) != 0,
                                      "info", &f_id, &f_size);
			}
			if (ret == UFS_OK)
			{
				font->ID = f_id;
				font->Size = f_size;
				for (d = 1; d <= 100; d++)
				if (font->ID == vqt_name(vdi_handle, d, font->Name))
				{
					font->Index = d;
					break;
				}
				return TRUE;
			}
			return FALSE;
		}
		else
		{
			if (note(1, NOUFSL) == 2)
				return FALSE;
		}
	}
	
	/* interner Fontselector */

	f_nr = font->Index;
	strcpy(name, font->Name);
	fill_ptext (fontsel, FNAME, name);
	set_fsize(vdi_handle, f_id, f_size);
	hide_objc(fontsel, FTEST, !show_font);
	open_dial(fontsel, FALSE, NULL, &dial);
	dial_draw(&dial);
	do
	{
		if (show_font)
		{
			RECT	s;

			objc_rect (fontsel, FTEST, &s, FALSE);		/* Box kann verschoben worden sein */
			Hide_mouse();
			set_clip(TRUE, &s);
			clr_area(&s);
			v_gtext(vdi_handle, s.x, s.y, "Test");
			Show_mouse();
		}
		antw = dial_do(&dial, 0) & 0x7FFF;
		if (antw == FLEFT)
		{
			WORD	i, f_nr_bak;

			f_nr_bak = f_nr;
			while (f_nr > 1)
			{
				f_nr--;
				i = vqt_name(vdi_handle, f_nr, name);
				if (i >= 0)
					break;
			}
			if (i >= 0)
			{
				f_id = i;
				name[32] = EOS;
				fill_ptext (fontsel, FNAME, name);
				draw_Objc(fontsel, FNAME, 1);
				f_size = set_fsize(vdi_handle,f_id,f_size);
				draw_Objc(fontsel, FGROESSE, 1);
			}
			else
				f_nr = f_nr_bak;
		}
		else if (antw == FRIGHT)
		{
			WORD	i, f_nr_bak;

			f_nr_bak = f_nr;
			while (f_nr <= font->Anz)
			{
				f_nr++;
				i = vqt_name(vdi_handle, f_nr, name);
				if (i >= 0)
					break;
			}
			if (i >= 0)
			{
				f_id = i;
				name[32] = EOS;
				fill_ptext (fontsel, FNAME, name);
				draw_Objc(fontsel, FNAME, 1);
				f_size = set_fsize(vdi_handle,f_id,f_size);
				draw_Objc(fontsel, FGROESSE, 1);
			}
			else
				f_nr = f_nr_bak;
		}
		else if (antw == GLEFT)
		{
			f_size = prev_fsize(vdi_handle,f_size);
			f_size = set_fsize(vdi_handle,f_id,f_size);
			draw_Objc(fontsel, FGROESSE, 1);
		}
		else if (antw == GRIGHT)
		{
			f_size = next_fsize(vdi_handle,f_size);
			f_size = set_fsize(vdi_handle,f_id,f_size);
			draw_Objc(fontsel, FGROESSE, 1);
		}
		undo_state(fontsel, antw, SELECTED);
		draw_Objc(fontsel, antw, 1);
	}
	while (antw != FOOK && antw != FORAUS);
	dial_end(&dial);
	if (antw == FOOK)
	{
		WORD	w1, w2, pxy[8];
		
		vqt_extent(vdi_handle, "LLLL", pxy);
		w1 = pxy[2] - pxy[0];
		vqt_extent(vdi_handle, "llll", pxy);
		w2 = pxy[2] - pxy[0];

		font->ID = f_id;
		font->Index = f_nr;
		font->Size = f_size;
		strcpy(font->Name, name);
		font->prop = (w1 != w2);
	}
	else		/* alte Werte wieder setzen */
	{
		WORD	ret;
	
		vst_font(vdi_handle, font->ID);
		vst_point(vdi_handle, font->Size, &ret,&ret,&ret,&ret);
	}
	Last_mouse();
	return (antw == FOOK);
}
