#include <aes.h>
#include <vdi.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "global.h"
#include "gdos.h"

/*
 * Exportierte Variablen
 */
DevInfoS		GdosDevices[10];
WORD			devAnzahl;
WORD			druckDevice;
BOOLEAN		gdos;

/* globale Variabeln */


short MicromToDPI( short microm)
{
	switch (microm) 
	{
		case 35:
			return 720;
		case 42:
			return 600;
		case 71:
			return 360;
		case 85:
			return 300;
		case 117:
		case 118:
			return 216;
		case 130:
			return 196;
		case 141:
			return 180;
		case 175:
		case 176:
			return 144;
		case 211:
		case 212:
			return 120;
		default:
			return 25400 / microm;
	}
} /* MicromToDPI */


BOOLEAN	DeviceInfo(WORD devID, DevInfoS *devInfo)
{
	WORD	workin[] = { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2};
	WORD	workout[57];
	WORD	wkHandle;
	WORD	devExist;
	WORD	i, id;
	UBYTE	name[80];

	if (!vq_gdos()) 
    		return FALSE;
 
	workin[0] = devID;
	wkHandle = -1;
	v_opnwk( workin, &wkHandle, workout);
	if (wkHandle <= 0) 
		return FALSE;
    
	devInfo->devID   = devID;
	devInfo->FntAnz  = workout[10] + vst_load_fonts(wkHandle, 0);

	if (devInfo->FntAnz <= 0)	/* Treiber nur gltig, wenn es auch Fonts gibt!! */
	{
		vst_unload_fonts(wkHandle, 0);
		v_clswk( wkHandle);
		return FALSE;
	}

	for (i=1; i<100; i++)
	{
		id = vqt_name(wkHandle, i, devInfo->firstName);
		if (id >= 0) 
			break;
	}
	if (id < 0)
		return FALSE;
		
	devInfo->firstSize = vst_point(wkHandle,10,&i,&i,&i,&i);
	devInfo->firstID	= id;
	
	_VDIParBlk.contrl[2] = 0;
	vqt_devinfo( wkHandle, devID, &devExist, name);

	if (_VDIParBlk.contrl[2] == 0) 
	{	/*** Funktion ist nicht implementiert, generiere Namen ***/
		if ((devID >= 21) && (devID < 31)) 
		{
	        	sprintf(name, "GDOS PRINTER %d", devID);
	    	}
		else if ((devID >= 31) && (devID < 41)) 
		{
	        	sprintf(name, "GDOS METAFILE %d", devID);
	    	}
		else 
		{
	        	sprintf(name, "GDOS DEVICE %d", devID);
		}
	}
	else 
		if (_VDIParBlk.contrl[2] == 1) 
		{
			/*** Nur Dateiname des Geraetetreibers vorhanden ***/
			i = _VDIParBlk.contrl[4];
			if (i > 11) 
				i = 11;
			name[i] = 0;
		}
		else /* if (_VDIParBlk.contrl[2] == 14) */ 
		{
			WORD	p = 0;
			UBYTE	*s;
			
			/*** Treiberbezeichnung ***/
			s = (UBYTE *)&_VDIParBlk.ptsout[1];
			for (i = 0; (i < 40) && (*s); i++) 
				name[p++] = *s++;
			name[p] = EOS;
		}

	vst_unload_fonts(wkHandle, 0);
	v_clswk( wkHandle);

	strcpy(devInfo->devName, " ");	/* fr das Popup! */
	if (strlen(name) > DEV_LEN - 1)	/* -1 wegen des " "!! */
		strncat(devInfo->devName, name, DEV_LEN - 1);
	else
		strcat(devInfo->devName, name);
	return( TRUE);
} /* DeviceInfo */


VOID	scanDevices(VOID)
{
	WORD	i;
	
	if (devAnzahl != 0)	/* nur einmal scannen! */
		return;
	devAnzahl = 0;
	for (i=21; i < 100; i++)
	{
		if (DeviceInfo(i, &GdosDevices[devAnzahl]))
			devAnzahl++;
	}
	if (file_exist("gemfile.gem"))	/* Metafile-Treiber legt eine leere Datei an */
		Fdelete("gemfile.gem");			/* die wir nun wieder lschen. */
}
