/***************************************************************************/
/* 																								*/
/* Modul: GLOBAL.C																			*/
/* 																								*/
/***************************************************************************/

#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <nkcc.h>

#include "global.h"
#include "fontsel.h"
#include "fsel.h"
#include "gdos.h"
#include "obj.h"
#include "qed.h"
#include "rsc.h"
#include "scroll.h"
#include "set.h"

/*
 * exportierte Variablen
 */
WORD	phys_handle;		/* Physikalisches Workstation Handle */
WORD	gl_apid;				/* Identifikation fr Applikation */
WORD	gl_wchar;			/* Je nach aktuellem Font z.B. 8*16 */
WORD	gl_hchar;
WORD	sys_font_size;		/* 10 */
WORD	sys_font_id;		/* */
WORD	sys_wchar;			/* 8*16 */
WORD	sys_hchar;
WORD	sys_wbox;			/* 19*19 */
WORD	sys_hbox;
WORD	min_ascii;
WORD	max_ascii;

BOOLEAN 	multi;				/* Mehrere Applikation mglich */
WORD		colors;				/* Anzahl der Farben */
WORD		fill_color;			/* aktuell eingestellte Fllfarbe */
WORD		planes;				/* Anzahl der Planes */
WORD		speed;				/* Anzahl Rasterops pro sec */
WORD		gem;					/* GEM-Version */
BOOLEAN	mint;					/* MiNT aktiv? */
BOOLEAN	mtos;					/* MultiTOS aktiv? */
BOOLEAN	magx;					/* Mag!X aktiv? */
BOOLEAN	magx3;

BOOLEAN	global_shift;		/* bei aktueller Opertion wurde Shift gedrckt */
BOOLEAN	menu_ctrl;			/* bei Menauswahl Ctrl gedrckt -> ST-GUIDE */
BOOLEAN	quick_close;		/* Sichern der Texte ohne Nachfrage */
WORD		vdi_handle;			/* Virtuelles Workstation Handle */
BOOLEAN 	no_desktop;			/* Kein Desktop */
BOOLEAN	wish_no_desktop;	/* fr save_option */
BOOLEAN	wind_cycle;			/* Fensterwechsel ber VA-Protokoll */

RECT		desk;					/* Bildschirm-Gre  0,19,640,381 */

BOOLEAN	done;					/* Ende gewhlt ? */
PATH		qed_path;			/* Name und Pfad der QED-Datei */
PATH		scrapdir;			/* Clipboard-Pfad */

struct tm	*local_time;	/* enthlt die aktuelle Uhrzeit */

LOCAL_OPT	loc_opt[MUSTER_ANZ];
WORD			desire_x, seiten_len, seiten_width, rand_len,
				prn_mode, r_modus, cu_mode, cu_width2,
				cu_high2, ev_time, transfer_size, return_code,
				loc_opt_anz, return_code;
BOOLEAN			zeilen_nr, seiten_nr, 
				s_grkl, s_quant, s_wort, s_runter, s_global, s_round,
				df_rekursiv, epson, vorschub, pruef_prn,
				save_opt, backup,
				cu_icon, cu_window, cu_width, cu_high,
				overwrite, gdos_print, gdos_device,
				blinking_cursor, extern_fontselect;
LONG			desire_y, undo_y;
UBYTE			r_str[80], s_str[80], s_history[HIST_ANZ][80],
				muster_str[MUSTER_ANZ][MUSTER_LEN+1],
				df_name[MUSTER_LEN+1];
PATH			helpprog;

/****** DEFINES **************************************************************/

#define CTRL_CHAR 	'^'		/* Men-Control-Buchstabe */
#define ALT_CHAR		0x07		/* Men-Alternate-Buchstabe */

#define MFILE_ANZ		10			/* Anzahl fr Selectric & Komp. */

/****** TYPES ****************************************************************/

/****** VARIABLES ************************************************************/

LOCAL WORD		hidden = 0;
LOCAL WORD		act_mousenumber	= 0;
LOCAL WORD		last_mousenumber = 0;
LOCAL BOOLEAN 	sleep = FALSE;

LOCAL RECT 		clip; 		/* Letztes Clipping Rechteck */
LOCAL BOOLEAN 	clip_flag;

LOCAL BOOLEAN 	ext_fsel;		/* erweitertes Fileselect-Box mglich */

LOCAL PATH 		fs_path; 		/* Pfad der Dateiauswahl-Box */
LOCAL FSEL 		default_fsel;	/* Suffix und Name in Box */

WORD	ping[] = {0x0034, 0x0100, 0x0200, 0x0300, 0x0400, 0x0500, 0x0600,
			       0x07FE, 0x0810, 0x0900, 0x0A00, 0x0B00, 0x0C10, 0x0D09,
					 0xFF00};

LOCAL	UBYTE		*slct_files[MFILE_ANZ];

/****** FUNCTIONS ************************************************************/

/*****************************************************************************/
/* ffne virtuelle Workstation																							 */
/*****************************************************************************/

int open_vwork (int *w_out)
{
	int i, handle;
	int work_in[11];

	for (i = 0; i < 11; i++)
		work_in[i] = 1;
	work_in[5]	= 0;
	work_in[9]	= WHITE; 					/* Fllfarbe */
	work_in[10] = RC; 						/* Raster Koordinaten */
	handle = phys_handle;
	v_opnvwk (work_in, &handle, w_out); /* ffne virtuelle Workstation */
	return (handle);
} /* open_vwork */


GLOBAL WORD appl_xgetinfo (WORD type, WORD *out1, WORD *out2, WORD *out3, WORD *out4)
{
	BOOLEAN	has_agi = FALSE;
	LONG		dummy;

	has_agi = ((_GemParBlk.global[0] == 0x399 && getcookie('MagX', &dummy)) ||
					(_GemParBlk.global[0] == 0x400 && type < 4) ||
					(_GemParBlk.global[0] > 0x400) ||
					(appl_find ("?AGI") >= 0));

	if (has_agi)
		return (appl_getinfo (type, out1, out2, out3, out4));
	else 
		return 0;
} /* appl_xgetinfo */

/*****************************************************************************/
/* Maus-Routinen																														 */
/*****************************************************************************/

VOID	beep(VOID)
{
	Dosound(ping);
}

VOID Set_mouse (WORD number)
{
	last_mousenumber	= act_mousenumber;
	act_mousenumber	= number;
	Wake_mouse();
	graf_mouse (number, NULL);
	sleep = FALSE;
}

WORD Get_mouse(VOID)
{
	return act_mousenumber;
}

BOOLEAN Mouse_sleeps(VOID)
{
	return sleep;
}

VOID Sleep_mouse (VOID)
{
	if (!sleep)
	{
		sleep = TRUE;
		if (hidden==0) graf_mouse (M_OFF, NULL);
	}
}

VOID Wake_mouse (VOID)
{
	if (sleep)
	{
		sleep = FALSE;
		if (hidden==0) graf_mouse (M_ON, NULL);
	}
}

VOID Last_mouse (VOID)
{
	Set_mouse (last_mousenumber);
}

VOID Hide_mouse ()
{
	if (hidden==0 && !sleep) graf_mouse (M_OFF, NULL);
	hidden++;
}

VOID Show_mouse ()
{
	if (--hidden==0 && !sleep) graf_mouse (M_ON, NULL);
}

VOID Busy_mouse ()
{
	Set_mouse (HOURGLASS);
}

VOID Arrow_mouse ()
{
	Set_mouse (ARROW);
}

/*****************************************************************************/

/* Ausgabe recht oben im Men */
VOID print_headline(UBYTE *str)
{
	WORD ret, len, width;

	set_clip(FALSE, NULL);
	vst_font (vdi_handle, sys_font_id);			/* Systemfont */
	vst_point (vdi_handle, sys_font_size, &ret, &ret, &width, &ret);
	len = (short) strlen(str);
	v_gtext(vdi_handle, desk.w-len * width, 0, str);
	vst_font (vdi_handle, winFont.ID);
	vst_point (vdi_handle, winFont.Size, &ret, &ret, &ret, &ret);
}

VOID font_change(VOID)
{
	WORD	i, ret, w1, w2, dummy2,dummy1[5],dummy3[3];

	vst_font(vdi_handle, winFont.ID);
	/* gl_wchar und gl_hchar werden NUR hier verndert */
	winFont.Size = vst_point (vdi_handle, winFont.Size, &i, &i, &gl_wchar, &gl_hchar);

	for (i = 1; i <= 100; i++)
		if (winFont.ID == vqt_name(vdi_handle, i, winFont.Name))
		{
			winFont.Index = i;
			break;
		}

	vqt_width(vdi_handle,'M',&w1,&ret,&ret);
	vqt_width(vdi_handle,'I',&w2,&ret,&ret);
	winFont.prop = (w1!=w2);

	vqt_fontinfo(vdi_handle,&min_ascii,&max_ascii,dummy1,&dummy2,dummy3);
	if (min_ascii <= 0) 
		min_ascii = 1;
}


/*****************************************************************************/
LOCAL LONG 	maxvalue;
LOCAL	DIALINFO	aktion_box;

VOID start_aktion(const UBYTE *head, BOOLEAN inter, LONG max_value)
{
	maxvalue = max(max_value, 1);
	fill_ptext(aktion, ATEXT, head);
	aktion[ABOX2].ob_width = 1;
	hide_objc(aktion, AESC, !inter);
	open_dial(aktion, TRUE, NULL, &aktion_box);
	dial_draw(&aktion_box);
}

VOID do_aktion (LONG value)
{
	LONG max_len, help;

	max_len = aktion[ABOX1].ob_width;
	help = max((max_len * value) / maxvalue,1);
	help = min(max_len, help);
	if (aktion[ABOX2].ob_width != help)
	{
		aktion[ABOX2].ob_width = (short) help;
		draw_Objc(aktion, ABOX2, 1);
	}
}

VOID end_aktion (VOID)
{
	dial_end(&aktion_box);
}

/*****************************************************************************/

UBYTE xupper(UBYTE c)
{
	if (c>='a' && c<='z') c -= 32;
	else if (c=='') c = '';
	else if (c=='') c = '';
	else if (c=='') c = '';
	return c;
}

VOID xstrupr(UBYTE *str)
{
	UBYTE	c;
	
	while (TRUE)
	{
		c = *str;
		if (c==EOS) break;
		if (c>='a' && c<='z') *str -= 32;
		else if (c=='') *str = '';
		else if (c=='') *str = '';
		else if (c=='') *str = '';
		str++;
	}
}

/*****************************************************************************/

BOOLEAN str_to_key(UBYTE *str, MKINFO *mk)
{
	UBYTE	c, sign, *s1, *s2;
	BOOLEAN	erg = FALSE;

	s1 = strrchr(str, CTRL_CHAR);
	s2 = strrchr(str, ALT_CHAR);
	if (s1 > s2)
		str = s1;
	else
		str = s2;

	if (str!=NULL && strlen(str)>=2) 		/* Sign und Buchstabe */
	{
		sign = *str++; 							/* "Vorzeichen" */
		c	  = *str;								/* Eigentliches Zeichen */
		switch (sign)
		{
		case CTRL_CHAR:
			mk->kstate = K_CTRL;
			mk->kreturn = NKF_FUNC|NKF_CTRL|c;
			mk->ascii_code = c;
			mk->scan_code = 0;
			mk->shift = FALSE;
			mk->ctrl = TRUE;
			mk->alt = FALSE;
			erg = TRUE;
			break;
		case ALT_CHAR:
			mk->kstate = K_ALT;
			mk->kreturn = NKF_FUNC|NKF_ALT|c;
			mk->ascii_code = c;
			mk->scan_code = 0;
			mk->shift = FALSE;
			mk->ctrl = TRUE;
			mk->alt = FALSE;
			erg = TRUE;
			break;
		}
	}
	return erg;
}

/*****************************************************************************/
/* Rechteck-Routinen 																											 */
/*****************************************************************************/

BOOLEAN rc_equal (const RECT *p1, const RECT *p2)
{
	return ((p1->x == p2->x) && (p1->y == p2->y) &&
			  (p1->w == p2->w) && (p1->h == p2->h));
} /* rc_equal */

/*****************************************************************************/

VOID rc_union (const RECT *p1, RECT *p2)
{
	RECT r;

	if ((p2->w==0) || (p2->h==0))
		*p2 = *p1;
	else
	{
		r.x = min (p1->x, p2->x);
		r.y = min (p1->y, p2->y);
		r.w = max (p1->x + p1->w, p2->x + p2->w) - r.x;
		r.h = max (p1->y + p1->h, p2->y + p2->h) - r.y;

		*p2 = r;
	}
} /* rc_union */

/*****************************************************************************/

BOOLEAN rc_in (const RECT *p1, const RECT *p2)
/* TRUE falls p1 vollstndig in p2 */
{
	return (p1->x>=p2->x && p1->y>=p2->y &&
			  p1->x+p1->w<=p2->x+p2->w && p1->y+p1->h<=p2->y+p2->h);
}

/*****************************************************************************/

BOOLEAN rc_intersect (const RECT *p1, RECT *p2)
{
	WORD tx, ty, tw, th;

	tw = min (p2->x + p2->w, p1->x + p1->w);
	th = min (p2->y + p2->h, p1->y + p1->h);
	tx = max (p2->x, p1->x);
	ty = max (p2->y, p1->y);

	p2->x = tx;
	p2->y = ty;
	p2->w = tw - tx;
	p2->h = th - ty;

	return ((tw > tx) && (th > ty));
} /* rc_intersect */

/*****************************************************************************/

BOOLEAN inside (WORD x, WORD y, const RECT *r)
{
	return (x>=r->x && y>=r->y && x<r->x+r->w && y<r->y+r->h);
} /* inside */

/*****************************************************************************/

VOID rect2array (const RECT *rect, WORD *array)
{
	LONG d;

	d = *((LONG*)rect)++;
	*((LONG*)array)++ = d;						/* Zuweisung x und y */
	d += (*((LONG*)rect));
	d -= ((1L<<16)+1);
	*((LONG*)array)	 = d; 					/* Zuweisung w und h */
} /* rect2array */

/*****************************************************************************/

VOID array2rect (const WORD *array, RECT *rect)
{
	rect->x = min (array[0], array[2]);
	rect->y = min (array[1], array[3]);
	rect->w = abs (array[0]-array[2]) + 1;
	rect->h = abs (array[1]-array[3]) + 1;
} /* array2rect */

/*****************************************************************************/

BOOLEAN get_clip (RECT *size)
{
	*size = clip;
	return clip_flag;
}

VOID set_clip (BOOLEAN clipflag, const RECT *size)
{
	WORD	xy[4];

	if (!clip_flag && !clipflag) return;	/* Es ist aus und bleibt aus */
	clip_flag = clipflag;
	if (clipflag)
	{
		if (size == NULL)
			clip = desk;							/* Nichts definiert, nimm Desktop */
		else
		{
			clip = *size;							/* Benutze definierte Gre */
			if (!rc_intersect (&desk, &clip))/* Nur auf Desktop zeichnen */
			{
				clip.x = 0; 						/* Nichts zeichnen */
				clip.y = 0;
				clip.w = 0;
				clip.h = 0;
			}
		}
		rect2array(&clip,xy);
	}
	else
		clip = desk;
	vs_clip (vdi_handle, clipflag, xy); 	/* Setze Rechteckausschnitt */
} /* set_clip */

/*****************************************************************************/

VOID growbox (const RECT *st, const RECT *fin)
{
	graf_growbox (st->x,st->y,st->w,st->h,fin->x,fin->y,fin->w,fin->h);
} /* growbox */

/*****************************************************************************/

VOID shrinkbox (const RECT *fin, const RECT *st)
{
	graf_shrinkbox (fin->x,fin->y,fin->w,fin->h,st->x,st->y,st->w,st->h);
}

/*****************************************************************************/

VOID movebox (const RECT *st, WORD d_x, WORD d_y)
{
	graf_movebox (st->w, st->h, st->x, st->y, st->x + d_x, st->y + d_y);
}

/*****************************************************************************/

WORD note (WORD button, WORD index)
{
	WORD ret;

	Arrow_mouse ();
	ret = do_alert(button, (BYTE *)alertmsg[index]);
	Last_mouse ();
	return (ret);
} /* note */

/*****************************************************************************/

WORD inote(WORD button, WORD index, LONG i)
{
	UBYTE str[20];

	ltoa(i,str,10);
	return snote(button,index,str);
}

/*****************************************************************************/

WORD snote (WORD button, WORD index, UBYTE *str)
{
	WORD	ret, len;
	UBYTE	s[200], *ptr;

	len = (short) strlen(str);
	strcpy(s, alertmsg[index]);
	ptr = strchr(s,'$');
	if (ptr!=NULL)
	{
		MOVE(ptr+len, ptr+1, (short) strlen(ptr));
		COPYB(ptr,str,len);
	}
	Arrow_mouse ();
	ret = do_alert (button, (BYTE *)s);
	Last_mouse ();
	return (ret);
} /* inote */

/***************************************************************************/
/* Verschiedenes																				*/
/***************************************************************************/

VOID make_shortpath(const UBYTE *path, UBYTE *shortpath, WORD maxlen)
{
	PATH	help;
	WORD	path_len;
	UBYTE	*p1, *p2;

	strcpy(help,path);
	path_len = (short) strlen(help);
	if (maxlen < 18)
	{
		file_name(path,help);
	}
	else if (path_len>maxlen)
	{
		p1 = strchr(help,'\\');
		p2 = p1;
		path_len += 2; 	/* zwei Punkte neu */
		while(*p2!=EOS && path_len>maxlen)
		{
			p2++;
			while(*p2!='\\' && *p2!=EOS)
			{
				p2++;
				path_len--;
			}
		}
		if (*p2!=EOS)
		{
			MOVE(p1+3, p2, (short)strlen(p2)+1);
			p1[1] = '.';
			p1[2] = '.';
		}
		else
		{
			p2 = strrchr(help,'\\');
			MOVE(help, p2, (short)strlen(p2)+1);
		}
	}
	strcpy(shortpath,help);
}

/* Macht aus allem einen kompletten Pfad			*/
/* evtl. vorhandene Dateinamen bleiben erhalten */
/* with_filename = hat ganz sicher Dateinamen	*/
BOOLEAN make_normalpath(UBYTE *path, BOOLEAN with_filename)
{
	WORD	i;
	PATH	p;
	UBYTE	*str, *f, drv;

	i = (short) strspn (path, "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_!@#$%^&()+-=~`;,<>|[]{}\\.:");
	path[i] = EOS;
	if (path[0]==EOS) return FALSE;
	/* Laufwerk bestimmen */
	str = strchr (path, ':');
	if (str==NULL) 				/* Kein Laufwerk */
	{
		drv = 'A'+Dgetdrv(); 		/* aktuelles Laufwerk */
		f = path;
	}
	else
	{
		drv = str[-1];
		f = str+1;
	}
	/* Pfad mit Laufwerk bestimmen */
	if (f[0]=='.' && (f[1]=='\\' || f[1]==EOS))
	{
		get_path(p, drv); 		/* aktuellen Pfad nehmen */
		if (f[1]=='\\') strcat(p,f+2);
	}
	else if (f[0]!='\\') 			/* Keine Root */
	{
		get_path(p, drv);
		strcat (p, f);
	}
	else
	{
		p[0] = drv;
		p[1] = ':';
		p[2] = EOS;
		strcat (p, f);
	}
	if (!with_filename)			/* herausbekommen ob Dateiname */
	{
		i = (short) strlen(p);
		if (p[i-1]!='\\')
		{
			p[i] = '\\';
			p[i+1] = EOS;
		}
		if (!path_exist(p))
			p[i] = EOS;
	}
	strcpy(path,p);
	return TRUE;
} /* make_normalpath */

VOID make_ext(UBYTE *fullname, const UBYTE *ext)
{
	UBYTE	*ptr = strrchr(fullname,'.');

	if (ptr==NULL || ptr < strrchr(fullname,'\\'))
	{
		ptr = fullname+strlen(fullname);
		*ptr = '.';
	}

	if (caseSens(fullname))
		strcpy(ptr+1, ext);
	else
	{	UBYTE	myext[5];
	
		strcpy(myext, ext);
		upper(myext);
		strcpy(ptr+1, myext);
	}
}

VOID file_name(const UBYTE *fullname, UBYTE *filename)
{
	file_splitt(fullname, NULL, filename);
}

VOID file_splitt(const UBYTE *fullname, UBYTE *path, UBYTE *name)
{
	UBYTE	 *str;

	str = strrchr (fullname, '\\');

	if (str != NULL)
	{
		/* Dateinamen holen */
		if (name != NULL)
			strcpy(name, str+1);

		/* Pfad mit Laufwerk bestimmen */
		if (path != NULL)
		{
			WORD len =  (short)( str - (UBYTE *)fullname + 1);
			strncpy(path, fullname, len);
			path[len] = EOS;
		}
	}
} /* file_split */

/*****************************************************************************/

WORD get_first_drive(VOID)
{
	unsigned LONG drives;
	WORD	drive;

	drives = Dsetdrv(Dgetdrv());			/* Alle Laufwerke */
	if (drives==0)
		drive = -1;
	else if (drives <= 3)
		drive = 0;								/* Benutze Laufwerk A */
	else
	{
		drives >>= 2;
		drive = 2;									/* Beginne bei Laufwerk C */
		while (!(drives & 1) && drive < 32)    /* Laufwerk gefunden */
		{
			drive++;
			drives >>= 1;
		}
	}
	return drive;
}

/*****************************************************************************/

VOID drive_name(WORD drive, UBYTE *name)
{
	UBYTE	n[10];
	DTA	dta, *old_dta;

	old_dta = Fgetdta();
	Fsetdta (&dta);
	strcpy(n,"A:\\*.*");
	n[0] += (drive-1);
	if (Fsfirst (n, FA_VOLUME)==0)
		strcpy(name, dta.d_fname);
	else
		name[0] = EOS;
	Fsetdta (old_dta);
}

/*****************************************************************************/

BOOLEAN get_path (UBYTE *path, UBYTE drive)
{
	WORD ret, drive_nr;

	if (drive==0)
		drive = 'A'+Dgetdrv();						/* Aktuelles Laufwerk */
	if (drive>='a' && drive<='z')
		drive_nr = drive-'a';
	else
		drive_nr = drive-'A';
	path[0] = drive; 
	path[1] = ':';
	ret = Dgetpath (path+2, drive_nr+1);
	strcat (path, "\\");
	return (ret==0);
} /* get_path */

/*****************************************************************************/

LOCAL VOID make_time(unsigned LONG ltime, UBYTE *date, UBYTE *time)
{
	if (time!=NULL)
	{
		strcpy(time,"00:00:00");
		time[6] += (((unsigned)ltime&31)*2) / 10;
		time[7] += (((unsigned)ltime&31)*2) % 10;
		ltime>>=5;
		time[3] += ((unsigned)ltime&63) / 10;
		time[4] += ((unsigned)ltime&63) % 10;
		ltime>>=6;
		time[0] += ((unsigned)ltime&31) / 10;
		time[1] += ((unsigned)ltime&31) % 10;
		ltime>>=5;
	}
	else
		ltime>>=16;
	if (date!=NULL)
	{
		strcpy(date,"00.00.80");
		date[0] += ((unsigned)ltime&31) / 10;
		date[1] += ((unsigned)ltime&31) % 10;
		ltime>>=5;
		date[3] += ((unsigned)ltime&15) / 10;
		date[4] += ((unsigned)ltime&15) % 10;
		ltime>>=4;
		date[6] += ((unsigned)ltime&127) / 10;
		date[7] += ((unsigned)ltime&127) % 10;
	}
}

/*****************************************************************************/

VOID get_datum(UBYTE *date)
{
	make_time(Gettime(),date,NULL);
}

/*****************************************************************************/

LONG file_time(const UBYTE *filename, UBYTE *date, UBYTE *time)
{
	LONG	ltime, ret;
	XATTR	attr;
	
	ret = Fxattr(0, (UBYTE *)filename, &attr);
	if (ret == -32)						/* kein Fxattr */
	{
		DTA	dta, *old_dta;
		
		old_dta = Fgetdta();
		Fsetdta (&dta);
		if (Fsfirst((UBYTE*)filename, 0x00)==0)
		{
			ltime = (LONG)dta.d_time+((LONG)dta.d_date<<16);
			make_time(ltime, date, time);
		}
		else
		{
			ltime = 0L;
			if (date!=NULL)
				date[0] = EOS;
			if (time!=NULL)
				time[0] = EOS;
		}
		Fsetdta (old_dta);
	}
	else if (ret == 0)
	{
		ltime = (LONG)attr.mtime + ((LONG)attr.mdate << 16);
		make_time(ltime, date, time);
	}
	else
	{
		ltime = 0L;
		if (date!=NULL)
			date[0] = EOS;
		if (time!=NULL)
			time[0] = EOS;
	}
	return ltime;
}

/*****************************************************************************/

LONG file_size(const UBYTE *filename)
{
	LONG	size = 0L, 
			ret;
	XATTR	attr;
	
	ret = Fxattr(0, (UBYTE *)filename, &attr);
	if (ret == -32)						/* kein Fxattr */
	{
		DTA	dta, *old_dta;

		old_dta = Fgetdta();
		Fsetdta (&dta);
		if (Fsfirst((UBYTE*)filename, 0x00)==0)
			size = (LONG)dta.d_length;
		Fsetdta (old_dta);
	}
	else if (ret == 0)
	{
		size = attr.size;
	}
	return size;
}

/*****************************************************************************/

BOOLEAN file_exist (const UBYTE *filename)
{
	BOOLEAN	result;
	XATTR	attr;
	LONG	ret;
	
	ret = Fxattr(0, (UBYTE *)filename, &attr);
	if (ret == -32)						/* kein Fxattr */
	{
		DTA	dta, *old_dta;

		old_dta = (DTA *)Fgetdta ();
		Fsetdta (&dta);
		result = (Fsfirst ((UBYTE*)filename, 0x00) == 0);
		Fsetdta (old_dta);
	}
	else
		result = (ret == 0);
	return (result);
} /* file_exist */

/*****************************************************************************/

BOOLEAN file_readonly (const UBYTE *filename)
{
	BOOLEAN	result;
	XATTR	attr;
	LONG	ret;
	
	ret = Fxattr(0, (UBYTE *)filename, &attr);
	if (ret == -32)						/* kein Fxattr */
	{
		DTA	dta, *old_dta;

		old_dta = (DTA *)Fgetdta ();
		Fsetdta (&dta);
		result = (Fsfirst ((UBYTE*)filename, 0x00) == 0);
		if (result)
			result = (dta.d_attrib&FA_READONLY)!=0;
		else
			result = FALSE;
		Fsetdta (old_dta);
	}
	else if (ret == 0)
	{
		WORD	uid, gid;
		
		uid = Pgetuid();
		gid = Pgetgid();
		if (uid != -32 && gid != -32)		/* gibts Pget[ug]id ? */
		{
			if (((uid == attr.uid) && ((attr.mode & S_IWUSR) != 0)) ||	/* Besitzer hat Schreibrecht */
		   	((gid == attr.gid) && ((attr.mode & S_IWGRP) != 0)) ||	/* Gruppe hat Schreibrecht */
		    	(((attr.mode & S_IWOTH) != 0))	||								/* Welt hat Schreibrecht */
		    	((uid == 0) && ((attr.mode & S_IWUSR) != 0)))				/* root darf, wenn Owner darf */
				result = FALSE;
			else
				result = TRUE;
		}
		else
			result = ((attr.attr & FA_READONLY) != 0);
	}
	else if (ret == -33)					/* Fxattr da, aber Datei nicht */
		result = FALSE;
	return (result);
} /* file_readonly */

/*****************************************************************************/

BOOLEAN path_exist(const UBYTE *pathname)
{
	BOOLEAN	result;
	PATH	s;
	WORD	l;

	strcpy (s, pathname);
	l = (short) strlen (s)-1;
	s[l] = EOS;
	if (l==2 && s[1]==':')
	{
		return TRUE;
	}
	else
	{
		LONG	ret;
		
		ret = Dopendir(s, 0);
		if (ret == -32)					/* kein Dopendir */
		{
			DTA	dta, *old_dta;
		
			old_dta = (DTA *)Fgetdta ();
			Fsetdta (&dta);
			result = (Fsfirst (s, 0x10)==0 && (dta.d_attrib&0x10));
			Fsetdta (old_dta);
		}
		else
		{
			if ((ret & 0xFF00) != 0xFF00)	/* FF im obersten Byte ? */
				Dclosedir(ret);
			result = (ret > 0);
		}
		return (result);
	}
} /* path_exist */

/*****************************************************************************/

UBYTE* getenv(const UBYTE *str) /* die lib-Funktion findet CDPATH bei PATH */
{
	UBYTE *ptr;
	WORD	l;
	
	l = (short) strlen(str);
	ptr = _BasPag->p_env;
	while (*ptr!=EOS)
	{
		if (strncmp(ptr,str,l)==0)
		{
			ptr += l;
			if (*ptr=='=')
			{
				return ptr+1;
			}
		}
		ptr += strlen(ptr)+1;
	}
	return NULL;
}

/*****************************************************************************/
/* Dateiauswahl																				  */
/*****************************************************************************/

VOID set_fsel_path(const UBYTE *path)
{
	PATH	p;

	file_splitt(path, p, NULL);
	if (path_exist(p))
		strcpy(fs_path, p);
}

BOOLEAN select_file (FSEL *fsel, UBYTE *filename, const UBYTE *lable)
{
	WORD	button;
	UBYTE	*p;
	PATH	l_path;
	FILENAME	l_name;

	if (fsel==NULL) 
		fsel = &default_fsel;

	strcpy(l_path, fs_path);

	p = strrchr (l_path, '\\');
	strcpy((p+1), fsel->suffix);
	strcpy(l_name, fsel->name);
	
	Wake_mouse();
/*	wind_update(BEG_UPDATE);*/
/*	wind_update(BEG_MCTRL);*/
	if (ext_fsel || gem >= 0x140 && gem < 0x200 || gem >= 0x300)
		fsel_exinput (l_path, l_name, &button, (UBYTE*)lable);
	else
		fsel_input (l_path, l_name, &button);
/*	wind_update(END_MCTRL);*/
/*	wind_update(END_UPDATE);*/
	if (button != 0)
	{
		p = strrchr (l_path, '\\');
		strcpy(fsel->suffix, (UBYTE *)p+1); 
		p[1] = EOS;
		make_normalpath(l_path,FALSE);
		strcpy(fsel->name, l_name);
		
		strcpy (filename, l_path);
		strcat (filename, l_name);
		set_fsel_path(l_path);						/* aktuellen Pfad im GEMDOS ndern */
	}
	else
		filename[0] = EOS;							/* Abbruch gedrckt */
	return (*l_name && (button !=0) );
} /* select_file */

/***************************************************************************/

UBYTE **select_mfile (FSEL *fsel, UBYTE *path, const UBYTE *lable, WORD *anz)
{
	BOOLEAN	slct;

	slct =  slct_morenames(CMD_FILES_OUT, MFILE_ANZ, slct_files);
	if (select_file (fsel, path, lable))
	{
		if (slct)
			*anz = slct_getnum();
		else
			*anz = 1;
	}
	else
		*anz = 0;
	return (*anz > 1) ? slct_files : NULL;
}

/***************************************************************************/
/* Initialisieren des Moduls																*/
/***************************************************************************/

VOID init_global (VOID)
{
	WORD		work_out[57], i, height, width, f_anz, d;
	WORD		work_outx[57];
	WORD		attr[10], ret;

	phys_handle = graf_handle (&sys_wchar, &sys_hchar, &sys_wbox, &sys_hbox);
	wind_get (0, WF_WORKXYWH, &desk.x, &desk.y, &desk.w, &desk.h);

	gdos	= vq_gdos();							/* GDOS vorhanden */
	ext_fsel = fsel_check();					/* erweiterte FselBox */
	if (ext_fsel)
		for (i = 0; i < MFILE_ANZ; i++)
			slct_files[i] = (UBYTE *) Malloc(sizeof(PATH));
	done	= FALSE;

	default_fsel.name[0] = EOS;
	strcpy(default_fsel.suffix,"*.*");
	get_path(fs_path, 0);							/* Aktuellen Pfad holen */
	strcat (fs_path, "*.*");						/* fr FileselctBox */

	vdi_handle = open_vwork(work_out);
	fill_color = WHITE;
	colors	= work_out[13];						/* Anzahl der Farben */
	clip_flag = TRUE;
	vq_extnd (vdi_handle, FALSE, work_outx);	/* So, wg. Fehler im VDI */
	f_anz = work_outx[10];
	vq_extnd (vdi_handle, TRUE, work_outx);
	planes = work_outx[4];
	speed = work_outx[6];
	
	if (gdos)
		f_anz += vst_load_fonts (vdi_handle, 0);
	vswr_mode(vdi_handle, MD_REPLACE);
	vsl_color (vdi_handle, BLACK);
	vsl_ends (vdi_handle, SQUARE, SQUARE);
	vsl_width (vdi_handle, 1);
	vst_alignment(vdi_handle, TA_LEFT, TA_TOP, &ret, &ret);

	/* Systemfont erfragen */
	i = appl_xgetinfo(0, &sys_font_size, &sys_font_id, &d, &d);
	if (i == 0)
	{
		vqt_attributes (vdi_handle, attr);
		sys_font_id = attr[0];

		sys_font_size = 0;
		while (sys_font_size < 100)
		{
			sys_font_size++;
			vst_point(vdi_handle, sys_font_size, &ret, &ret, &width, &height);
			if (height == sys_hchar && width == sys_wchar)
				break;
		}
		if (sys_font_size == 100)
			sys_font_size = 10;
	}

#if 0
	vst_font (vdi_handle, sys_font_id);
	for (i=1; i<100; i++)
	{
		winFont.Size = vst_point (vdi_handle, i, &ret, &ret, &width, &height);
		if (height == sys_hchar && width == sys_wchar)
		{
			sys_font_size = i;
			break;
		}
	}
#endif


   vst_font (vdi_handle, sys_font_id);
   vst_point (vdi_handle, sys_font_size, &ret, &ret, &ret, &ret);

	winFont.ID = sys_font_id;
	for (i = 1; i <= 100; i++)
		if (winFont.ID == vqt_name(vdi_handle, i, winFont.Name))
		{
			winFont.Index = i;
			break;
		}
/*	winFont.Name[32] = EOS;*/
	winFont.Size = sys_font_size;
	winFont.Anz = f_anz;
	winFont.prop = FALSE;
	font_change();
} /* init_global */

/************************************************************************/
/* Terminieren des Moduls																*/
/************************************************************************/

VOID term_global(VOID)
{
	if (ext_fsel)
	{
		WORD	i;
		
		for (i = 0; i < MFILE_ANZ; i++)
			Mfree(slct_files[i]);
	}
	if (gdos)
		vst_unload_fonts (vdi_handle, 0);
	v_clsvwk(vdi_handle);
}

/************************************************************************/
/* Dateiname in Grobuchstaben wandeln												*/
/************************************************************************/
VOID	upper(UBYTE *name)
{
	PATH	temp = "";
	WORD	i;
	
	for (i=0; i< strlen(name); i++)
		temp[i] = toupper(name[i]);
	temp[strlen(name)] = EOS;
	strcpy(name, temp);
}

/************************************************************************/
/* Kann Filesystem lange Namen?														*/
/************************************************************************/
BOOLEAN	longName(UBYTE *filename)
{
	PATH	pfad = "";
	
	if (Dpathconf("", -1) == -32)		/* gibt diese Funktion berhaupt?? */
		return FALSE;
	file_splitt(filename, pfad, NULL);
	if (Dpathconf(pfad, 3) > 12) 
		return TRUE;
	return FALSE;
}

/************************************************************************/
/* Kann Filesystem Gro/Klein?														*/
/************************************************************************/
BOOLEAN	caseSens(UBYTE *filename)
{
	LONG	case_sen;
	PATH	pfad = "";
	
	if (Dpathconf("", -1) == -32)		/* gibt diese Funktion berhaupt?? */
		return FALSE;
	file_splitt(filename, pfad, NULL);
	case_sen = Dpathconf(pfad, 6);
	if (case_sen == 0L) 
		return TRUE;
	return FALSE;
}
