/*****************************************************************************/
/*																																			 */
/* Modul: EXTERN.H																													 */
/*																																					 */
/*****************************************************************************/
#ifndef _qed_global_h_
#define _qed_global_h_

#undef NULL				/* MK@UN: in mydial\portab.h *UND* stddef.h definiert... */

#include <stddef.h>
#include <portab.h>
#include <aes.h>
#include <vdi.h>
#include <tos.h>
#include <mglobal.h>
#include <mydial.h>
#include <time.h>


/* MK@UN: Die folgenden Definitionen sind mglicherweise schon
	       in aes.h / vdi.h vorhanden: */

#ifndef TA_LEFT
/* text alignment */
#define TA_LEFT		0
#define TA_CENTER		1
#define TA_RIGHT		2

#define TA_BASELINE	0
#define TA_HALF		1
#define TA_ASCENT		2
#define TA_BOTTOM		3
#define TA_DESCENT	4
#define TA_TOP			5
#endif

#ifndef WHITEBAK
#define WHITEBAK		0x40
#define DRAW3D			0x80
#endif

#ifndef CH_EXIT
#define CH_EXIT		90					/* AES 4.1 */
#else
#if CH_EXIT != 90
#error Bug in aes.h: CH_EXIT should be 90!
#endif
#endif

#ifndef WM_M_BDROPPED
#define WM_M_BDROPPED		100		/* Mag!C */
#define WF_M_BACKDROP    	100
#endif

#ifndef WM_BOTTOMED
#define WM_BOTTOMED			33
#define WF_BOTTOM				25
#endif

#ifndef SMALLER							/* AES 4.1 */
#define SMALLER				0x4000
#define WM_ICONIFY			34
#define WM_UNICONIFY			35
#define WM_ALLICONIFY		36
#define WF_ICONIFY			26
#define WF_UNICONIFY			27
#define WF_UNICONIFYXYWH	28
#endif


/****** DEFINES **************************************************************/

#define NO_HANDLE	 (-1)						/* Wert fr ungltiges Handle */

#define NDC		0								/* Normalisierte Koordinaten */
#define RC		2								/* Raster Koordinaten */

#define THEBAR		1							/* Objekt-Nummer der Menzeile */
#define THEACTIVE 2							/* Objekt-Nummer der aktiven Mens */
#define THEFIRST	3							/* Objekt-Nummer des ersten Mens */

#define max(a,b)	(((a) > (b)) ? (a) : (b))
#define min(a,b)	(((a) < (b)) ? (a) : (b))
#define odd(i)		((i) & 1) 

#define EOS	'\0'
#define NIL	-1

#define MAX_PATH_LEN	1024
#define MAX_NAME_LEN	255

#define MAX_LINE_LEN	255

#define RP_FIRST 	0
#define RP_ALL   	1
#define RP_OPT   	2			/* Werte von 'r_modus' */

#define HIST_ANZ		10		/* Gre des History-Puffers fr Suchstrings */
#define MUSTER_ANZ	10		/* Anzahl Muster fr Optionen */
#define MUSTER_LEN	15

#define SETSIZE	32							/* Gre eines Sets in Longs */
#define SETMAX		(SETSIZE*32 - 1)		/* Maximale Elemente eines Sets */

/****** TYPES ****************************************************************/

typedef UBYTE PATH[MAX_PATH_LEN];
typedef UBYTE FILENAME[MAX_NAME_LEN];

typedef ULONG SET[SETSIZE];				/* Menge */

typedef struct
{
	FILENAME name;
	FILENAME suffix;
} FSEL;

typedef enum 
{	
	POS_CHANGE,
	LINE_CHANGE,
	TOTAL_CHANGE,
	NOP_CHANGE,
	SCROLL_UP,
	SCROLL_DOWN,
	MOVE_UP,
	MOVE_DOWN,
	BLK_CHANGE
} CHANGE;

/*
SCROLL_UP 	: Alles unter der aktuellen Zeile wird hochgescrollt,
		  die letzte Zeile wird natrlich neu geschrieben.
		  (Cntrl-Y, und Delete am Ende der Zeile).
SCROLL_DOWN	: Alles unterhalb der aktuellen Zeile und diese Zeile werden
		  nach unten gescrollt, die aktuelle Zeile wird neu
		  geschrieben. Ist auch LINE_CHANGE gesetzt wird auch die
		  Zeile vor der aktuellen Zeile neu geschrieben.
		  (RETURN, last_out_klemm)
MOVE_UP,_DOWN	: Das Fenster wird hoch und runter gescrollt um anz Zeilen
BLK_CHANGE   	: Die Blockmarkierung wurde gendert.
*/

typedef struct
{
	BOOLEAN	tab;
	WORD		tabsize;
	BOOLEAN	einruecken;
	BOOLEAN	umbrechen;
	BOOLEAN	format_by_load;
	BOOLEAN  format_by_paste;
	WORD		lineal_len;
	UBYTE		umbruch_str[35];
	SET		umbruch_set;
	BOOLEAN	backup;
	UBYTE		backup_ext[4];
	PATH		kurzel;
	UBYTE		wort_str[34];
	SET		wort_set;
}LOCAL_OPT, *LOC_OPTP;

typedef struct                                                                
{                                                                             
      LONG    x;                                                              
      LONG    y;                                                              
      LONG    w;                                                              
      LONG    h;                                                              
} LRECT;                                                                      
                                                                              
/****** VARIABLES ************************************************************/

EXTERN WORD		phys_handle;		/* Physikalisches Workstation Handle */
EXTERN WORD		gl_apid;				/* Identifikation fr Applikation */
EXTERN WORD		gl_wchar;			/* Je nach aktuellem Font z.B. 8*16 */
EXTERN WORD		gl_hchar;
EXTERN WORD		sys_font_size;		/* 10 */
EXTERN WORD		sys_font_id;		/* */
EXTERN WORD		sys_wchar;			/* 8*16 */
EXTERN WORD		sys_hchar;
EXTERN WORD		sys_wbox;			/* 19*19 */
EXTERN WORD		sys_hbox;
EXTERN WORD		min_ascii;
EXTERN WORD		max_ascii;

EXTERN BOOLEAN multi;				/* Mehrere Applikation mglich */
EXTERN WORD		colors;				/* Anzahl der Farben */
EXTERN WORD		fill_color;			/* aktuell eingestellte Fllfarbe */
EXTERN WORD		planes;				/* Anzahl der Planes */
EXTERN WORD		speed;				/* Anzahl Rasterops pro sec */
EXTERN WORD		gem;					/* GEM-Version */
EXTERN BOOLEAN	mint;					/* MiNT aktiv? */
EXTERN BOOLEAN	mtos;					/* MultiTOS aktiv? */
EXTERN BOOLEAN	magx;					/* Mag!X aktiv? */
EXTERN BOOLEAN magx3;				/* MagiC 3 ? */

EXTERN BOOLEAN	global_shift;		/* bei aktueller Opertion wurde Shift gedrckt */
EXTERN BOOLEAN	menu_ctrl;			/* bei Menauswahl Ctrl gedrckt -> ST-GUIDE */
EXTERN BOOLEAN	quick_close;		/* Sichern der Texte ohne Nachfrage */
EXTERN WORD		vdi_handle;			/* Virtuelles Workstation Handle */
EXTERN BOOLEAN no_desktop;			/* Kein Desktop */
EXTERN BOOLEAN wish_no_desktop;	/* fr save_option */
EXTERN BOOLEAN	wind_cycle;			/* Fensterwechsel ber VA-Protokoll */

EXTERN RECT		desk;					/* Bildschirm-Gre  0,19,640,381 */

EXTERN BOOLEAN	done;					/* Ende gewhlt ? */
EXTERN PATH		qed_path;			/* Name und Pfad der QED-Datei */
EXTERN PATH		scrapdir;			/* Clipboard-Pfad */

EXTERN struct tm	*local_time;	/* enthlt die aktuelle Uhrzeit */

EXTERN LOCAL_OPT	loc_opt[MUSTER_ANZ];
EXTERN WORD			desire_x, seiten_len, seiten_width, rand_len,
						prn_mode, r_modus, cu_mode, cu_width2,
						cu_high2, ev_time, transfer_size, return_code,
						loc_opt_anz, return_code;
EXTERN BOOLEAN 	zeilen_nr, seiten_nr, 
						s_grkl, s_quant, s_wort, s_runter, s_global, s_round,
						df_rekursiv, epson, vorschub, pruef_prn,
						save_opt,
						cu_icon, cu_window, cu_width, cu_high,
						overwrite, gdos_print, gdos_device,
						blinking_cursor, extern_fontselect;
EXTERN LONG			desire_y, undo_y;
EXTERN UBYTE		r_str[80], s_str[80], s_history[HIST_ANZ][80],
						muster_str[MUSTER_ANZ][MUSTER_LEN+1],
						df_name[MUSTER_LEN+1];
EXTERN PATH			helpprog;

/****** FUNCTIONS ************************************************************/

WORD			open_vwork		(WORD	*w_out);
VOID			beep				(VOID);

VOID			Set_mouse		(int number);
WORD			Get_mouse		(void);
BOOLEAN		Mouse_sleeps	(void);
VOID			Sleep_mouse 	(void);
VOID			Wake_mouse		(void);
VOID			Last_mouse		(void);
VOID			Hide_mouse		(void);
VOID			Show_mouse		(void);
VOID			Busy_mouse		(void);
VOID			Arrow_mouse		(void);

VOID			print_headline	(UBYTE *str);
VOID			font_change 	(VOID);

VOID			start_aktion	(CONST UBYTE *head, BOOLEAN inter, LONG max);
VOID			do_aktion		(LONG value);
VOID			end_aktion		(VOID);

UBYTE			xupper			(UBYTE c);
VOID			xstrupr			(UBYTE *str);
BOOLEAN		str_to_key		(UBYTE *str, MKINFO *mk);

BOOLEAN		rc_equal			(CONST RECT *p1, CONST RECT *p2);
VOID			rc_union			(CONST RECT *p1, RECT *p2);
BOOLEAN		rc_in				(CONST RECT *p1, CONST RECT *p2);
BOOLEAN		rc_intersect	(CONST RECT *p1, RECT *p2);
BOOLEAN		inside			(WORD x, WORD y, CONST RECT *r);
VOID			rect2array		(CONST RECT *rect, WORD *array);
VOID			array2rect		(CONST WORD *array, RECT *rect);

BOOLEAN		get_clip			(RECT *size);
VOID			set_clip			(BOOLEAN	 flag, CONST RECT *size);

VOID			growbox			(CONST RECT *st, CONST RECT *fin);
VOID			shrinkbox		(CONST RECT *fin, CONST RECT *st);
VOID			movebox			(CONST RECT *st, WORD d_x, WORD d_y);

WORD			note				(WORD button, WORD index);
WORD			inote				(WORD button, WORD index, LONG i);
WORD			snote				(WORD button, WORD index, UBYTE *str);

VOID			make_shortpath	(CONST UBYTE *path, UBYTE *shortpath, WORD maxlen);
BOOLEAN		make_normalpath(UBYTE *path, BOOLEAN with_filename);
VOID			make_ext			(UBYTE *fullname, CONST UBYTE *ext);
VOID			get_datum		(UBYTE *date);
long			file_time		(CONST UBYTE *filename, UBYTE *date, UBYTE *time);
long			file_size		(CONST UBYTE *filename);
VOID			file_name		(CONST UBYTE *fullname, UBYTE *filename);
VOID	 		file_splitt 	(CONST UBYTE *fullname, UBYTE *path, UBYTE *name);
WORD			get_first_drive(VOID);
VOID 			drive_name		(WORD drive, UBYTE *name);
BOOLEAN		get_path			(UBYTE *path, UBYTE drive);
BOOLEAN		file_exist		(CONST UBYTE *filename);
BOOLEAN		file_readonly	(CONST UBYTE *filename);
BOOLEAN		path_exist		(CONST UBYTE *pathname);
VOID			set_fsel_path	(CONST UBYTE *path);
BOOLEAN		select_file 	(FSEL *fsel, UBYTE *filename, CONST UBYTE *lable);
UBYTE		 **select_mfile	(FSEL *fsel, UBYTE *path, CONST UBYTE *lable, WORD *anz);
UBYTE 		*getenv			(CONST UBYTE *str);	/* die lib-Funktion findet CDPATH bei PATH */

VOID			init_global		(VOID);
VOID			term_global		(VOID);

VOID			upper				(UBYTE *name);
/* wandelt einen Filename in Grobuchstaben */

BOOLEAN		longName			(UBYTE *filename);
BOOLEAN		caseSens			(UBYTE *filename);
/* testet, ob der Pfad von `filename` auf einem FS liegt, 
 *		- das lange Namen kann
 *		- das Gro- und Kleinschrift unterscheidet
 */

#endif
