/***************************************************************************/
/* 																								*/
/* Modul: MENU.C																				*/
/* 																								*/
/***************************************************************************/

#include <stdlib.h>	/* itoa, atoi */
#include <stdio.h>
#include <string.h>	/* strcpy */
#include <vdi.h>		/* vqt_name */
#include <ctype.h>

#include "global.h"
#include "block.h"	/* blk_demark */
#include "clipbrd.h" /* get_clip_text, clip_ondisk is_clip_ondisk */
#include "comm.h"
#include "desktop.h" /* clearup_desktop */
#include "disk.h" 	/* idisk */
#include "edit.h" 	/* font_edit, absatz_edit, new_edit, load_edit */
#include "error.h"
#include "file.h"
#include "find.h" 	/* set_suchmode, dials */
#include "fontsel.h"
#include "kurzel.h"	/* hndl_kurzel, config_marken */
#include "makro.h"	/* start_rec, end_rec, makro_rec */
#include "icon.h" 	/* Icon_exist, Icon_edit, all_icons, do_icon */
#include "obj.h"
#include "projekt.h" /* load_projekt, new_prj */
#include "qed.h"
#include "rsc.h"		/* option, menu usw. */
#include "scroll.h"	/* COPYB */
#include "set.h"
#include "text.h"
#include "umbruch.h" /* set_umbruch */
#include "windows.h"
#include "menu.h"

/****** DEFINES **************************************************************/

/****** TYPES ****************************************************************/

/****** VARIABLES ************************************************************/

GLOBAL BOOLEAN as_text, as_proj; 			/* Autosave ? */
GLOBAL BOOLEAN as_text_ask, as_proj_ask;	/* AS: nachfragen? */
GLOBAL WORD 	as_text_min, as_proj_min;	/* AS: Minuten */

/* Menuenummer zu einer Aktion */
WORD menu_nr[] =	{MUNDO, MCUT, MCOPY, MPASTE, MCLEAR, MSELALL,
		  MCLOSE, -1, MOPEN, MINFO, -1, MLEFT, MRIGHT,
		  MFORMAT, MPRINT, MABAND, MSAVE, MSAVENEW, MFIND,
		  MFNDGOON, MADD, -1, MGOTO, MSCUT, -1, -1,
		  MSTAB2LZ, -1, MSLZ2TAB, -1, MZEICHEN, MSWAP,
		  MLEFT, MRIGHT, MSMALL, MBIG, MSMALLBIG, MCAPS,
		  -1, -1, MUMLAUTE, -1};
		  /*MGOBLKA, MGOBLKE};*/

		  
WORD local_option;

/*****************************************************************************/

LOCAL WORD	menu_width;

/****** FUNCTIONS ************************************************************/

LOCAL VOID	mglobalop	(VOID);
LOCAL VOID	mlocalop 	(VOID);
LOCAL VOID	mclearup 	(VOID);

/*****************************************************************************/

WORD get_ascii(VOID)
{
	WORD	antw;
	
	Arrow_mouse();
	antw = HndlDial(zeichentab, 0, FALSE, NULL, NULL);
	Last_mouse();
	if (antw != ZABBRUCH)
		return (antw - ZEICHEN1 + 1 );
	return -1;
}

/***************************************************************************/
/* Lokale Optionen																			*/
/***************************************************************************/

LOCAL BOOLEAN		krz_changed = FALSE;
LOCAL WORD			selected_muster;
LOCAL LOCAL_OPT	bak_loc_opt[MUSTER_ANZ];
LOCAL UBYTE 		bak_muster_str[MUSTER_ANZ][MUSTER_LEN+1];

LOCAL VOID option_fill(VOID)
{
	UBYTE 	s[10], str[13] = "", name[MUSTER_LEN + 1] = " ";
	LOC_OPTP lo;

	lo = &loc_opt[local_option];
	strcat(name, muster_str[local_option]);
	set_ptext(localop, OTYPE, name);
	set_state(localop, OTAB, lo->tab);
	itoa(lo->tabsize,s,10);
	set_ptext(localop, OTABSIZE, s);
	set_state(localop, OEINRUCK, lo->einruecken);
	set_ptext(localop, OWORT, lo->wort_str);
	set_state(localop, OUMBRUCH, lo->umbrechen);
	set_state(localop, OFORMLOAD, lo->format_by_load);
	set_state(localop, OFORMPASTE, lo->format_by_paste);
	set_ptext(localop, OUMBTEXT, lo->umbruch_str);
	itoa(lo->lineal_len,s,10);
	set_state(localop, OBACKUP, lo->backup);
	set_ptext(localop, OEXT, lo->backup_ext);
	set_ptext(localop, OLINEAL, s);
	if (lo->kurzel[0] != EOS)
		file_name(lo->kurzel, str);
	else
		strcpy(str, strings(KURZELSTR));
	fill_ptext(localop, OKURZELNAME, str);
}

LOCAL VOID option_get(VOID)
{
	UBYTE 	s[20];
	WORD		help;
	LOC_OPTP lo;

	lo = &loc_opt[local_option];
	lo->tab = get_state(localop, OTAB);
	get_ptext (localop, OTABSIZE, s);
	if (*s)
	{
		help = atoi(s);
		if (help < 1 || help > 50) 
			help = 3;
	}
	else
		help = 3;
	lo->tabsize = help;
	lo->umbrechen = get_state(localop, OUMBRUCH);
	lo->einruecken = get_state(localop, OEINRUCK);
	get_ptext(localop, OUMBTEXT, lo->umbruch_str);
	str2set(lo->umbruch_str,lo->umbruch_set);
	lo->format_by_load = get_state(localop, OFORMLOAD);
	lo->format_by_paste = get_state(localop, OFORMPASTE);
	lo->backup = get_state(localop, OBACKUP);
	get_ptext(localop, OEXT, lo->backup_ext);
	get_ptext(localop, OLINEAL, s);
	if (*s)
	{
		help = atoi(s);
		if (help < 3 || help > 200) help = 65;
	}
	else
		help = 65;
	lo->lineal_len = help;
	get_ptext(localop, OWORT, lo->wort_str);
	str2set(lo->wort_str,lo->wort_set);
}

LOCAL BOOLEAN option_changed(VOID)
{
	UBYTE 	s[40];
	WORD		help;
	LOC_OPTP lo;

	lo = &loc_opt[local_option];
	if (lo->tab != get_state(localop, OTAB)) return TRUE;
	get_ptext (localop, OTABSIZE, s);
	if (*s)
	{
		help = atoi(s);
		if (help<1 || help>50) help = 3;
	}
	else
		help = 3;
	if (lo->tabsize != help) 
		return TRUE;
	if (lo->umbrechen != get_state(localop, OUMBRUCH)) 
		return TRUE;
	if (lo->einruecken != get_state(localop, OEINRUCK)) 
		return TRUE;
	get_ptext(localop, OUMBTEXT, s);
	if (strcmp(lo->umbruch_str,s)) 
		return TRUE;
	str2set(lo->umbruch_str,lo->umbruch_set);
	if (lo->format_by_load != get_state(localop, OFORMLOAD)) 
		return TRUE;
	if (lo->format_by_paste != get_state(localop, OFORMPASTE)) 
		return TRUE;
	get_ptext(localop, OLINEAL, s);
	if (*s)
	{
		help = atoi(s);
		if (help<3 || help>200) help = 65;
	}
	else
		help = 65;
	if (lo->lineal_len != help) 
		return TRUE;
	get_ptext(localop, OWORT, s);
	if (strcmp(lo->wort_str,s)) 
		return TRUE;
	str2set(lo->wort_str,lo->wort_set);

	get_ptext(localop, OEXT, s);
	if (strcmp(lo->backup_ext, s)) 
		return TRUE;
	if (lo->backup != get_state(localop, OBACKUP)) 
		return TRUE;
	
	if (krz_changed)
	{
		krz_changed = FALSE;
		return TRUE;
	}
	return FALSE;
}


LOCAL VOID config_muster(VOID)
{
	DIALINFO	dial;
	BOOLEAN	quit = FALSE;
	WORD		i, antw;
	UBYTE 	str[MUSTER_LEN+1];

	if (option_changed() && note(1,APPLAYCH)==2)
		return;
	option_get();

	/* Daten fr Abbruch retten */
	COPYW(bak_loc_opt, loc_opt, (short) sizeof(LOCAL_OPT) * MUSTER_ANZ);
	COPYW(bak_muster_str, muster_str, MUSTER_ANZ * (MUSTER_LEN+1));

	selected_muster = -1;
	do_state(muster, DMDELETE, DISABLED);
	do_state(muster, DMCHANGE, DISABLED);
	if (loc_opt_anz == MUSTER_ANZ)
		do_state(muster, DMNEW, DISABLED);

	for (i=1; i<loc_opt_anz; i++)
	{
		set_fstring(muster, DM1 + i - 1, muster_str[i]);
		do_flags(muster, DM1 + i - 1, SELECTABLE);
	}
	for (; i<MUSTER_ANZ; i++)
	{
		set_fstring(muster,DM1 + i - 1, strings(FREESTR));
		do_state(muster, DM1 + i - 1, DISABLED);
	}

	open_dial(muster, FALSE, NULL, &dial);
	dial_draw(&dial);
	do
	{
		antw = dial_do(&dial, 0) & 0x7FFF;
		if (antw >= DM1 && antw <= DM9)
		{
			if (antw == selected_muster)
			{
				undo_state(muster, selected_muster, SELECTED);
				selected_muster = -1;
				undo_state(muster, DMNEW, DISABLED);
				do_state(muster, DMDELETE, DISABLED);
				do_state(muster, DMCHANGE, DISABLED);
			}
			else
			{
				undo_state(muster, selected_muster, SELECTED);
				selected_muster = antw;
				do_state(muster, selected_muster, SELECTED);
				do_state(muster, DMNEW, DISABLED);
				undo_state(muster, DMDELETE, DISABLED);
				undo_state(muster, DMCHANGE, DISABLED);
			}
			dial_draw(&dial);
		}
		else
		{
			switch (antw)
			{
				case DMNEW: 							/* Neues Dateimuster eingeben */
					set_ptext(musterchg, DMCTEXT, "");
					if (HndlDial(musterchg, 0, FALSE, NULL, NULL) == DMCOK)
					{
						WORD	i;
			
						i = loc_opt_anz;
						if (i < MUSTER_ANZ)
						{
							get_ptext(musterchg, DMCTEXT, str);
							set_fstring(muster, DM1 + i - 1, str);
							undo_state(muster, DM1 + i - 1, DISABLED);
							strcpy(muster_str[i],str);
							COPYW(&loc_opt[i], &loc_opt[0], (short) sizeof(LOCAL_OPT));
							loc_opt_anz++;
							draw_Objc(muster, DMEXTBOX, 8);
						}
					}
					if (loc_opt_anz == MUSTER_ANZ)		/* wenn voll, Button aus! */
					{
						do_state(muster, DMNEW, DISABLED);
						draw_Objc(muster, DMNEW, 1);
					}
					break;
				case DMDELETE: 						/* Muster lschen */
					i = selected_muster - DM1 + 1;
					COPYW(&loc_opt[i], &loc_opt[i+1], (short) sizeof(LOCAL_OPT) * (loc_opt_anz-i-1));
					COPYW(&muster_str[i], &muster_str[i+1], (MUSTER_LEN+1) * (loc_opt_anz-i-1));
					loc_opt_anz--;
					for (; i<loc_opt_anz; i++)
						set_fstring(muster, DM1 + i - 1, muster_str[i]);

					if (i < MUSTER_ANZ)
					{
							set_fstring(muster, DM1 + i - 1, strings(FREESTR));
							do_state(muster, DM1 + i - 1, DISABLED);
					}
					undo_state(muster, selected_muster, SELECTED);

					selected_muster = -1;
					do_state(muster, DMDELETE, DISABLED);
					do_state(muster, DMCHANGE, DISABLED);

					if (loc_opt_anz < MUSTER_ANZ) 		/* wieder welche frei? */
						undo_state(muster, DMNEW, DISABLED);

					dial_draw(&dial);
					break;
				case DMCHANGE: 						/* Muster ndern */
					get_fstring(muster, selected_muster, str);
					set_ptext(musterchg, DMCTEXT, str);
					if (HndlDial(musterchg, 0, FALSE, NULL, NULL) == DMCOK)
					{
						get_ptext(musterchg, DMCTEXT, str);
						set_fstring(muster, selected_muster, str);
						draw_Objc(muster, DMEXTBOX, 8);
						strcpy(muster_str[selected_muster - DM1 + 1], str);
					}
					break;
				default:
					quit = TRUE;
					break;
			} /* switch */
			undo_state(muster, antw, SELECTED);
			draw_Objc(muster, antw, 1);
		} /* if */
	} /* while */
	while (!quit);
	dial_end(&dial);
	if (antw == DMOK)
	{
		if (muster_str[local_option][0]==EOS)
		{
			local_option = 0;
			option_fill();
		}
		draw_Objc(localop, OTYPE, 1);
		draw_Objc(localop, OBOX, 8);
	}
	else
	{
		COPYW(loc_opt,bak_loc_opt, (short) sizeof(LOCAL_OPT) * MUSTER_ANZ);
		COPYW(muster_str, bak_muster_str, MUSTER_ANZ * (MUSTER_LEN + 1));
	}
	if (selected_muster!=-1)
		undo_state(muster, selected_muster, SELECTED);
}

LOCAL BOOLEAN build_popup(POPUP *pop)
{
	UBYTE str[MUSTER_LEN + 1];
	WORD	i, len;
	
	if (loc_opt_anz <= 1)
		return FALSE;
		
	strcpy(str, " ");
	strcat(str, muster_str[0]);
	len = (short) strlen(str);
	len = min(MUSTER_LEN, len);
	if (len <= MUSTER_LEN)
		for (i = len; i < MUSTER_LEN; i++)
			strcat(str, " ");
	create_popup(pop, MUSTER_ANZ, str, (short)strlen(str));
	for (i = 1; i < loc_opt_anz; i++)
	{
		strcpy(str, " ");
		strcat(str, muster_str[i]);
		append_popup(pop, str);
	}
	if (pop->tree != NULL)
	{
		dial_fix(pop->tree, TRUE);
		return TRUE;
	}
	return FALSE;
}

LOCAL VOID mlocalop (VOID)
{
	WORD		antw;
	WINDP 	window;
	PATH		save_name;
	DIALINFO	dial;
	BOOLEAN	quit = FALSE;	
	FSEL		fsel = {"", "*.KRZ"};
	PATH		name = "";
	UBYTE 	str[13] = "";
	POPUP 	popup;
	
	local_option = 0;
	window = top();
	if (window->flags & WI_FONTSIZE)
	{
		TEXTP t_ptr = get_text(window->link);
		local_option = (short)(t_ptr->loc_opt - loc_opt);
	}
	option_fill();
	strcpy(save_name, loc_opt[local_option].kurzel);

	Arrow_mouse();
	open_dial(localop, FALSE, NULL, &dial);
	dial_draw(&dial);
	do
	{
		antw = dial_do(&dial, 0);
		switch (antw)
		{
			case (OTYPE|0x8000) :			/* Doppelklick -> Popup */
				antw &= 0x7FFF;
				config_muster();
				break;
			case OTYPE :
				if (build_popup(&popup))
				{
					WORD	pos_x, pos_y, y;
															
					objc_offset(localop, OTYPE, &pos_x, &pos_y); 			
					pos_x += localop[OTYPE].ob_width / 2 - 1;
					pos_y += localop[OTYPE].ob_height / 2 - 1;
					y = popup_menu(popup.tree, 1, pos_x, pos_y, 
										local_option + popup.first_item , FALSE, 1 ,NULL);
					y -= popup.first_item;
					if (y >= 0 && y != local_option)
					{
						if (option_changed() && note(1,APPLAYCH) == 1)
							option_get();
						local_option = y;
						option_fill();
						draw_Objc(localop, OBOX, MAX_DEPTH);
					}
				}
				break;				
			case OKURZEL:
				if (loc_opt[local_option].kurzel[0] != EOS)
				{	
					set_fsel_path(loc_opt[local_option].kurzel);
					file_name(loc_opt[local_option].kurzel, name);
				}
				strcpy(fsel.name, name);
				if (select_file(&fsel, name, strings(FINDKURZELSTR)))
				{
					strcpy(loc_opt[local_option].kurzel, name);
					file_name(name, str);
					krz_changed = TRUE;
					set_ptext(localop, OKURZELNAME, str);
				}
				undo_state(localop, OKURZEL, SELECTED);
				dial_draw(&dial);
				break;
			case OOK:
				option_get();
				update_loc_opt();
				absatz_edit();
				ch_kurzel(loc_opt[local_option].kurzel, TRUE);
				quit = TRUE;
				break;
			case ORAUS :
				quit = TRUE;
				break;
		}
		undo_state(localop, antw, SELECTED);
		draw_Objc(localop, antw, 1);
	}
	while (!quit);
	dial_end(&dial);
	Last_mouse();
	if (antw == ORAUS)
		strcpy(loc_opt[local_option].kurzel, save_name);
} /* mlocalop */

/***************************************************************************/
/* Globale Optionen																			*/
/***************************************************************************/

LOCAL VOID mglobalop(VOID)
{
	WORD		antw;
	UBYTE 	s[13];
	BOOLEAN	prev_no_desktop, quit = FALSE;
	DIALINFO	dial;
	FSEL		fsel = {"", "*.*"};
	PATH		n = "", newhelpprog;
		
	prev_no_desktop = no_desktop;
	set_state(globalop, OASAVE, save_opt);
	set_state(globalop, ONODESK, wish_no_desktop);
	if (scrapdir[0]==EOS)
	{
		globalop[OCLIP].ob_state |= DISABLED;
		set_state(globalop, OCLIP, FALSE);
	}
	else
	{
		globalop[OCLIP].ob_state &= (~DISABLED);
		set_state(globalop, OCLIP, is_clip_ondisk());
	}
	set_state(globalop, OWINDOW, wind_cycle);
	set_state(globalop, OBLINK, blinking_cursor);
	set_state(globalop, OEXTFONT, extern_fontselect);
	itoa(transfer_size,s,10);
	set_ptext(globalop, OTRANS, s);
	if (helpprog[0] != EOS)
		file_name(helpprog, s);
	else
		strcpy(s, "");
	set_ptext(globalop, OHELPNAME, s);
	strcpy(newhelpprog, helpprog);
	
	Arrow_mouse();
	open_dial(globalop, FALSE, NULL, &dial);
	dial_draw(&dial);
	do
	{
		antw = dial_do(&dial, OTRANS) & 0x7FFF;
		switch (antw)
		{
			case OHELP :
				if (helpprog[0] != EOS)
				{
					set_fsel_path(helpprog);
					file_name(helpprog, n);
				}
				strcpy(fsel.name, n);
				if (select_file(&fsel, n, strings(FINDHPSTR)))
				{
					strcpy(newhelpprog, n);
					file_name(newhelpprog, n);
					set_ptext(globalop, OHELPNAME, n);
				}				
				undo_state(globalop, antw, SELECTED);
				dial_draw(&dial);
				break;
			default:
				quit = TRUE;
				break;
		}		
	}
	while (!quit);
	undo_state(globalop, antw, SELECTED);
	dial_end(&dial);
	if (antw == GOOK)
	{
		save_opt = get_state(globalop, OASAVE);
		wish_no_desktop = get_state(globalop, ONODESK);
		if (scrapdir[0]!=EOS)
			clip_ondisk(get_state(globalop, OCLIP));
		wind_cycle = get_state(globalop, OWINDOW);
		blinking_cursor = get_state(globalop, OBLINK);
		extern_fontselect = get_state(globalop, OEXTFONT);
		get_ptext (globalop, OTRANS, s);
		transfer_size = atoi(s);
		if (transfer_size == 0) 
			transfer_size = 1;
		strcpy(helpprog, newhelpprog);
		if (prev_no_desktop != wish_no_desktop)
			note(1, DESKCHG);
	}
	Last_mouse();
} /* mglobalop */

/***************************************************************************/

VOID	set_overwrite(BOOLEAN over)
{
	if (overwrite && !over) 	/* einfgen */
	{
		overwrite = FALSE;
		menu_icheck(menu, MOOVERW, FALSE);
		menu_icheck(menu, MOEINF, TRUE);
	}
	else				/* berschreiben */
	{
		overwrite = TRUE;
		menu_icheck(menu, MOOVERW, TRUE);
		menu_icheck(menu, MOEINF, FALSE);
	}
}

/***************************************************************************/

LOCAL VOID mclearup(VOID)
{
	WORD	antw, i;
	UBYTE s[10];

	set_state(clearup, CUWIN, cu_window);
	if (no_desktop)
		clearup[CUICON].ob_state |= DISABLED;
	else
	{
		clearup[CUICON].ob_state &= ~DISABLED;
		set_state(clearup, CUICON, cu_icon);
	}

	set_state(clearup, CU1, cu_mode==0);
	set_state(clearup, CU2, cu_mode==1);
	set_state(clearup, CU3, cu_mode==2);

	set_state(clearup, CUWIDTH, cu_width);
	itoa(cu_width2,s,10);
	set_ptext(clearup, CUWIDTH2, s);
	set_state(clearup, CUHIGH, cu_high);
	itoa(cu_high2,s,10);
	set_ptext(clearup, CUHIGH2, s);

	Arrow_mouse();
	antw = HndlDial(clearup, 0, FALSE, NULL, NULL);
	Last_mouse();
	if (antw == CUOK)
	{
		cu_window = get_state(clearup,CUWIN);
		cu_icon = get_state(clearup,CUICON);
		cu_width = get_state(clearup,CUWIDTH);
		cu_high = get_state(clearup,CUHIGH);
		get_ptext(clearup, CUWIDTH2, s);
		cu_width2 = atoi(s);
		get_ptext(clearup, CUHIGH2, s);
		cu_high2 = atoi(s);
		for (i=0; i<3; i++)
			if (get_state(clearup,CU1+i))
			{
				cu_mode = i;
				break;
			}
		if (cu_window)
			clearup_windows(cu_mode, cu_width?cu_width2:0, cu_high?cu_high2:0);
		if (cu_icon)
			clearup_desktop();
	}
}

/***************************************************************************/
/* Autosave-Konfiguration																	*/
/***************************************************************************/

GLOBAL VOID autosave_dial(VOID)
{
	UBYTE	s[10];
	WORD	antw;
		
	set_state(autosave, ASTEXT, as_text);
	itoa(as_text_min, s, 10);
	set_ptext(autosave, ASTMIN, s);
	set_state(autosave, ASTASK, as_text_ask);

	set_state(autosave, ASPROJ, as_proj);
	itoa(as_proj_min, s, 10);
	set_ptext(autosave, ASPMIN, s);
	set_state(autosave, ASPASK, as_proj_ask);

	Arrow_mouse();
	antw = HndlDial(autosave, 0, FALSE, NULL, NULL);
	Last_mouse();
	if (antw == ASOK)
	{
		as_text = get_state(autosave, ASTEXT);
		get_ptext(autosave, ASTMIN, s);
		as_text_min = atoi(s);
		if (as_text_min < 1)
			as_text_min = 1;
		if (as_text_min > 59)
			as_text_min = 59;
		as_text_ask = get_state(autosave, ASTASK);

		as_proj = get_state(autosave, ASPROJ);
		get_ptext(autosave, ASPMIN, s);
		as_proj_min = atoi(s);
		if (as_proj_min < 1)
			as_proj_min = 1;
		if (as_proj_min > 59)
			as_proj_min = 59;
		as_proj_ask = get_state(autosave, ASPASK);

		do_all_icon(ALL_TYPES, DO_AUTOSAVE);
	}
}

/***************************************************************************/
/* Men-Verarbeitung 																		*/
/***************************************************************************/

LOCAL VOID multitest_action(SET icons, SET action)
{
	WORD	icp[MAX_ICON_ANZ], ic;
	SET	help;
	WORD	i;

	i = all_icons(icp);
	setclr(action);
	while ((--i)>=0)
	{
		ic = icp[i];
		if(setin(icons,ic))
		{
			Icon_exist(ic,help);
			setor(action,help);
		}
	}
}

GLOBAL VOID set_menu(WORD item, BOOLEAN yes)
{
	if (((menu[item].ob_state&DISABLED)==0)!=yes)
		menu_ienable (menu, item, yes);
}

GLOBAL VOID mark_menu(WORD item, BOOLEAN yes)
{
	if (((menu[item].ob_state&CHECKED)!=0)!=yes)
		menu_icheck (menu, item, yes);
}

GLOBAL VOID fillup_menu (WORD item, CONST UBYTE *new_text, WORD free)
{
	WORD	len, max_len;
	UBYTE *str;
	
	str = menu[item].ob_spec.free_string + free;
	len = (short) strlen(new_text);
	max_len = (short) strlen(str) - 4;		/* ' ?? ' Shortcut nicht berscrieben! */
	if (len > max_len)
		len = max_len;
	str = COPYB(str, new_text, len);
	len = max_len - len; 					/* Restlnge */
	while ((--len) >= 0)
		*str++ = ' ';
}


LOCAL VOID set_MCOPY(char *n)
{
	fillup_menu(MCOPY, n, 2);
	set_menu(MCOPY, TRUE);
}


VOID updt_menu (WINDOWP window)
{
	SET		all_actions;
	BOOLEAN	yes, is_text = FALSE;
	WORD		i, nr;

	setclr(all_actions);
	window = top();

	if (sel_window != NULL) /* Aktion fr selektierte Objekte */
	{
		if (sel_window->class == DESK)
			multitest_action(sel_objs,all_actions);
		else
		{
			Icon_exist(sel_window->link+SUB_ICON,all_actions);
		}
		mark_menu(MSEL,FALSE);
		set_menu(MSEL,FALSE);
		set_menu(MSETMARK,FALSE);
	}
	else			/* Aktionen fr oberstes Fenster */
	{
		if (window!=NULL)
			Icon_exist(window->link, all_actions);
		else
			Icon_exist(0,all_actions);

		if (window!=NULL && window->class == CLASS_EDIT && !(window->flags & WI_ICONIFIED))
		{
			TEXTP t_ptr = get_text(window->link);
			mark_menu(MSEL,t_ptr->blk_mark_mode);
			set_menu(MSEL,TRUE);
			set_menu(MSETMARK,TRUE);
			is_text = TRUE;
		}
		else
		{
			mark_menu(MSEL,FALSE);
			set_menu(MSEL,FALSE);
			set_menu(MSETMARK,FALSE);
		}
	}

	yes = (num_windows(NIL,SRCH_OPENED)>=3);	/* Desk + 2 Fenster */
	set_menu(MCYCLE, yes);
	mark_menu(MSMAKRO, makro_rec);

	for (i=DO_ANZ; (--i)>=0; )
	{
		nr = menu_nr[i];
		if (nr > -1)
			set_menu(nr,setin(all_actions,i));
	}
	if (setin(all_actions, DO_LINECOPY))
		set_MCOPY(strings(LCOPYSTR));
	else if (setin(all_actions, DO_COPY))
		set_MCOPY(strings(COPYSTR));

	setupShellMenu(is_text);		/* protokol.c */
} /* updt_menu */


/*
 * Alle Mentitel abschalten, nur die ACC bleiben aktiv.
 * Wird bei All-Iconify benutzt.
 */
VOID	enable_menu(BOOLEAN enable)
{
	WORD	titel;
	
	wind_update(BEG_UPDATE);
	titel = menu[THEFIRST].ob_next;
	while (titel != THEACTIVE)
	{
		if (enable)
			undo_state(menu, titel, DISABLED);
		else
			do_state(menu, titel, DISABLED);
		titel = menu[titel].ob_next;
	}
	if (enable)
		menu[THEACTIVE].ob_width = menu_width;
	else
	{
		if (menu[THEACTIVE].ob_width != menu[THEFIRST].ob_width)
		{
			menu_width = menu[THEACTIVE].ob_width;
			menu[THEACTIVE].ob_width = menu[THEFIRST].ob_width;
		}
	}
	/* About-Eintrag auch noch */
	menu_ienable(menu, MABOUT, enable);
	if (!mtos || (menu_bar(NULL, -1) == gl_apid))
		menu_bar(menu, TRUE);

	wind_update(END_UPDATE);
} /* enable_menu */

/*****************************************************************************/

LOCAL VOID do_multi_action(WORD action)
{
	WORD	icp[MAX_ICON_ANZ], ic;
	SET	sel_icons;
	WORD	i, anz;

	anz = all_icons(icp);
	setcpy(sel_icons, sel_objs);
	for (i=0; i<anz; i++)				/* In dieser Reihenfolge! */
	{
		ic = icp[i];
		if (setin (sel_icons, ic))
		{
			if (do_icon(ic,action)<0 && action==DO_OPEN)
			{
				note(1, NOWINDOW);
				break;
			}
		}
	}
}

VOID do_action(WORD action)
{
	if (sel_window!=NULL)
	{
		if (sel_window->class == DESK)
			do_multi_action(action);
		else
		{
			if (do_icon(sel_window->link+SUB_ICON,action)<0 && action==DO_OPEN)
				note(1, NOWINDOW);
		}
	}
	else
	{
		WINDOWP w = top();

		if (w!=NULL)
			do_icon(w->link,action);
		else
			do_icon(0,action);
	}
}


LOCAL VOID	menu_help(WORD title, WORD item)
{
	UBYTE help[128], *p1, str[128];

	/* Spezial-Flle: besonderer Text */
	if (item >= MMARKE1 && item <= MMARKE5)
		strcpy(str, "Marke anspringen");
	else if (item == MPROJEKT)
		strcpy(str, strings(DEFPRJSTR));
	else if (title == MSHELL)
		strcpy(str, "Shell");
	else
	{
		/* Spezial-Flle: Item ummappen */
		if (item == MOEINF)
			item = MOOVERW;

		/* die fhrenden '  ' berspringen und das letzte auch nicht */
		strcpy(help, menu[item].ob_spec.free_string);
		strncpy(str, help + 2, (short) strlen(help) - 3);
		p1 = strrchr(str, ' ');
		while (*(p1--) == ' ')	/* Leerzeichen weg */
			;		 
		*(p1+2) = EOS;
		if (str[strlen(str) - 1] == '.')		/* es folgen '...' */
			str[strlen(str) - 3] = EOS;
		call_hyp(str);
	}
	menu_ctrl = FALSE;
}


VOID hndl_menu (WINDOWP window, WORD title, WORD item)
{
	WINDP w;
	WORD	action, antw, anz;
	UBYTE str[10];

	if (menu_ctrl)
		menu_help(title, item);
	else
	{
		menu_normal (window, title, FALSE); 			/* Titel invers darstellen */
		action = -1;
		switch (item)
		{
			case MABOUT : 
				info_desktop();		/* Desktop */
				break;
			/* ==== Datei ==== */
			case MNEW	:
				if (global_shift)
					new_prj();			/* Neue Projektdatei anlegen */
				else
					new_edit(); 		/* Neue Textdatei anlegen */
				break;
			case MOPEN	 : 
				if (sel_window==NULL)
				{
					if (do_icon(idisk,DO_OPEN)<0)
						note(1, NOWINDOW);
				}
				else
					action = DO_OPEN;
				break;
			case MADD	: 
				action = DO_ADD;		
				break;
			case MCLOSE : 
				if (no_desktop)
					action = DO_DESTRUCT;
				else
					action = DO_CLOSE;
				break;
			case MCLEAR : 
				action = DO_CLEAR;	
				break;
			case MCYCLE : 
				cycle_window(); 
				break;
			case MSAVE: 
				action = DO_SAVE; 	
				break;
			case MSAVENEW: 
				action = DO_SAVENEW; 
				break;
			case MABAND : 
				action = DO_ABAND;	
				break;
			case MPRINT : 
				action = DO_PRINT;	
				break;
			case MINFO	 : 
				action = DO_INFO; 	
				break;
			case MQUIT2 : 
				quick_close = TRUE;
			case MQUIT : /* Desktop */
				if (Icon_test(0,DO_DESTRUCT))
				{
					/* Fenster ist danach weg */
					menu_normal (window, title, TRUE);
					Icon_edit(0,DO_DESTRUCT);
				}
				break;
			/* ==== Bearbeiten ==== */
			case MUNDO	 : 
				action = DO_UNDO; 		
				break;
			case MCUT	 : 
				action = DO_CUT;			
				break;
			case MCOPY	 : 
				w = top();
				if (w!=NULL && w->class==CLASS_EDIT)
				{
					TEXTP t_ptr = get_text(w->link);
					if (t_ptr->block)
						action = DO_COPY;
					else
						action = DO_LINECOPY;
				}
				break;
			case MPASTE : 
				action = DO_PASTE;		
				break;
			case MSEL	 : 
				w = top();
				if (w!=NULL && w->class==CLASS_EDIT)
				{
					TEXTP t_ptr = get_text(w->link);
					if (t_ptr->blk_mark_mode)
						t_ptr->blk_mark_mode = FALSE;
					else
					{
						blk_demark(t_ptr);
						restore_edit();
						blk_mark(t_ptr,0);
						t_ptr->blk_mark_mode = TRUE;
					}
				}
				break;
			case MSELALL : 
				action = DO_SELALL;		
				break;
			case MFORMAT :
				action = DO_FORMAT;		
				break;
			case MSWAP:
				action = DO_SWAPCHAR;
				break;
			case MLEFT	 : 
				if (global_shift)
					action = DO_ONE_LEFT;
				else
					action = DO_LEFT;
				break;
			case MRIGHT :
				if (global_shift)
					action = DO_ONE_RIGHT;
				else
					action = DO_RIGHT;
				break;
			case MSMALLBIG :
				action = DO_CHNG_SMBG;
				break;
			case MBIG:
				action = DO_SMALL2BIG;
				break;
			case MSMALL :
				action = DO_BIG2SMALL;
				break;
			case MCAPS:
				action = DO_CAPS;
				break;
			/* ==== Suchen ==== */
			case MFIND	 : 
				if (global_shift)
					do_icon(idisk, DO_FIND);
				else
					action = DO_FIND; 		
				break;
			case MFNDGOON: 
				action = DO_FINDNEXT;	
				break;
			case MGOTO	 : 
				action = DO_GOTO; 		
				break;
	/* 		case MGOBLKA:
				action = DO_GO_BLK_A;
				break;
			case MGOBLKE : 
				action = DO_GO_BLK_E;
				break;
	*/ 	case MSETMARK: 
				w = top();
				if (w!=NULL)
					config_marken(get_text(w->link));
				break;
			case MMARKE1 :
			case MMARKE2 :
			case MMARKE3 :
			case MMARKE4 :
			case MMARKE5 : 
				goto_marke(item-MMARKE1);
				break;
			/* ==== Spezial ==== */
			case MSRECORD: 
				if (makro_rec)
					end_rec(TRUE);
				else
					start_rec();
				break;
			case MSPLAY : 
				anz = 1;
				if (global_shift)
				{
					set_ptext(makrorep, MREPANZ, "");
					Arrow_mouse();
					antw = HndlDial (makrorep, MREPANZ, FALSE, NULL, NULL);
					Last_mouse();
					if (antw == MREPOK)
					{
						get_ptext(makrorep,MREPANZ,str);
						anz = atoi(str);
					}
					else
						break;
				}
				start_play(-1, anz);
				break;
			case MSMAKRO : 
				makro_dial();
				break;
			case MZEICHEN:
				action = DO_ZEICHTAB;
				break;
			case MUMLAUTE:
				action = DO_UMLAUT;
				break;
			case MSCLEAR : 
				mclearup();
				break;
			case MSCUT : 
				action = DO_CUTLINES;
				break;
			case MSTAB2LZ: 
				action = DO_TAB2LZ;
				break;
			case MSLZ2TAB: 
				action = DO_LZ2TAB;
				break;
			/* ==== Optionen ==== */
			case MOEINF:
				set_overwrite(FALSE);
				break;
			case MOOVERW:
				set_overwrite(TRUE);
				break;
			case MOFONT : 
				if (select_font(vdi_handle, WINFONT, extern_fontselect))
				{
					font_change();
					font_edit();
				}
				break;
			case MGLOBALO: 
				mglobalop();
				break;
			case MLOCALOP: 
				mlocalop();
				break;
			case MAUTOSAVE :
				autosave_dial();
				break;
	/* 	case MFEHLER:
				fehler_box();
				break;*/
			case MPROJEKT :
				open_def_prj();
				break;
			case MTAKEPRJ :
				add_to_def();				
				break;
			case MSOPTION: 
				if (option_save(TRUE)<0)
					note(1,WRITEERR);
				break;
			/* ==== Shell ==== */
			default:
				hndl_ESprotokol(item);
				break;
		}
		if (action!=-1)
			do_action(action);
	} /* if menu_ctrl */
	menu_normal (window, title, TRUE);	/* Titel wieder normal */
} /* hndl_menu */
