#ifndef _qed_obj_h_
#define _qed_obj_h_

VOID		fill_ptext	(OBJECT *tree, WORD obj, CONST UBYTE *s);
VOID		set_fstring	(OBJECT *tree, WORD obj, CONST UBYTE *s);
VOID		get_fstring	(OBJECT *tree, WORD obj, UBYTE *s);
VOID		hide_objc	(OBJECT *tree, WORD obj, BOOLEAN hide);
VOID		disable_objc(OBJECT *tree, WORD obj, BOOLEAN dis);
VOID		set_state	(OBJECT *tree, WORD obj, BOOLEAN sel);
BOOLEAN	get_state	(OBJECT *tree, WORD obj);

VOID		draw_Dial	(DIALINFO *d, WORD obj, WORD deep);
VOID		draw_Objc	(OBJECT *tree, WORD obj, WORD deep);


BOOLEAN	background		(OBJECT *tree, WORD obj, BOOLEAN get, MFDB *buffer, RECT *box);
/* nur noch fr Fenstermen!! */

WORD		find_xobj		(OBJECT *tree, WORD xtype);
/* 
 * Sucht im Baum das erste Objekt mit xType
 */

/*
 * Popup-Routinen: zur Laufzeit erstellter Objektbaum
 */
 
typedef struct _popup
{
	OBJECT	*tree;		/* der Objektbaum */
	WORD		max_item;	/* maximal mgliche Anzahl */
	WORD		akt_item;	/* aktuelle Anzahl */
	WORD		item_len;	/* Lnge eines Eintrages */
	WORD		first_item;	/* erster echter Meneintrag */
} POPUP;

EXTERN BOOLEAN	create_popup(POPUP *p, WORD anz, UBYTE *item, WORD len);
/*
 * Neues Popup anlegen. 
 *	p		: die Popup Variable
 *	anz	: die Anzahl der maximal mglichen Eintrge
 *	item	: der erste Eintrag
 * len	: maximal Lnge der Eintrge
 *
 * Rckgabe
 *	TRUE	: alles OK
 *	FALSE	: Zuwenig freier Speicher
 */

EXTERN BOOLEAN	free_popup(POPUP *p);
/*
 * Gibt den Speicher wieder frei.
 *	p		: das Popup
 *
 * Rckgabe
 *	TRUE	: alles OK
 *	FALSE	: `p` war schon gelscht
 */
 
EXTERN BOOLEAN	append_popup(POPUP *p, UBYTE *item);
/*
 * Eintrag am Ende anhngen.
 *	p		: das Popup
 *	item	: Eintrag, der am Ende angehngt werden soll. Wenn ein
 *		  	  Eintrag aus '-' besteht, wird er 'disabled' angezeigt.
 *
 * Rckgabe
 *	TRUE	: alles OK
 *	FALSE	: Kein Eintrag mehr frei
 */


/*
 * G_USERDEFs
 */

EXTERN BOOLEAN my_fix(OBJECT *tree);
/*
 * Anpassung der eigenen Objekttypen
 */

#endif
