#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "global.h"
#include "edit.h"
#include "icon.h"
#include "menu.h"
#include "obj.h"
#include "qed.h"
#include "rsc.h"
#include "scroll.h"
#include "text.h"
#include "windows.h"
#include "protokol.h"


/*
 * exportierte Variablen
 */
GLOBAL ShellEntry	SE_Shells[4];			/* 0 - 2 : QED sucht Shell */
													/* 3     : Shell sucht QED */

GLOBAL PATH			SE_Makefile;
GLOBAL BOOLEAN		SE_Activ;				/* haben wir Kontakt zur Shell? */


typedef struct _separm
{
		WORD		id;
		WORD		shellCmd;
		WORD		editCmd;
} SEPARMS;


#define WAITTIME	2000				/* Zeit, die QED auf ein SE_ACK wartet */

LOCAL UBYTE 	*global_str;		/* 256 Byte globaler Platz */
LOCAL SEPARMS	shellParm,
					editParm;
LOCAL WORD		msgbuff[8];			/* Buffer zum Senden! */
LOCAL WORD		aktiv;				/* Nummer der aktiven Shell (0..3) */
LOCAL	WINDOWP	wd = (WINDOWP)NIL;	/* Dummy-Var., wird fr updt_menu bentigt */
LOCAL WORD		menu_len;

/* lokale Prototypen */
LOCAL BOOLEAN	waitAck(VOID);
LOCAL VOID		sendOK(VOID);
LOCAL VOID		sendACK(BOOLEAN ok);
LOCAL VOID		sendCmd(WORD cmd, WORD bit);
LOCAL BOOLEAN	sendMsg(WORD id);

/******************************************************************************/

LOCAL BOOLEAN	sendMsg(WORD id)
{
	WORD	ret;
	
	ret = appl_write(id, (short) sizeof(msgbuff), msgbuff);
	return (ret > 0);
}

LOCAL VOID	setupMakefile(VOID)
{
	FILENAME	n = "";

	if (SE_Makefile[0] == EOS)
		strcpy(n, strings(SEMAKESTR));		
	else
		file_name(SE_Makefile, n);
	fillup_menu(MSMAKEFILE, n, 2);
}


LOCAL	VOID setTitel(UBYTE *titel)
{
	UBYTE	str[11] = " ";

	strcat(str, titel);
	strcat(str, " ");
	menu_bar(menu, 0);
	menu[2].ob_width = menu_len + (short)strlen(str) * sys_wchar;
	menu[MSHELL].ob_width = (short)strlen(str) * sys_wchar;
	strcpy(menu[MSHELL].ob_spec.free_string, str);
	menu_bar(menu, 1);
}

GLOBAL VOID	setupShellMenu(BOOLEAN text_win)
{
	WORD	i;
	
	if (SE_Activ)
	{
		setupMakefile();
		set_menu(MSMAKEFILE, (shellParm.editCmd & _ESMAKE));
		set_menu(MSCOMP, ((shellParm.editCmd & _ESCOMPILE) && text_win));
		set_menu(MSMAKE, (shellParm.editCmd & _ESMAKE));
		set_menu(MSMAKEALL, (shellParm.editCmd & _ESMAKEALL));
		set_menu(MSLINK, ((shellParm.editCmd & _ESLINK) && text_win));
		set_menu(MSEXEC, ((shellParm.editCmd & _ESEXEC) && text_win));
		set_menu(MSMAKEEXEC, (shellParm.editCmd & _ESMAKEEXEC));
	}
	else
	{													/* SE beendet, alles aus */
		for (i = MSMAKEFILE; i <= MSMAKEEXEC; i++)
			set_menu(i, FALSE);
	}
}


LOCAL BOOLEAN	waitAck(VOID)
{
	WORD	msg[8], d, ev;

	while (TRUE)
	{
		ev = evnt_multi ((MU_MESAG | MU_TIMER),
								0, 0, 0,	0, 0, 0, 0, 0,
								0, 0, 0, 0, 0,
								msg, WAITTIME, 0,
								&d, &d, &d, &d, &d, &d);
		if (ev == MU_TIMER)
		{
			SE_Activ = FALSE;
			setTitel("Shell");
			updt_menu(wd);
			return FALSE;
		}
		else if (ev == MU_MESAG)
			if (msg[0] == SE_ACK)
			{
				return TRUE;
			}
	}		
}


LOCAL BOOLEAN	waitSEOK(VOID)
{
	WORD	msg[8], d, ev;

	while (TRUE)
	{
		ev = evnt_multi ((MU_MESAG | MU_TIMER),
								0, 0, 0,	0, 0, 0, 0, 0,
								0, 0, 0, 0, 0,
								msg, WAITTIME, 0,
								&d, &d, &d, &d, &d, &d);
		if (ev == MU_TIMER)
			return FALSE;
		else if (ev == MU_MESAG)
			if (msg[0] == SE_OK)
			{
				shellParm.id 		 = msg[1];
				shellParm.shellCmd = msg[3];
				shellParm.editCmd  = msg[5];
				SE_Activ = TRUE;
				setTitel(SE_Shells[aktiv].Name);
				updt_menu(wd);
				return TRUE;
			}
	}		
}

/******************************************************************************/
/* 	Shell -> Editor																			*/
/******************************************************************************/

/* Antwort auf SE_INIT */				
LOCAL VOID	sendOK(VOID)
{
	if (shellParm.editCmd & _ESOK)
	{
		msgbuff[0] = ES_OK;
		msgbuff[1] = editParm.id;
		msgbuff[2] = 0;
		msgbuff[3] = editParm.shellCmd;
		msgbuff[5] = editParm.editCmd;
		msgbuff[6] = SEPROTOVERSION;
		msgbuff[7] = shellParm.id;
		sendMsg(shellParm.id);
	}
}


LOCAL VOID	sendACK(BOOLEAN ok)
{
	if (shellParm.editCmd & _ESACK)
	{
		msgbuff[0] = ES_ACK;
		msgbuff[1] = editParm.id;
		msgbuff[2] = 0;
		msgbuff[3] = ok;
		sendMsg(shellParm.id);
	}
}


GLOBAL VOID	hndl_SEprotokol(WORD *msg)
{
	UBYTE 	datei[255], fehler[255], str[9];
	WORD		icon;
	ERRINFO	*error;
	
	switch (msg[0])
	{
		case SE_INIT :
			shellParm.id = msg[1];
			shellParm.shellCmd = msg[3];
			shellParm.editCmd  = msg[5];
			sendOK();
			SE_Activ = TRUE;
			aktiv = 3;

			/* Wir versuchen den GEM-Namen des Senders zu ermitteln */
			if (magx)
			{
				sprintf(str, "? %cXXXXX", (char) shellParm.id);
				str[1] = '\0';
				appl_find(str);
				strcpy(SE_Shells[aktiv].Name, str);
			}
			else if (mtos)
			{
				WORD	type, id, i;

				i = appl_search( 0, str, &type, &id);
				while (i != 0)
				{ 
					if (type == 2 && id == shellParm.id)
						break;
			      i = appl_search( 1, str, &type, &id); 
				}
				strcpy(SE_Shells[aktiv].Name, str);
			}
			else
				strcpy(str, "Shell");
			setTitel(str);
			updt_menu(wd);
			break;
		case SE_OPEN :
			strcpy(datei, *(UBYTE **)(msg + 3));
			sendACK(TRUE);
			icon = load_edit(datei, FALSE, -1, -1, NULL);
			if (icon > 0)
				do_icon(icon, DO_OPEN);
			break;
		case SE_ERROR :
			error = *(ERRINFO **)(msg + 3);
			strcpy(datei, error->errFile);
			strcpy(fehler, error->errMess);
			desire_x = error->errRow - 1;
			desire_y = error->errLine - 1;
			sendACK(TRUE);
			icon = load_edit(datei, FALSE, -1, -1, NULL);
			if (icon > 0)
			{
				TEXTP t_ptr;

				t_ptr = get_text(icon);
				strcpy(t_ptr->m2_err_str, fehler);
				do_icon(icon, DO_OPEN);
				Icon_edit(icon, DO_GOTO);
			}
			break;
		case SE_ERRFILE :
			strcpy(datei, *(UBYTE **)(msg + 5));
			strcpy(fehler, *(UBYTE **)(msg + 3));	/* Fehlerdatei */
			sendACK(TRUE);
			icon = load_edit(datei, FALSE, -1, -1, NULL);
			if (icon > 0)
				do_icon(icon, DO_OPEN);
			icon = load_edit(fehler, FALSE, -1, -1, NULL);
			if (icon > 0)
				do_icon(icon, DO_ABAND);
			break;
		case SE_QUIT :
			SE_Activ = FALSE;
			setTitel("Shell");
			updt_menu(wd);
			note(1, SECLOSE);
			break;
		case SE_ACK :
			/* Shell hat besttigt. Toll. */
			break;
		default:
			inote(1, SEUNKNOWN, msg[0]);
			break;
	} /* switch */
}


/******************************************************************************/
/* 	Editor -> Shell																			*/
/******************************************************************************/


LOCAL VOID	sendESQUIT(VOID)
{
	msgbuff[0] = ES_QUIT;
	msgbuff[1] = editParm.id;
	msgbuff[2] = 0;
	(VOID) sendMsg(shellParm.id);
	SE_Activ = FALSE;
}


LOCAL VOID	sendCmd(WORD cmd, WORD bit)
{
	if (shellParm.editCmd & bit)
	{
		msgbuff[0] = cmd;
		msgbuff[1] = editParm.id;
		msgbuff[2] = 0;
		if (global_str[0] != EOS)
	  		*(UBYTE **) &msgbuff[3] = global_str;
	  	else
	  		*(UBYTE **) &msgbuff[3] = NULL;
		if (!sendMsg(shellParm.id))
		{
			SE_Activ = FALSE;
			setTitel("Shell");
			updt_menu(wd);
			note(1, SENOANS);
			return;
		}
		if (!waitAck())
			note(1, SENOANS);
	}
}


LOCAL BOOLEAN	get_filename(VOID)
{
	WINDOWP	window;
	TEXTP		t_ptr;

	window = top();
	if (window != NULL && window->class == CLASS_EDIT)
	{
		t_ptr = get_text(window->link);
		strcpy(global_str, t_ptr->filename);
		return TRUE;
	}
	else
		return FALSE;
}


LOCAL VOID	suchShell(VOID)
{
	WORD		erg, len, i;
	UBYTE		name[9];
	
	for (i = 0; i < 3; i++)	
	{
		set_ptext(suchshell, SENAME1 + i, SE_Shells[i].Name);
		set_state(suchshell, SEUSE1 + i, SE_Shells[i].aktiv);
	}
	erg = HndlDial(suchshell, SENAME1, TRUE, NULL, NULL);
	if (erg == SSOK)
	{
		if (SE_Activ)
		{
			erg = note(2, SEONLINE);
			if (erg == 2)
				return ;
			else
			{
				sendESQUIT();
				setTitel("Shell");
			}
		}
		
		for (i = 0; i < 3; i++)	
		{
			get_ptext(suchshell, SENAME1 + i, SE_Shells[i].Name);
			SE_Shells[i].aktiv = get_state(suchshell, SEUSE1 + i);
			if (SE_Shells[i].aktiv)
			{
				aktiv = i;
				strcpy(name, SE_Shells[aktiv].Name);
			}
		}
		
		if (name[0] != EOS)
		{
				len = (short) strlen(name);
				if (len < 8)					/* mit ' ' auffllen */
					for (i = len; i < 8; i++)
						strcat(name, " ");
				i = appl_find(name);
				if (i < 0) 
				{
					note(1, SENOTFOUND);
					SE_Activ = FALSE;
					setTitel("Shell");
					updt_menu(wd);
					return ;
				}
				msgbuff[0] = ES_INIT;
				msgbuff[1] = editParm.id;
				msgbuff[2] = 0;
				msgbuff[3] = editParm.shellCmd;
				msgbuff[4] = 0;
				msgbuff[5] = editParm.editCmd;
				sendMsg(i);
				if (!waitSEOK())
					note(1, SENOANS);
		}
		else
					note(1, SENONAME);
	}
}


GLOBAL VOID	hndl_ESprotokol(WORD item)
{
	FSEL		fsel = {"", "*.*"};
	PATH		name = "";
	FILENAME	n = "";


	if (item == MSSUCH)
		suchShell();

	if (!SE_Activ)
		return ;

	switch (item)
	{
		case MSMAKEFILE:
			if (global_shift && SE_Makefile[0] != EOS)	/* Makefile lschen */
			{
				SE_Makefile[0] = EOS;
				updt_menu(wd);
				break;
			}
			if (SE_Makefile[0] != EOS)
				file_name(SE_Makefile, n);
			strcpy(fsel.name, n);
			if (select_file(&fsel, name, strings(FINDMKSTR)))
			{
				strcpy(SE_Makefile, name);
				setupMakefile();
				sendCmd(ES_PROJECT, _ESPROJECT);
			}
			break;
		case MSCOMP :
			if (get_filename())
				sendCmd(ES_COMPILE, _ESCOMPILE);
			break;
		case MSMAKE :
			strcpy(global_str, SE_Makefile);
			sendCmd(ES_MAKE, _ESMAKE);
			break;
		case MSMAKEALL :
			strcpy(global_str, SE_Makefile);
			sendCmd(ES_MAKEALL, _ESMAKEALL);
			break;
		case MSLINK :
			if (get_filename())
				sendCmd(ES_LINK, _ESLINK);
			break;
		case MSEXEC :
			if (get_filename())
				sendCmd(ES_EXEC, _ESEXEC);
			break;
		case MSMAKEEXEC :
			strcpy(global_str, SE_Makefile);
			sendCmd(ES_MAKEEXEC, _ESMAKEEXEC);
			break;
	} /* switch */
}

/******************************************************************************/

GLOBAL VOID	term_seprotokol(VOID)
{
	if (SE_Activ && (shellParm.editCmd & _ESQUIT))
		sendESQUIT();
	Mfree(global_str);
}

GLOBAL VOID	init_seprotokol(VOID)
{
	LONG	ret;

	SE_Activ	= FALSE;
	menu_len = menu[2].ob_width - menu[MSHELL].ob_width;
	setTitel("Shell");
	
	shellParm.id		 = -1;
	shellParm.shellCmd = 0;
	shellParm.editCmd  = 0;
		
	editParm.id 		 = gl_apid;
	editParm.shellCmd  = (_SEINIT|_SEOK|_SEACK|_SEQUIT|_SEOPEN|_SEERROR|_SEERRFILE);
	editParm.editCmd	 = (_ESINIT|_ESOK|_ESACK|_ESQUIT|_ESCOMPILE|_ESLINK|_ESMAKE|_ESEXEC);

	ret = (LONG) Mxalloc(256, 0x40);
	if (ret == -32L)				/* kein Mxalloc */
		ret = (LONG) Malloc(256);
	if (ret != 0L)
		global_str = (UBYTE *)ret; 
	
	setupMakefile();
}
