/***************************************************************************/
/*																									*/
/* Modul: RSC.C																				*/
/*																									*/
/***************************************************************************/

#include <stdlib.h>
#include <string.h>
#include <vdi.h>
#include <nkcc.h>

#include "global.h"
#include "fontsel.h"
#include "obj.h"
#include "scroll.h"
#include "rsc.h"

/* 
 * exportierte Variablen
 */
OBJECT 	*menu;
OBJECT 	*desktop;
OBJECT 	*about;
OBJECT 	*share;
OBJECT 	*printer;
OBJECT 	*textinfo;
OBJECT 	*diskinfo;
OBJECT 	*prjinfo;
OBJECT	*blockinfo;
OBJECT 	*find;
OBJECT 	*replace;
OBJECT 	*diskfind;
OBJECT 	*pos;
OBJECT 	*marken;
OBJECT 	*funktionstasten;
OBJECT 	*makrorep;
OBJECT	*zeichentab;
OBJECT	*umlautkonv;
OBJECT 	*clearup;
OBJECT 	*fontsel;
OBJECT 	*globalop;
OBJECT 	*localop;
OBJECT 	*muster;
OBJECT 	*musterchg;
OBJECT	*autosave;
OBJECT	*fehler;
OBJECT	*suchshell;

OBJECT 	*aktion;
OBJECT 	*prjscan;
OBJECT 	*icons;
OBJECT 	*winicon;

OBJECT 	*fhilfe;
OBJECT 	*rphilfe;
OBJECT 	*dfhilfe;
OBJECT 	*popups;
OBJECT 	*strings;

UBYTE		**alertmsg;
UBYTE		**copy_str;

ICONBLK	iconblk[MAX_ICON_ANZ];
WORD		max_icon_anz;

/****** DEFINES ************************************************************/

/****** TYPES **************************************************************/

/****** VARIABLES **********************************************************/

LOCAL	OBBLK		usr_block[1500];	

LOCAL	OBJECT	*setup;
LOCAL BOOLEAN	dial3D;

/***************************************************************************/
/* Initialisieren des Moduls																*/
/***************************************************************************/

BOOLEAN init_resource (VOID)
{
	UBYTE		*str;
	WORD		x, y, w, h;
	OBJECT	*ptr;
	
	if (!rsrc_load ("qed.rsc"))
	{
		UBYTE	*str, *ptr;
		PATH	s;
		
		str = getenv("QED");			/* ENV-Var */
		if (str != NULL)
		{
			WORD i;

			strcpy(s, str);
			i = (short) strlen(s);
			if (s[i-1]!='\\')
			{
				s[i] = '\\';
				s[i+1] = EOS;
			}
			if (make_normalpath(s,FALSE))
			{
				strcat(s,"qed.rsc");
				if (file_exist(s))
					if (rsrc_load (s)) 
						goto erfolg;
			}
		}
		str = getenv("PATH");
		if (str!=NULL)
		{
			while (TRUE)
			{
				ptr = strchr(str,',');
				if (ptr!=NULL)
					*(UBYTE*)COPYB(s,str, (short)(ptr-str)) = EOS;
				else
					strcpy(s,str);
				
				if (make_normalpath(s,FALSE))
				{
					strcat(s,"qed.rsc");
					if (file_exist(s))
					{
						if (rsrc_load (s)) goto erfolg;
					}
				}
				if (ptr==NULL) break;
				str = ptr+1;
			}
		}
		form_alert (1, "[3][Resource-File|QED.RSC?][ EXIT ]");
		return (FALSE);
	}
erfolg:

	rsrc_gaddr (R_TREE, SETUP,		&setup);
	dial3D = get_state(setup, SETUP3D);
	
	rsrc_gaddr (R_FRSTR, NOWINDOW,&alertmsg);

	rsrc_gaddr (R_TREE, MENUTREE,	&menu);
	rsrc_gaddr (R_TREE, ABOUT,		&about);
	rsrc_gaddr (R_TREE, SHARE,		&share);
	rsrc_gaddr (R_TREE, FIND,		&find);
	rsrc_gaddr (R_TREE, REPLACE,	&replace);
	rsrc_gaddr (R_TREE, LOCALOP,	&localop);
	rsrc_gaddr (R_TREE, GLOBALOP,	&globalop);
	rsrc_gaddr (R_TREE, POS,		&pos);
	rsrc_gaddr (R_TREE, PRINTER,	&printer);
	rsrc_gaddr (R_TREE, TEXTINFO,	&textinfo);
	rsrc_gaddr (R_TREE, DESKTOP,	&desktop);
	rsrc_gaddr (R_TREE, FONT,		&fontsel);
	rsrc_gaddr (R_TREE, AKTION,	&aktion);
	rsrc_gaddr (R_TREE, FUNKTION,	&funktionstasten);
	rsrc_gaddr (R_TREE, DISKFIND,	&diskfind);
	rsrc_gaddr (R_TREE, ICONS,		&icons);
	rsrc_gaddr (R_TREE, WINICON,	&winicon);
	rsrc_gaddr (R_TREE, FHILFE,	&fhilfe);
	rsrc_gaddr (R_TREE, CLEARUP,	&clearup);
	rsrc_gaddr (R_TREE, PRJINFO,	&prjinfo);
	rsrc_gaddr (R_TREE, PRJSCAN,	&prjscan);
	rsrc_gaddr (R_TREE, RPHILFE,	&rphilfe);
	rsrc_gaddr (R_TREE, DISKINFOS,	&diskinfo);
	rsrc_gaddr (R_TREE, MARKEN,	&marken);
	rsrc_gaddr (R_TREE, DFHILFE,	&dfhilfe);
	rsrc_gaddr (R_TREE, POPUPS,	&popups);
	rsrc_gaddr (R_TREE, MUSTER,	&muster);
	rsrc_gaddr (R_TREE, MUSTERCH, &musterchg);
	rsrc_gaddr (R_TREE, MAKROREP, &makrorep);
	rsrc_gaddr (R_TREE, ZEICHENSATZ, &zeichentab);
	rsrc_gaddr (R_TREE, UMLAUTE, 		&umlautkonv);
	rsrc_gaddr (R_TREE, BLOCKINFO, &blockinfo);
	rsrc_gaddr (R_TREE, AUTOSAVE,  &autosave);
	rsrc_gaddr (R_TREE, FEHLER, 	 &fehler);
	rsrc_gaddr (R_TREE, SUCHSHELL, &suchshell);
	rsrc_gaddr (R_TREE, STRINGS,    &strings);	

	nkc_init(NKI_NO200HZ, 0, 0);
	dial_init(malloc, free, NULL, NULL, NULL, dial3D, usr_block, 1000);
	
	dial_fix (menu, FALSE);
	dial_fix (about, TRUE);
	dial_fix (share, TRUE);
	dial_fix (find, TRUE);
	dial_fix (replace,TRUE);
	dial_fix (globalop,TRUE);
	dial_fix (localop,TRUE);
	dial_fix (pos,TRUE);
	dial_fix (printer,TRUE);
	dial_fix (textinfo,TRUE);
	dial_fix (desktop,FALSE);
	dial_fix (fontsel,TRUE);
	dial_fix (aktion,TRUE);
	dial_fix (funktionstasten, TRUE);
	dial_fix (diskfind,TRUE);
	dial_fix (fhilfe,TRUE);
	dial_fix (clearup,TRUE);
	dial_fix (prjinfo,TRUE);
	dial_fix (prjscan,TRUE);
	dial_fix (rphilfe,TRUE);
	dial_fix (diskinfo,TRUE);
	dial_fix (marken,TRUE);
	dial_fix (dfhilfe,TRUE);
	dial_fix (popups, TRUE);
	dial_fix (muster,TRUE);
	dial_fix (musterchg,TRUE);
	dial_fix (makrorep,TRUE);
	dial_fix (zeichentab, TRUE);
	dial_fix (umlautkonv, TRUE);
	dial_fix (blockinfo, TRUE);
	dial_fix (fehler, TRUE);
	dial_fix (icons,TRUE);
	dial_fix (winicon,TRUE);
	dial_fix (suchshell, TRUE);
	dial_fix (autosave, TRUE);

	/* Da man '@' mit Interface nicht eintragen kann: */
	str = (UBYTE *) get_obspec(zeichentab, ZEICHEN64);
	strcpy(str, "@");

	/* VDI-Objekte initialisieren */
	my_fix(zeichentab);
					
	desktop->ob_x = 0;
	desktop->ob_y = 0;
	if (desk.x+desk.w > desktop->ob_width)		/* Falls Desktop breiter Objektbreite */
		desktop->ob_width = desk.x+desk.w;		/* Groe Bildschirme */
	if (desk.y+desk.h > desktop->ob_height)	/* Falls Desktop hher Objekthhe */
		desktop->ob_height = desk.y+desk.h;		/* Groe Bildschirme */

	desktop[FKEYS].ob_y = desk.y+desk.h-desktop[FKEYS].ob_height-5;
	desktop[FKEYS].ob_x = (desk.w-desktop[FKEYS].ob_width)>>1;

	max_icon_anz = 0;
	w = (icons[IDISK].ob_width+7)&(~7);
	h = icons[IDISK].ob_height;
	x = 0;
	y = h;
	for (ptr=desktop+IICON; TRUE; ptr++)
	{
		if (max_icon_anz==MAX_ICON_ANZ)
		{
			inote(1,FATALERR,3);
			break;
		}
		ptr->ob_type  = G_ICON;
		ptr->ob_flags |= HIDETREE;
		iconblk[max_icon_anz].ib_ptext = ptr->ob_spec.free_string;
		ptr->ob_spec.iconblk = &iconblk[max_icon_anz++];
		ptr->ob_x = x;
		ptr->ob_y = y;
		x += w;
		if (x+w>=desktop->ob_width)
		{
			x = 0;
			y += h;
		}
		if (ptr->ob_flags&LASTOB) break;
	}
	return (TRUE);
} /* init_resource */

/*****************************************************************************/
/* Terminieren des Moduls																										*/
/*****************************************************************************/

VOID term_resource (VOID)
{
	dial_exit();
	nkc_exit();
	rsrc_free();								/* Resourcen freigeben */
} /* term_resource */
