#ifndef _qed_text_h_
#define _qed_text_h_

#include "memory.h"

typedef struct text
{
	WORD				link;
	struct text 	*next;
	RING				text;					/* Der Text */
	LONG				file_date_time;	/* Datei-Datum und Zeit */
	LINEP				cursor_line;      /* zeigt auf aktuellen Textzeile */
	WORD				xpos;            	/* x-Position des Cursors im Text */
	LONG				ypos;					/* y-Position des Cursors im Text */
	LONG				moved;				/* Text wurde seit letztem Sichern verndert */
	LINEP				p1,p2;				/* Zeiger fr Block */
	LONG				z1,z2;				/* ZeilenNr. fr p1 und p2 */
	WORD				x1,x2;				/* X-Pos fr Block-Anfang und Ende */
	BOOLEAN			cursor;				/* Cursor anzeigen */
	BOOLEAN			block;				/* Es gibt einen Block */
	BOOLEAN			blink;				/* Cursor ist gerade wg. Blinken aus */
	BOOLEAN			block_dir;			/* Blockrichtung laut Eingabe */
	BOOLEAN			up_down;				/* War letzte Operation Up oder Down */
	BOOLEAN			blk_mark_mode;		/* Block wird durch Cursor aufgezogen */
	BOOLEAN			cr_lf;				/* Zeilenende mit CR/LF oder nur LF */
	BOOLEAN			readonly;			/* Datei auf Disk schreibgeschtzt */
	WORD				desire_x;			/* Fr UP und DOWN in [TASTEN] */
	UBYTE				m2_err_str[80];	/* Fehlertext vom M2-Compiler (Thomas Tempelmann) */
	PATH				filename;			/* Name der Datei */
	BOOLEAN			namenlos;			/* Datei hat noch keinen Name */
	BOOLEAN			edit_change;		/* Wurde ber change_edit-Protokoll gestartet */
	SET				edit_change_set;	/* IDs der Programme, die benachrichtigt werden */
	LOC_OPTP			loc_opt;				/* Zeiger auf lokalen Optionen */
	WORD				count;				/* intern: letzter Autosave (min) */
} TEXT_INF, *TEXTP;


TEXTP	get_text			(WORD link);
TEXTP	new_text			(WORD link);
VOID	clear_text		(TEXTP t_ptr);
VOID	destruct_text	(TEXTP t_ptr);
VOID	set_text_name	(TEXTP t_ptr, CONST UBYTE *filename, BOOLEAN namenlos);
VOID	update_loc_opt	(VOID);

VOID	init_text		(VOID);

#endif
