/***************************************************************************/
/*																									*/
/* Modul: WINDOWS.C																			*/
/*																									*/
/***************************************************************************/
#include <string.h>	/* strcpy, strcat */
#include <stdlib.h>
#include <vdi.h>
#include <nkcc.h>

#include "global.h"
#include "desktop.h"	/* move_icon_to */
#include "event.h"	/* idle */
#include "icon.h"
#include "makro.h"
#include "menu.h"
#include "obj.h"
#include "qed.h"
#include "rsc.h"		/* menu */
#include "scroll.h"	/* COPYW */
#include "set.h"

#include "windows.h"


VOID	clr_undo		(VOID);		/* aus CLIPBRD.H */
VOID	cursor_on	(WORD wHandle);	/* aus edit.h */

/*
 * exportierte Variablen
 */

WINDP 	sel_window;		/* Zeiger auf selektiertes Fenster */
SET		sel_objs;		/* Menge selektierter Objekte */
BOOLEAN	all_iconified;	
BOOLEAN	do_open = FALSE;	/* fr all-iconify */

/****** DEFINES ************************************************************/

#define MIN_WIDTH		(8 * sys_wchar)			/* Kleinste Breite */
#define MIN_HEIGHT 	(8 * sys_hchar)			/* Kleinste Hhe */

#define M_LTARROW	1				/* Menpfeil links */
#define M_RTARROW	2				/* Menpfeil rechts */

#define WORK_MOVED	0x01				/* Fr Verschieben und Vergrern */
#define WORK_SIZED	0x02

#define MAX_WINDOW 	19

/****** TYPES **************************************************************/

/****** VARIABLES **********************************************************/

LOCAL WINDOW	windrec[MAX_WINDOW];			/* Speicher fr Fenster */

LOCAL WORD	menu_offset;				/* X-Offset Menzeile */
LOCAL RECT	border;					/* fr rc_first/next */

LOCAL WINDP	free_list;				/* ROOT der unbenutzten Fenster */
LOCAL WINDP	used_list;				/* ROOT der benutzten Fenster */
LOCAL WORD	age, top_handle;

LOCAL OBJECT arrows[3] =
{
 -1,	1,  2, G_BOX,	 	NONE,	  NORMAL, 0x1100L,	   0, 0, 772,513,
  2, -1, -1, G_BOXCHAR,	NONE,	  NORMAL, 0x4FF1100L,	0, 0, 258,513,
  0, -1, -1, G_BOXCHAR,	LASTOB, NORMAL, 0x3FF1100L, 514, 0, 258,513
};

LOCAL WINDP	icon_win;
LOCAL WORD	opened_win[MAX_WINDOW];	/* Iconnummer der offen gewesenen Fenster 
												 * [0] enthlt die Anzahl !!
												 */
/****** FUNCTIONS **********************************************************/

LOCAL VOID move_to_top	(WINDP window);
LOCAL VOID move_to_end	(WINDP window);
LOCAL VOID just_menu		(WINDP window);
LOCAL VOID get_work		(WINDP window, RECT *new, WORD mode);
LOCAL VOID do_arrow		(WINDP window, WORD dir, long delta);
LOCAL VOID draw_box		(CONST RECT *box, WORD x_offset, WORD y_offset);
LOCAL VOID check_drag	(WORD x_offset, WORD y_offset, CONST RECT *bound, CONST RECT *inner, RECT *diff);
LOCAL VOID draw_all		(WORD num_boxes, CONST RECT *boxes, WORD x_offset, WORD y_offset);
LOCAL VOID default_snap	(WINDP window, RECT *new, WORD mode);
LOCAL VOID draw_mtitle 	(WINDP window, WORD title);
LOCAL VOID draw_mbar		(WINDP window, CONST RECT *d);
LOCAL VOID hndl_mscroll	(WINDP window, WORD obj, WORD breturn);
LOCAL VOID fix_menu		(WINDP window);

/***************************************************************************/

VOID add_windinfo(WORD class, RECT *r, WORD icon_x, WORD icon_y, WORD init)
{
	WORD i;
	WINDP window;

	switch (class)
	{
		case 2 : class = CLASS_EDIT; break;
		case 3 : class = CLASS_CLIP; break;
		case 4 : class = CLASS_PROJEKT; break;
		case 5 : class = CLASS_TRASH; break;
		default: return;
	}
	for (i=MAX_WINDOW,window=windrec; (--i)>=0; window++)
	{
		if (r==NULL)						/* Nur Iconpos setzen */
		{
			if (window->icon_x==0 && window->icon_y==0 &&
				 window->class==class)			/* Ohne Iconpos */
			{
				window->icon_x = icon_x;
				window->icon_y = icon_y;
				break;
			}
		}
		else
		{
			if (window->work.w==0)				/* Ohne Info */
			{
				window->class = class;
				window->work = *r;
				window->icon_x = icon_x;
				window->icon_y = icon_y;
				window->init = init;
				break;
			}
		}
	}
}

BOOLEAN get_windinfo(WORD *last, WORD *class, RECT *r, WORD *icon_x, 
                  WORD *icon_y, WORD *used)
{
	WORD	i, nr;
	WINDP window;

	i = *last+1;
	if (i>=age) return FALSE;
retry:
   *used = 0;
   nr = 1;
	for (window=free_list; window!=NULL && window->age!=i; window=window->next) ;
	if (window==NULL)
	{
		for (window=used_list; window!=NULL && window->age!=i; window=window->next,nr++) ;
		if (window!=NULL)
		{
			*used = nr;
		}
	}
	if (window==NULL || window->class==DESK || window->work.w==0)
	{
		i++;
		if (i==age) 
			return FALSE;
		goto retry;
	}

	*r = window->work;
	*icon_x = window->icon_x;
	*icon_y = window->icon_y;
	switch (window->class)
	{
		case CLASS_EDIT : *class = 2; break;
		case CLASS_CLIP : *class = 3; break;
		case CLASS_PROJEKT:*class = 4; break;
		case CLASS_TRASH: *class = 5; break;
	}
	*last = i;
	return TRUE;
}

BOOLEAN rc_first(WORD wh, CONST RECT *b, RECT *r)
{
	border = *b;
	if (!rc_intersect(&desk,&border))			/* mit Bildschirm schneiden */
		return FALSE;
	wind_get (wh, WF_FIRSTXYWH, &r->x, &r->y, &r->w, &r->h);
	while (r->w && r->h)
	{
		if (rc_intersect (&border, r))			/* Schneide Rechtecke */
			return TRUE;
		wind_get (wh, WF_NEXTXYWH, &r->x, &r->y, &r->w, &r->h);
	}
	return FALSE;
}

BOOLEAN rc_next(WORD wh, RECT *r)
{
	wind_get (wh, WF_NEXTXYWH, &r->x, &r->y, &r->w, &r->h);
	while (r->w && r->h)
	{
		if (rc_intersect (&border, r))			/* Schneide Rechtecke */
			return TRUE;
		wind_get (wh, WF_NEXTXYWH, &r->x, &r->y, &r->w, &r->h);
	}
	return FALSE;
}

/************************************************************************/
/* Suche nach Fenster 							*/
/************************************************************************/

WINDP get_window (WORD link)
{
	WINDP w;

	for (w=used_list; w!=NULL ; w=w->next)
	{
		if (link==w->link) return (w);
	}
	return (NULL);
} /* get_window */

/***************************************************************************/
/* Suche Fenster von Fenster-Handle														*/
/***************************************************************************/

WINDP find_window (WORD wh)
{
	WINDP w;

	for (w=used_list; w!=NULL; w=w->next)
	{
		if (wh==w->handle) return (w);
	}
	return (NULL);
} /* find_window */

/***************************************************************************/
/* Suche oberstes Fenster																	*/
/***************************************************************************/

WINDP top (VOID)
{
	WINDP w;

	for (w=used_list; w!=NULL && w->opened; w=w->next)
		return w;
	return NULL;
}

VOID get_realtop(VOID)
{
	wind_get (0, WF_TOP, &top_handle);
}

WINDP real_top (VOID)
{
	WINDP	window;

	window = top();
	if (window==NULL) return NULL;
	return ((window->handle==top_handle) ? window : NULL);
}

BOOLEAN free_for_draw(WINDP window)
{
	RECT draw;

	if (rc_first(window->handle, &window->work, &draw))
	{
		if (window->work.w==draw.w && window->work.h==draw.h)
			return TRUE;
	}
	return FALSE;
}

/***************************************************************************/
/* Zhle Anzahl vorhandener Fenster einer Klasse									*/
/***************************************************************************/

WORD num_windows (WORD class, WORD mode)
{
	WORD	num;
	WINDP window;

	num = 0;
	for (window=used_list; window!=NULL; window=window->next)
	{
		if (class==NIL || class==window->class)
			if ((mode==SRCH_ANY) ||
				 (!window->opened && mode==SRCH_CLOSED) ||
				 ( window->opened && mode==SRCH_OPENED))
			{
				num++;
			}
	}
	return (num);
} /* num_windows */

VOID get_all_windows (WORD class, WORD mode, VOID (*doit)(WINDP window))
{
	WINDP	window;

	for (window=used_list; window!=NULL; window=window->next)
	{
		if (class==NIL || class==window->class)
			if ((mode==SRCH_ANY) ||
				 (!window->opened && mode==SRCH_CLOSED) ||
				 ( window->opened && mode==SRCH_OPENED))
		{
			(*doit)(window);
		}
	}
} /* get_all_windows */

/***************************************************************************/

LOCAL VOID move_to_top (WINDP window)
{
	WINDP w;

	if (used_list==window) return;
	for (w=used_list; w->next!=window; w=w->next) ;
	w->next = window->next;
	window->next = used_list;
	used_list = window;
} /* move_to_top */

/***************************************************************************/

LOCAL VOID move_to_end (WINDP window)
{
	WINDP w;

	if (used_list==window)
		used_list = window->next;
	else
	{
		for (w=used_list; w->next!=window; w=w->next) ;
		w->next = window->next;
	}
	window->next = NULL;
	if (used_list==NULL)
		used_list = window;
	else
	{
		for (w=used_list; w->next!=NULL; w=w->next) ;
		w->next = window;
	}
} /* move_to_end */

/***************************************************************************/

LOCAL VOID just_menu(WINDP window)
{
	OBJECT *object, *menu;

	menu = window->menu;
	if (menu!=NULL)										/* Menu vorhanden */
	{
		menu->ob_x = window->work.x + menu_offset - menu[window->first_menu].ob_x;
		menu->ob_y = window->work.y;
		arrows[ROOT].ob_x = window->work.x;
		arrows[ROOT].ob_y = window->work.y;
	}
	object = window->object;
	if (object != NULL)									/* Objekt vorhanden */
	{
		WORD x_offset, y_offset;

		x_offset = y_offset = 0;
		if (window->class == DESK)				 		/* Bewege Objektbaum Desktop */
		{
			x_offset = desk.x;
			y_offset = desk.y;
			object->ob_x = window->scroll.x-x_offset-(WORD)window->doc.x*window->xfac;
			object->ob_y = window->scroll.y-y_offset-(WORD)window->doc.y*window->yfac;
		}
	}
}

/***************************************************************************/
/* Einschnappen des Fenster(inneren) auf bestimmte Grenzen						*/
/* x : auf Bytegrenze (von work)															*/
/* y : gerade			 (von work)															*/
/* w und h : vielfache von xfac und yfac	(von scroll)							*/
/* new ist Innenbereich	(work)															*/
/***************************************************************************/

LOCAL VOID snap_window(WINDP window, RECT *new, WORD mode)
{
	new->x = (new->x+4)&(~7);								/* Byte Position */
	new->y &= (~1);											/* gerade Position */

	if (mode&WORK_SIZED)
	{
		WORD diff;

		diff = window->work.w-window->scroll.w;
		new->w -= diff;
		new->w = new->w-(new->w%window->xfac);			/* scroll.w: vielfaches */
		new->w += diff;

		diff = window->work.h-window->scroll.h;
		new->h -= diff;
		new->h = new->h-(new->h%window->yfac);			/* scroll.h: vielfaches */
		new->h += diff;
	}

	if (window->snap != NULL)
		(*window->snap) (window, new, mode);
} /* snap_window */

/***************************************************************************/
/* Setze Arbeitsbereich des Fensters													*/
/* new: Aussenbereich des Fensters														*/
/***************************************************************************/

LOCAL VOID test_work(RECT *new)
{
	/* Liegt und pat das Fenster auf den Bildschirm */
	if (new->y < desk.y)
		new->y = desk.y;
	else if (new->y > desk.y+desk.h-2*sys_hchar)
		new->y = desk.y+desk.h-2*sys_hchar;
	if (new->x <= 0)
		new->x = -1;
	else if (new->x > desk.x+desk.w-3*sys_wchar)
		new->x = desk.x+desk.w-3*sys_wchar;
}

LOCAL VOID get_work (WINDP window, RECT *new, WORD mode)
{
	WORD diff;

	if (mode & WORK_SIZED)
	{
		if (new->w < MIN_WIDTH)
			new->w = MIN_WIDTH;
		else if (new->w > desk.w)
			new->w = desk.w;
		if (new->h < MIN_HEIGHT)
			new->h = MIN_HEIGHT;
		else if (new->h > desk.h)
			new->h = desk.h;
	}

	wind_calc (WC_WORK, window->kind,				/* Innenbereich berechnen */
				  new->x, new->y, new->w, new->h,
				  &new->x, &new->y, &new->w, &new->h);
	snap_window (window, new, mode);

	/* work und scroll und w_* (und doc) anpassen */
	diff = window->work.x-window->scroll.x;
	window->work.x = new->x; 
	window->scroll.x = new->x-diff;
	diff = window->work.y-window->scroll.y;
	window->work.y = new->y;
	window->scroll.y = new->y-diff;
	if (mode&WORK_SIZED)
	{
		long max_doc;

		diff = window->work.w-window->scroll.w;
		window->work.w = new->w;
		window->scroll.w = new->w-diff;
		window->w_width  = window->scroll.w/window->xfac;
		max_doc = window->doc.w - window->w_width;
		if (max_doc<0) max_doc = 0;
		if (window->doc.x > max_doc)				/* Jenseits rechter Bereich */
			window->doc.x = max_doc;

		diff = window->work.h-window->scroll.h;
		window->work.h = new->h;
		window->scroll.h = new->h-diff;
		window->w_hight  = window->scroll.h/window->yfac;
		max_doc = window->doc.h - window->w_hight;
		if (max_doc<0) max_doc = 0;
		if (window->doc.y > max_doc)				/* Jenseits unterer Bereich */
			window->doc.y = max_doc;
	}

	if (window->opened)
	{
		wind_calc (WC_BORDER, window->kind,		/* Rand berechnen */
					  new->x, new->y, new->w, new->h,
					  &new->x, &new->y, &new->w, &new->h);
		wind_set (window->handle, WF_CURRXYWH, new->x, new->y, new->w, new->h);
	}

	just_menu(window);

	if (mode&WORK_SIZED)
		set_sliders (window, HORIZONTAL+VERTICAL, SLPOS+SLSIZE);
} /* get_work */

/***************************************************************************/
/* Kreiere Fenster																			*/
/***************************************************************************/

WINDP create_window (WORD kind, WORD class, WORD link, VOID (*crt)(WORD link, WINDP window))
{
	WINDP window, w;
	WORD	i, *ptr, h_age, h_x, h_y;
	RECT	help;

	if (free_list==NULL)							/* kein Platz mehr fr Fenster */
	{
		free_list = (WINDP)Malloc(sizeof(WINDOW));
		if (free_list==NULL)
		{
			note(1, NOWINDOW);
			return (NULL);
		}
		else
		{
			ptr = (WORD*)free_list;
			for (i = (short)sizeof(WINDOW) / 2; (--i)>=0; ) 
				*ptr++ = 0;
		}
	}
	/* Unbenutzt und gleiche Klasse und groeszter init */
	i = -1;
	w = NULL;
	for (window=free_list; window!=NULL; window=window->next)
	{
		if (window->class==class && window->init>i)
		{
			i = window->init;
			w = window;
		}
	}
	window = w;
	if (window==NULL)
	{
		/* Unbenutzt und gleiche Klasse */
		for (window=free_list; window!=NULL; window=window->next)
		{
			if (window->class==class)
				break;
		}
		/* Unbenutzt und nicht gleiche Klasse */
		if (window==NULL)
		{
			for (window=free_list; window!=NULL; window=window->next)
			{
				if (window->work.w==0)
					break;
			}
			if (window==NULL)								/* Nur unbenutzt */
			{
				window = free_list;
				window->work.h = window->work.w = 0;
			}
		}
	}

	if (free_list==window)							/* Aushngen */
		free_list = window->next;
	else
	{
		for (w=free_list; w->next!=window; w=w->next) ;
		w->next = window->next;
	}

	help = window->work;								/* Lschen */
	h_age = window->age;
	h_x = window->icon_x;
	h_y = window->icon_y;
#if sizeof(WINDOW)&1
	So gehts nicht
#endif
	ptr = (WORD*)window;
	for (i= (short) sizeof(WINDOW) / 2; (--i)>=0; )
		*ptr++ = 0;

	if (used_list==NULL)								/* Einhngen */
		used_list = window;
	else
	{
		for (w=used_list; w->next!=NULL; w=w->next) ;
		w->next = window;
	}

	window->age			= h_age;
	window->handle		= NO_HANDLE;
	window->kind		= kind;
	window->class		= class;
	window->first_menu= THEFIRST;
	window->link 		= link;
	(* crt)(link, window);
	if (class != CLASS_WICON)
	{
		if (help.w == 0 || help.h == 0)
			help = window->work;
		size_window(window, &help, FALSE);
		if (is_icon_on_desk(window->link))
		{
			if (h_x || h_y)
			{
				move_icon_to(window->link,h_x,h_y);
				show_icon(window->link);
			}
			else
			{
				show_icon(window->link);
				get_icon_pos(window->link,&window->icon_x,&window->icon_y);
			}
		}
	}
	return (window);
} /* create_window */

/***************************************************************************/
/* ffne Fenster																				*/
/***************************************************************************/


BOOLEAN open_window (WINDP window)
{
	WORD	wh;

	clr_undo();
	if (!window->opened)		/* Erstes ffnen */
	{
		if (window->class == DESK)
			wh = DESK;
		else
		{
			wh = wind_create (window->kind, desk.x, desk.y, desk.w, desk.h);
			if (wh < 0)
				return FALSE;											/* Kein Fenster mehr */
		}
		window->handle = wh;
	}
	else
		wh = window->handle;

	unclick_window();
	window->opened++;									/* Fenster einmal mehr offen */
	window->flags &= ~WI_FULLED;					/* Fenster hat nicht volle Gre */

	if (wh == DESK)										/* GEM Desktop */
	{
		if (!no_desktop)
		{
			wind_set(DESK, WF_NEWDESK, window->object, 0);
			form_dial(FMD_FINISH, 0, 0, 0, 0, desk.x, desk.y, desk.w, desk.h);
		}
	}
	else 
	{
		RECT	r;

		wind_calc (WC_BORDER, window->kind,		/* Rand berechnen */
					  window->work.x, window->work.y, window->work.w, window->work.h,
					  &r.x, &r.y, &r.w, &r.h);
		if (window->kind&NAME)						/* Name setzen */
			wind_set (wh, WF_NAME, window->titel);
		if (window->kind&INFO)						/* Infozeile setzen */
			wind_set (wh, WF_INFO, window->info);
		window->slider_pos = -1;					/* garantiert setzen */
		set_sliders (window, HORIZONTAL+VERTICAL, SLPOS+SLSIZE);
		if (window->opened==1)						/* erstes ffnen */
		{
			if (is_icon_on_desk(window->link) && !no_desktop)
			{
				RECT	k;

				objc_rect (desktop, window->link, &k, FALSE);
				growbox (&k, &window->work);
			}
			wind_open (wh, r.x, r.y, r.w, r.h);	/* Fenster ffnen */
			top_handle = wh;
			while (idle()) 
				;
		}
	}
	just_menu (window);								/* Menu und Objekt anpassen */
	if (window->opened == 1)
	{
		move_to_top (window);						/* Neu geffnetes Fenster oben */
		if (wh != DESK)
		{
			redraw_window(window, &window->work);
			window->flags |= WI_NOTDRAWED;
		}
	}
	return TRUE;
} /* open_window */

/***************************************************************************/
/* Schliee Fenster																			*/
/***************************************************************************/

VOID close_window (WINDP window)
{
	WORD	wh;

	wh	= window->handle;
	unclick_window ();			/* Deselektieren */

	if (window->opened)			/* Fenster offen? */
	{
		Wake_mouse();				/* Mu an sein */
		if (wh==DESK)				/* GEM Desktop */
		{
			if (!no_desktop)
			{
				wind_set(DESK, WF_NEWDESK, NULL);/* Original Desktop */
				form_dial (FMD_FINISH, 0, 0, 0, 0, desk.x, desk.y, desk.w, desk.h);
			}
		}
		else if (window->opened == 1)
		{
			wind_close (wh);		/* Schliee Fenster */
			wind_delete (wh);		/* Window-Handle freigeben */
			get_realtop();
			if (is_icon_on_desk(window->link) && !no_desktop)
			{
				RECT	k;
				
				objc_rect (desktop, window->link, &k, FALSE);
				shrinkbox (&k, &window->work);
			}
			idle();
		}
		window->opened--;			/* Fenster einmal geschlossen */
		if (!window->opened)			/* Fenster ganz schlieen */
		{
			window->handle	= NO_HANDLE;	/* Kein Handle mehr verfgbar */
			move_to_end (window);
			clr_undo();
		}
	}
} /* close_window */

/***************************************************************************/

VOID destruct_window(WINDP window)
{
	WINDP w;

	if (window->flags & WI_ICONIFIED)
		window->opened = 1;

	while(window->opened)
		close_window (window);						/* Schliee Fenster */

	if (used_list==window)							/* Aushngen */
		used_list = window->next;
	else
	{
		for (w = used_list; w->next!=window; w=w->next) ;
		w->next = window->next;
	}
	if (window>=windrec && window<&windrec[MAX_WINDOW])
	{
		if (free_list==NULL || free_list->age>window->age)
		{
			window->next = free_list;
			free_list = window;
		}
		else
		{
			for (w=free_list; (w->next!=NULL) && (w->next->age<window->age); w=w->next) ;
			window->next = w->next;
			w->next = window;
		}
	}
	else
	{
		Mfree(window);
	}
}

/***************************************************************************/
/* Suche und zeichne berlagernde Rechtecke von Fenstern							*/
/***************************************************************************/

VOID redraw_window (WINDP window, CONST RECT *area)
{
	WORD	wh;
	RECT	r, r1;

	if (window==NULL) 
		return;
	if (window->flags & WI_NOTDRAWED)
	{
		window->flags &= (~WI_NOTDRAWED);
	}
	else if (window->opened || (window->flags & WI_ICONIFIED) )
	{
		if (window->opened)		
		{
			just_menu (window);							/* Eventuell Objekte korrigieren */
			if (window->menu!=NULL)
				draw_mbar (window, area);				/* Zeichne Menzeile */
		} 
		if (window->flags & WI_ICONIFIED)
		{
			/* Icon-Position wieder eintragen, da alle Fenster den gleichen
			 * Objektbaum benutzen!!!
			 */
			window->icon[0].ob_x = window->ix;
			window->icon[0].ob_y = window->iy;
		}
		wh = window->handle;
		if (rc_first (wh, area, &r1))
		{
			Hide_mouse ();								/* Maus verstecken */
			do
			{
				if (window->flags & WI_ICONIFIED)
				{
					if (rc_intersect (area, &r1))
						objc_draw (window->icon, ROOT, MAX_DEPTH, r1.x, r1.y, r1.w, r1.h);
				}
				else if (window->opened)
				{
					if (window->draw!=NULL)		/* Zeichenroutine ausfhren */
						(*window->draw) (window, &r1);
					if (window->object!=NULL)			/* Objekte im Fenster zeichnen */
					{
						r = window->scroll;
						if (rc_intersect (&r1, &r))
							objc_draw (window->object, ROOT, MAX_DEPTH, r.x, r.y, r.w, r.h);
					}
				}
			}
			while(rc_next(wh,&r1));					/* Hole nchstes Rechteck */
			Show_mouse ();								/* Zeige Maus wieder */
		}
	}
} /* redraw_window */

/***************************************************************************/
/* Bringt anderes Fenster nach oben														*/
/***************************************************************************/

VOID cycle_window(VOID)
{
	WINDP	window, w;

	window = NULL;
	for (w=used_list; w!=NULL; w=w->next)
	{
		if (w->opened && w->class != DESK && 
			(w->class != CLASS_PROJEKT || wind_cycle))
			window = w;
	}
	top_window(window);
}

/***************************************************************************/
/* Rume alle offenen Fenster auf														*/
/***************************************************************************/

VOID clearup_windows(WORD mode, WORD w, WORD h)
{
	WINDP	winds[MAX_WINDOW], window;
	RECT	r1, r2;
	WORD	i, anz;

	for (window=used_list,anz=0; window!=NULL; window=window->next)
	{
		if (window->opened && window->kind&SIZER && window->flags&WI_TEXT)
			winds[anz++] = window;
	}
	if (anz==0) return;
	if (mode==0)
	{
		r1.x = desk.x+sys_wchar;
		r1.y = desk.y+(sys_hchar>>1);
		r1.w = desk.w-anz*sys_wchar;
		r1.h = desk.h-anz*sys_hchar;
		if (w>0 || h>0)
		{
			wind_calc(WC_WORK, winds[0]->kind, r1.x, r1.y, r1.w, r1.h,
															&r1.x, &r1.y, &r1.w, &r1.h);
			if (w>0) r1.w = w*gl_wchar;
			if (h>0) r1.h = h*gl_hchar;
			wind_calc(WC_BORDER, winds[0]->kind, r1.x, r1.y, r1.w, r1.h,
																&r1.x, &r1.y, &r1.w, &r1.h);
		}
		while ((--anz)>=0)
		{
			size_window(winds[anz], &r1, TRUE);
			r1.x += sys_wchar;
			r1.y += sys_hchar;
		}
		return;
	}
	else if (mode==1)		/* nebeneinander */
	{
		i = (anz+1)>>1;
		r1.x = desk.x+sys_wchar;
		r1.y = desk.y+(sys_hchar>>1);
		r1.w = (desk.w>>1)-i*sys_wchar;
		r1.h = desk.h-i*sys_hchar;
		r2 = r1;
		r2.x += (desk.w>>1);
	}
	else						/* untereinander */
	{
		i = (anz+1)>>1;
		r1.x = desk.x+sys_wchar;
		r1.y = desk.y+(sys_hchar>>1);
		r1.w = desk.w-i*sys_wchar;
		r1.h = (desk.h>>1)-i*sys_hchar;
		r2 = r1;
		r2.y += (desk.h>>1);
	}
	while ((--anz)>=0)
	{
		size_window(winds[anz], (anz&1)?&r2:&r1, TRUE);
		if (anz&1)
		{
			r2.x += sys_wchar;
			r2.y += sys_hchar;
		}
		else
		{
			r1.x += sys_wchar;
			r1.y += sys_hchar;
		}
	}
}

/***************************************************************************/
/* Fenster wurde durch andere getopped/geuntopped 									*/
/***************************************************************************/
VOID ontop_window(WINDP window)
{
	if (window != NULL && window->ontop != NULL) 
		(*window->ontop)(window);
}

VOID untop_window(WINDP window)
{
	if (window != NULL && window->untop != NULL) 
		(*window->untop)(window);
}

/***************************************************************************/
/* Bringe Fenster nach oben																*/
/***************************************************************************/

VOID top_window (WINDP window)
{
	WORD	wh;

	if (window == NULL || (!window->opened) && !(window->flags & WI_ICONIFIED))
		return;
	if (window->class == DESK) 
		return;		/* Desktop im HP */
	if (window->top != NULL) 
		(*window->top)(window);
	wh = window->handle;
	wind_set (wh, WF_TOP);
	top_handle = wh;
	if (window != sel_window)
		unclick_window();
	if (window != used_list)				/* War noch nicht top */
	{
		clr_undo();
		move_to_top (window);			/* Neues Fenster oben im Keller */
	}
} /* top_window */

/************************************************************************/
/* Bringe Fenster nach hinten						*/
/************************************************************************/

VOID bottom_window (WINDP window, WORD which)
{
	WORD	wh, 
			msg[8] = {0,0,0,0,0,0,0,0};
	
	if (window == NULL || (!window->opened) && !(window->flags & WI_ICONIFIED))
		return;
	if (window->class == DESK) 
		return;
	wh = window->handle;
	if (window->bottom != NULL) 
		(*window->bottom)(window);
	if (which == WM_BOTTOMED)
		wind_set (wh, WF_BOTTOM);			/* MTOS/MagiC 3 */
	else
		wind_set(wh, WF_M_BACKDROP);		/* Magic 2 */
	if (window != used_list)
	{
		clr_undo();
		move_to_end(window);
	}
	get_realtop();			/* QED ber das neue top-Fenster informieren */
	msg[0] = WM_TOPPED;
	msg[1] = gl_apid;
	msg[3] = top_handle;
	appl_write(gl_apid, 16, msg);
} /* bottom_window */

/***************************************************************************/
/* Scrolle den Fensterinhalt																*/
/***************************************************************************/

LOCAL VOID scroll_window (WINDP window, WORD dir, long delta)
{
	MFDB	s, d;
	WORD	xy[8];
	RECT	r;
	BOOLEAN	draw;

	draw = FALSE;
	wind_get (window->handle, WF_FIRSTXYWH, &r.x, &r.y, &r.w, &r.h);
	if (r.w!=window->work.w || r.h!=window->work.h) draw = TRUE;

	r = window->scroll;							/* Hole Scrollbereich */
	if (!rc_intersect(&desk,&r)) return;

	if (dir&HORIZONTAL)
	{
		delta *= window->xfac;
		if (labs(delta)>=r.w) draw = TRUE;
	}
	else
	{
		delta *= window->yfac;
		if (labs(delta)>=r.h) draw = TRUE;
	}

	if (!draw)
	{
		rect2array (&r, xy);						/* Quelle fr vro_cpyfm */
		xy[4] = xy[0];								/* Ziel fr vro_cpyfm */
		xy[5] = xy[1];
		xy[6] = xy[2];
		xy[7] = xy[3];

		if (dir&HORIZONTAL)						/* Horizontales Scrolling */
		{
			if (delta > 0)							/* Links Scrolling */
			{
				xy[0] += (short) delta;			/* Werte fr vro_cpyfm */
				xy[6] -= (short) delta;

				r.x += r.w - (short)delta;		/* Rechter Bereich nicht gescrollt, */
				r.w  = (short)delta;				/* mu neu gezeichnet werden */
			}
			else										/* Rechts Scrolling */
			{
				xy[2] += (short)delta;			/* Werte fr vro_cpyfm */
				xy[4] -= (short)delta;

				r.w = (short)(-delta);			/* Linken Bereich noch neu zeichnen */
			}
		}
		else											/* Vertikales Scrolling */
		{
			if (delta > 0)							/* Aufwrts Scrolling */
			{
				xy[1] += (short)delta;					/* Werte fr vro_cpyfm */
				xy[7] -= (short)delta;

				r.y += r.h - (short)delta;					/* Unterer Bereich nicht gescrollt, */
				r.h  = (short) delta;						/* mu neu gezeichnet werden */
			}
			else										/* Abwrts Scrolling */
			{
				xy[3] += (short)delta;					/* Werte fr vro_cpyfm */
				xy[5] -= (short)delta;

				r.h = (short)(-delta);					/* Oberen Bereich noch neu zeichnen */
			}
		}
		s.fd_addr = d.fd_addr = NULL;			/* Erzwinge Bildschirmadresse */
		set_clip(FALSE,NULL);
		Hide_mouse ();
		vro_cpyfm (vdi_handle, S_ONLY, xy, &s, &d);
		Show_mouse ();
		redraw_window (window, &r);
	}
	else
		redraw_window (window, &r);			/* Fenster zeichnen */
} /* scroll_window */

/***************************************************************************/
/* Reagiere auf Anklicken eines Pfeils													*/
/***************************************************************************/

LOCAL VOID do_arrow(WINDP window, WORD dir, long delta)
{
	if (delta)
	{
		if (dir==HORIZONTAL)		 							/* Horizontale Pfeile und Schieber */
			window->doc.x += delta;							/* Neue Position */
		else														/* Vertikale Pfeile und Schieber */
			window->doc.y += delta;							/* Neue Position */
		if (window->opened)
		{
			set_sliders (window, dir, SLPOS);			/* Schieber setzen */
			scroll_window (window, dir, delta);
		}
	}
}

VOID arrow_window (WINDP window, WORD arrow, long amount)
{
	WORD w, h, dir;
	long oldpos, newpos, max_slide;

	if (window!=NULL)
	{
		w	  = window->w_width; 							/* Breite in Zeichen */
		h	  = window->w_hight; 							/* Hhe in Zeichen */

		if (arrow <= WA_DNLINE)
		{
			oldpos = newpos = window->doc.y;
			dir	 = VERTICAL;
			max_slide = window->doc.h - h;				/* Maximale Position */
		}
		else
		{
			oldpos = newpos = window->doc.x;
			dir	 = HORIZONTAL;
			max_slide = window->doc.w - w;				/* Maximale Position */
		}
		switch (arrow)
		{
			case WA_UPPAGE : newpos -= h * amount; break;
			case WA_DNPAGE : newpos += h * amount; break;
			case WA_UPLINE : newpos -= amount;		break;
			case WA_DNLINE : newpos += amount;		break;
			case WA_LFPAGE : newpos -= w * amount; break;
			case WA_RTPAGE : newpos += w * amount; break;
			case WA_LFLINE : newpos -= amount;		break;
			case WA_RTLINE : newpos += amount;		break;
		}

		if (newpos > max_slide) newpos = max_slide;	/* Jenseits des Randes */
		if (newpos < 0) newpos = 0;					 	/* Jenseits des Randes */
		do_arrow(window, dir, newpos-oldpos);
	}
} /* arrow_window */

/***************************************************************************/
/* Reagiere auf Bewegen der Schieber													*/
/***************************************************************************/

VOID h_slider (WINDP window, WORD new_value)
{
	WORD w;
	long oldpos, newpos, max_slide;

	if (window != NULL)
	{
		w				= window->w_width;					/* Breite in Zeichen */
		max_slide	= window->doc.w - w;					/* Maximale Position */
		oldpos		= window->doc.x;
		newpos		= (long)new_value * max_slide;
		newpos		= (newpos+500) / 1000;				/* Teilen + Runden */

		if (newpos > max_slide) newpos = max_slide;	/* Jenseits des Randes */
		if (newpos < 0) newpos = 0;						/* Jenseits des Randes */
		do_arrow(window, HORIZONTAL, newpos-oldpos);
	}
} /* h_slider */

/*****************************************************************************/

VOID v_slider (WINDP window, WORD new_value)
{
	WORD h;
	long oldpos, newpos, max_slide;

	if (window != NULL)
	{
		h				= window->w_hight;					/* Hhe in Zeichen */
		max_slide	= window->doc.h - h;					/* Maximale Position */
		oldpos		= window->doc.y;
		newpos		= (long)new_value * max_slide;
		newpos		= (newpos+500) / 1000;				/* Teilen + Runden */

		if (newpos > max_slide) newpos = max_slide;	/* Jenseits des Randes */
		if (newpos < 0) newpos = 0;						/* Jenseits des Randes */
		do_arrow(window, VERTICAL, newpos-oldpos);
	}
} /* v_slider */

/***************************************************************************/
/* Setze Schieberpositionen und Schiebergre										*/
/***************************************************************************/

VOID set_sliders (WINDP window, WORD which, WORD mode)
{
	WORD	wh;
	WORD	size, newval, oldval;
	long	max_doc;

	if (window->opened)
	{
		wh = window->handle;

		if ((which&HORIZONTAL) && (window->kind&HSLIDE))
		{
			size		= window->w_width;
			max_doc	= window->doc.w-size;

			if (mode&SLPOS)
			{
				if (max_doc<=0)			/* Fenster zu gro oder passend */
					newval = 0;
				else
					newval = (short)((1000L * window->doc.x) / max_doc);

				wind_get (wh, WF_HSLIDE, &oldval);
				if (newval!=oldval)
					wind_set (wh, WF_HSLIDE, newval);
			}
			if (mode&SLSIZE)
			{
				if (window->doc.w<=0)		/* Fenster zu gro oder passend */
					newval = 1000;
				else
					newval = (short)((1000L * size) / window->doc.w);
				wind_get (wh, WF_HSLSIZE, &oldval);
				if (newval!=oldval)
					wind_set (wh, WF_HSLSIZE, newval);
			}
		}
		if ((which&VERTICAL) && (window->kind&VSLIDE))
		{
			size	  = window->w_hight;
			max_doc = window->doc.h-size;

			if (mode&SLPOS)
			{
				if (max_doc<=0)			/* Fenster zu gro oder passend */
					newval = 0;
				else
					newval = (short)((1000L*window->doc.y) / max_doc);
				if (newval!=window->slider_pos)
				{
					wind_set (wh, WF_VSLIDE, newval);
					window->slider_pos = newval;
				}
			}
			if (mode&SLSIZE)
			{
				if (window->doc.h<=0)		/* Fenster zu gro oder passend */
					newval = 1000;
				else
					newval = (short)((1000L*size) / window->doc.h);
				wind_get (wh, WF_VSLSIZE, &oldval);
				if (newval!=oldval)
					wind_set (wh, WF_VSLSIZE, newval);
			}
		}
	}
} /* set_sliders */

/***************************************************************************/
/* Setze Fenstername       																*/
/***************************************************************************/

VOID set_wname(WINDP window, CONST UBYTE *name)
{
	UBYTE	str[82];
	
	strcpy(window->name, name);
	str[0] = ' ';
	if (window->changed)
	{
		str[1] = '*';
		*(UBYTE*)COPYB(str+2,name,76) = EOS;
		strcat(str," ");
	}
	else
	{
		*(UBYTE*)COPYB(str+1,name,76) = EOS;
		strcat(str," ");
	}
	strcpy(window->titel,str);
	if (window->opened && window->kind&NAME)
		wind_set(window->handle, WF_NAME, window->titel);
}

/***************************************************************************/
/* Setze Fensterinfo       																*/
/***************************************************************************/

VOID set_winfo(WINDP window, CONST UBYTE *info)
{
	*(UBYTE*)COPYB(window->info,info,79) = EOS;
	if (window->opened && window->kind&INFO)
		wind_set(window->handle,WF_INFO,window->info);
}

/***************************************************************************/
/* '*' vor Fenstertitel																		*/
/***************************************************************************/

VOID change_window (WINDP window, BOOLEAN changed)
{
	if (window->changed!=changed)
	{
		window->changed = changed;
		set_wname(window,window->name);
	}
}

/***************************************************************************/
/* Vergere Fenster auf volle Gre bzw. verkleinere Fenster					*/
/***************************************************************************/

VOID full_window (WINDP window)
{
	RECT	new;

	if (window!=NULL && window->kind&FULLER)
	{
		if (window->flags&WI_FULLED)				/* Mache Fenster klein */
			wind_get (window->handle, WF_PREVXYWH, &new.x, &new.y, &new.w, &new.h);
		else												/* Mache Fenster gro */
			wind_get (window->handle, WF_FULLXYWH, &new.x, &new.y, &new.w, &new.h);
		test_work (&new);
		get_work (window, &new, WORK_MOVED|WORK_SIZED);
		window->flags ^= WI_FULLED;
	}
} /* full_window */

/***************************************************************************/
/* ndere Fenstergre																		*/
/***************************************************************************/

VOID size_window (WINDP window, CONST RECT *new, BOOLEAN border)
{
	RECT r;

	if (window!=NULL)
	{
		r = *new;
		if (!border)
			wind_calc (WC_BORDER, window->kind,		/* Rand berechnen */
						  r.x, r.y, r.w, r.h, &r.x, &r.y, &r.w, &r.h);
		if (window->kind&SIZER)
		{
			test_work (&r);
			get_work (window, &r, WORK_SIZED);
			window->flags &= ~WI_FULLED;
			if (window->flags&WI_REDRAW)
				redraw_window(window,&window->work);
		}
		else
			move_window(window,&r);
	}
} /* size_window */

/***************************************************************************/
/* Bewege Fenster																				*/
/***************************************************************************/

VOID move_window (WINDP window, CONST RECT *new)
{

	if (window != NULL)
	{
		if (window->flags & WI_ICONIFIED)
		{
			WORD	x, y, d;
			
			wind_set(window->handle, WF_CURRXYWH, new->x, new->y, new->w, new->h);
			wind_get(window->handle, WF_WORKXYWH, &x, &y, &d, &d);
			window->icon[0].ob_x = x;
			window->icon[0].ob_y = y;
			window->ix = window->icon[0].ob_x;
			window->iy = window->icon[0].ob_y;
		}
		else if (window->kind & MOVER)
		{
			RECT r;
			
			r = *new;
			/* test_work (&r); hier nicht wg. MagiX */
			get_work (window, &r, WORK_MOVED);
			window->flags &= ~WI_FULLED;
		}
	}
} /* move_window */

/***************************************************************************/
/* Iconify																						*/
/***************************************************************************/

VOID		iconify_window(WINDP window, CONST RECT *new)
{

	unclick_window ();			/* Deselektieren */

	if (window->opened && !(window->flags & WI_ICONIFIED))
	{
		WORD	x, y, w, h;


		if (window->iconify != NULL)
			(*window->iconify) (window);
		
		wind_set(window->handle, WF_ICONIFY, new->x, new->y, new->w, new->h);

		if (do_open)				/* alliconify: Fenster erst noch ffnen! */
			wind_open(window->handle, new->x, new->y, new->w, new->h);
			
		wind_get(window->handle, WF_WORKXYWH, &x, &y, &w, &h);
		window->icon[0].ob_x = x;
		window->icon[0].ob_y = y;
		window->icon[0].ob_width = w;
		window->icon[0].ob_height = h;
		window->icon[1].ob_x = (w - window->icon[1].ob_width) / 2;
		window->icon[1].ob_y = (h - window->icon[1].ob_height) / 2;
		window->ix = window->icon[0].ob_x;
		window->iy = window->icon[0].ob_y;

		window->flags |= WI_ICONIFIED;
		if (window->class == CLASS_EDIT)
			window->flags &= ~WI_MOUSE;
		window->opened = 0;
		bottom_window(window, WM_BOTTOMED);		/* Icon nach hinten! */

	}
}


LOCAL VOID	crt_wicon(WORD icon, WINDP window)
{
	window->opened = 1;		/* wir gaukeln iconify_window ein geffnetes Fenster
									 * vor, damit der Iconify klappt.
									 */
	window->icon = winicon;
}


VOID	alliconify(CONST RECT *new)
{
	WORD	i, anz;
	WORD	ic, icp[MAX_ICON_ANZ];
	WINDP	window;
	

	if (makro_rec)
	{
		beep();
		return;
	}

	/* Zunchst alle Fenster schlieen und in Liste merken */
	i = all_icons(icp);
	anz = 0;
	while ((--i) >= 0)
	{
		ic = icp[i];
		if (ic != 0)
		{
			window = get_window(ic);
			if (window != NULL)
				if (window->handle != NO_HANDLE && ((window->opened) || (window->flags & WI_ICONIFIED)))
				{
					anz++;
					opened_win[anz] = ic;
					wind_close(window->handle);
					if (window->flags & WI_ICONIFIED)
					{
						/* 
						 * Iconify noch schnell aufheben. Schwachsinnige Gre macht nix,
						 * Fenster wird eh schon zu. 
						 */
						if (window->uniconify != NULL)
							(*window->uniconify) (window);
						wind_set(window->handle, WF_UNICONIFY, -1, -1, -1, -1);
						window->flags &= ~WI_ICONIFIED;
						if (window->class == CLASS_EDIT)
							window->flags |= WI_MOUSE;
					}
					wind_delete(window->handle);	/* Fenster entgltig lschen */
					window->handle = NO_HANDLE;
					window->opened = 0;
				}
		}
	}
	opened_win[0] = anz;

	/*
	 * Nachdem nun alle anderen Fenster geschlossen wurden, wird ein
	 * neues Fenster geffnet. Etwas	umstndlich, aber 'open_window' macht
	 * viel zuviele Dinge mit dem Fenster, die ggf. gar nicht funken.
	 */
	icon_win = create_window((NAME|MOVER), CLASS_WICON, 0, crt_wicon);
	icon_win->handle = wind_create((NAME|MOVER), desk.x, desk.y, desk.w, desk.h);
	set_wname(icon_win, " QED ");
	do_open = TRUE;
	iconify_window(icon_win, new);	/* Als Icon anmelden und ffnen! */
	do_open = FALSE;
	enable_menu(FALSE);					/* Menu abschalten */
	all_iconified = TRUE;
}


VOID		uniconify_window(WINDP window, CONST RECT *new)
{
	WORD	i;
	
	if (all_iconified)
	{
		wind_close(icon_win->handle);	/* Icon schlieen */
		wind_set(icon_win->handle, WF_UNICONIFY, -1, -1, -1, -1);
		destruct_window(icon_win);		/* und entgltig lschen */
		enable_menu(TRUE);				/* Menu wieder an */
		all_iconified = FALSE;

		i = 1;								/* und alle Fenster wieder ffnen */
		while (i <= opened_win[0])
		{
			window = get_window(opened_win[i]);
			open_window(window);
			i++;
		}
	}
	else if (window != NULL && (window->flags & WI_ICONIFIED))
	{
		if (window->uniconify != NULL)
			(*window->uniconify) (window);

		wind_set(window->handle, WF_UNICONIFY, new->x, new->y, new->w, new->h);
		window->flags &= ~WI_ICONIFIED;
		if (window->class == CLASS_EDIT)
			window->flags |= WI_MOUSE;
		window->opened = 1;
		top_window(window);
	}
}


/***************************************************************************/
/* Klicken in das Fensterinnere															*/
/***************************************************************************/

VOID click_window (WINDP window, MKINFO *mk)
{
	if (window!=NULL)
	{
		if (window->click!=NULL)
			(*window->click) (window, mk);
		else
			unclick_window (); 					/* Deselektieren */
	}
} /* click_window */

/***************************************************************************/

VOID unclick_window (VOID)
{
	if (sel_window!=NULL && sel_window->unclick!=NULL)
		(*sel_window->unclick) (sel_window);
	sel_window = NULL;
	setclr (sel_objs);
} /* unclick_window */

/***************************************************************************/
/* Taste fr ein Fenster																	*/
/***************************************************************************/

BOOLEAN key_window (WINDP window, MKINFO *mk)
{
	if (window->key!=NULL)
		return ((*window->key) (window, mk));
	return (FALSE);
} /* key_window */

/***************************************************************************/
/* Fenster-Objektroutinen																	*/
/***************************************************************************/

VOID draw_winobject (WINDP window, WORD obj)
{
	WORD	wh;
	RECT	r1, r2;

	if (window!=NULL && window->opened && window->object!=NULL)
	{
		wh = window->handle;

		objc_rect (window->object, obj, &r2, FALSE);
		if (rc_intersect (&window->scroll,&r2))
		{
			if (rc_first(wh,&r2,&r1))
				do
				{
					objc_draw (window->object, obj, MAX_DEPTH, r1.x, r1.y, r1.w, r1.h);
				}while (rc_next(wh, &r1));
		}
	}
} /* draw_object */

/***************************************************************************/

LOCAL VOID draw_box (CONST RECT *box, WORD x_offset, WORD y_offset)
{
	WORD xy[10];
	WORD m1, m2;

	xy[2] = xy[0] = x_offset + box->x;		/* Dieser Teil ist RICHTIG !!! */
	xy[7] = xy[1] = y_offset + box->y;
	xy[3] = xy[1] + box->h-1;
	xy[4] = xy[0] + box->w-1;
	*(long*)(xy+5) = *(long*)(xy+3);
	*(long*)(xy+8) = *(long*)(xy+0);			/* Punkt 0 ist gleich Punkt 5 */

	m1 = 0xAAAA; m2 = 0x5555;
	vsl_udsty (vdi_handle, odd (xy[0]+xy[1]) ? m1 : m2);
	v_pline (vdi_handle, 2, &xy[0]);
	vsl_udsty (vdi_handle, odd (xy[3]) ? m1 : m2);
	v_pline (vdi_handle, 2, &xy[2]);
	vsl_udsty (vdi_handle, odd (xy[4]+xy[5]) ? m1 : m2);
	v_pline (vdi_handle, 2, &xy[4]);
	vsl_udsty (vdi_handle, odd (xy[7]) ? m1 : m2);
	v_pline (vdi_handle, 2, &xy[6]);
} /* draw_box */

/***************************************************************************/

LOCAL VOID check_drag(x_offset, y_offset, bound, inner, diff)
WORD			x_offset, y_offset;	/* schon verschoben   */
CONST RECT	*bound,					/* erlaubter Bereich  */
				*inner;					/* Umschlieende Box  */
RECT			*diff;					/* verschiebung zurck*/
{
	WORD i, delta;

	delta = 0;
	i = bound->x-(inner->x+x_offset);
	if (i > 0) delta = i;									/* Links heraushngend */
	i = bound->x+bound->w-(inner->x+inner->w+x_offset);
	if (i < 0)													/* Rechts heraushngend */
	{
		if (delta)
			delta = -x_offset;								/* Keine Verschiebung */
		else
			delta = i;
	}
	x_offset += delta;

	delta = 0;
	i = bound->y - (inner->y+y_offset);
	if (i > 0) delta = i;									/* Oben heraushngend */
	i = bound->y + bound->h - (inner->y + inner->h + y_offset);
	if (i < 0)													/* Unten heraushngend */
	{
		if (delta)
			delta = -y_offset;
		else
			delta = i;
	}
	y_offset += delta;

	diff->w = x_offset;
	diff->h = y_offset;
}

/***************************************************************************/

LOCAL VOID draw_all (WORD num_boxes, CONST RECT *boxes, WORD x_offset, WORD y_offset)
{
	WORD i;

	Hide_mouse ();
	set_clip (TRUE, &desk);
	for (i = num_boxes; (--i)>=0 ; )
		draw_box (boxes++, x_offset, y_offset);
	Show_mouse ();
} /* draw_all */

/***************************************************************************/

VOID drag_boxes (num_objs, boxes, window, inv_objs, diff, bound)
WORD			num_objs;		/* Anzahl der Objekte, die verschoben werden */
CONST RECT	boxes[];			/* Array der Objecte		*/
WINDP			window;			/* Zielfenster				*/
SET			inv_objs;		/* Nummer der Objekte, die dort selektiert werden knnen	*/
RECT			*diff;			/* Maus-Pos/Verschiebung*/
CONST RECT	*bound;			/* Erlaubter Bereich		*/
{
	WORD		event, i, obj, last_obj, kreturn;
	WORD		x_mstart, y_mstart;		/* MausPos ganz am Anfang */
	RECT		inner;						/* Box ber alle Icons */
	MKINFO	mk;
	OBJECT	*object;
	CONST RECT *ptr;

	x_mstart = mk.mox = diff->x;
	y_mstart = mk.moy = diff->y;

	inner.x = 0; inner.y = 0; inner.w = 0; inner.h = 0;
	ptr = boxes;
	for (i = num_objs; (--i)>=0; )						/* Vereinigungsbox */
		rc_union (ptr++, &inner);

	diff->w  = diff->h  = 0;
	obj		= last_obj = NIL;
	object	= NULL;

	if (window != NULL) object = window->object;
	if (bound == NULL) bound = &desk;

	vswr_mode (vdi_handle, MD_XOR);						/* Modi einstellen */
	vsl_type (vdi_handle, USERLINE);

	draw_all (num_objs, boxes, diff->w, diff->h);
	do
	{
		event = evnt_multi ( MU_BUTTON | MU_M1,
									1, 0x01, 0x00,
									TRUE, mk.mox, mk.moy, 1, 1,
									0, 0, 0, 0, 0,
									NULL,
									0, 0,
									&mk.mox, &mk.moy,
									&mk.mobutton, &mk.kstate,
									&kreturn, &mk.breturn);

		if (event==MU_M1)		/* wenn MU_BUTTON dann hier nicht mehr rein */
		{
			draw_all (num_objs, boxes, diff->w, diff->h);
			if (object != NULL)
			{
				last_obj = obj;
				if (wind_find(mk.mox, mk.moy)==window->handle &&
					 inside(mk.mox,mk.moy,&window->work))
					obj = objc_find (object, ROOT, MAX_DEPTH, mk.mox, mk.moy);
				else
					obj = NIL;
				if (obj!=last_obj)
				{
					if (setin (inv_objs, last_obj))
					{
						set_state(object, last_obj, FALSE);
						draw_winobject (window, last_obj);
					}
					if (setin (inv_objs, obj))
					{
						set_state(object, obj, TRUE);
						draw_winobject (window, obj);
					}
				}
			}
			check_drag(mk.mox-x_mstart, mk.moy-y_mstart, bound, &inner, diff);
			diff->x = mk.mox;
			diff->y = mk.moy;
			draw_all (num_objs, boxes, diff->w, diff->h);
		}
	}while (!(event&MU_BUTTON));
	draw_all (num_objs, boxes, diff->w, diff->h);

	if (setin (inv_objs, obj))							/* Wieder normal darstellen */
	{
		set_state(object, obj, FALSE);
		draw_winobject (window, obj);
	}

	vsl_type (vdi_handle, SOLID);
	vswr_mode (vdi_handle, MD_REPLACE);				/* Modi zurcksetzen */
} /* drag_boxes */

/***************************************************************************/
/* Scroll- und Lschroutinen																*/
/***************************************************************************/

VOID scroll_vertical (CONST RECT *area, WORD delta)
/* Die Maus ist schon aus, keine berprfung auf Bildschirmgrenzen */
{
	MFDB	s, d;
	WORD	xy[8];

	rect2array (area, xy);
	xy[4] = xy[0];
	xy[5] = xy[1]-delta;
	xy[6] = xy[2];
	xy[7] = xy[3]-delta;

	s.fd_addr = d.fd_addr = NULL;							/* Erzwinge Bildschirmadresse */
	vro_cpyfm (vdi_handle, S_ONLY, xy, &s, &d);		/* Eigentliches Scrolling */
} /* scroll_vertical */

/***************************************************************************/

VOID clr_area (CONST RECT *area)
{
	WORD xy[4];

	rect2array (area, xy);									/* Bereich setzen */
	if (fill_color!=WHITE)
	{
		vsf_color(vdi_handle,WHITE);
		fill_color = WHITE;
	}
	vr_recfl (vdi_handle, xy);								/* Bereich lschen */
} /* clr_area */

/***************************************************************************/
/* Fenster-Menroutinen																		*/
/***************************************************************************/

LOCAL VOID draw_mtitle (WINDP window, WORD title)
{
	OBJECT	*menu;
	WORD		wh;
	RECT		r1, r2;

	if (window->opened)
	{
		menu = window->menu;
		wh = window->handle;

		just_menu (window);	 					/* Menzeile fr Fenster korrigieren */
		objc_rect (menu, title, &r2, FALSE);

		if (rc_first(wh, &r2, &r1))
			do
			{
				objc_draw (menu, THEBAR, 2, r1.x, r1.y, r1.w, r1.h);
			}while(rc_next(wh, &r1));
	}
} /* draw_mtitle */

/***************************************************************************/

LOCAL VOID draw_mbar (WINDP window, CONST RECT *d)
{
	OBJECT	*menu;
	WORD		wh, xy[4];
	RECT 		r, r1, r2;

	menu = window->menu;
	wh = window->handle;

	if (window->first_menu == THEFIRST)				 		/* Auf erstem Men */
		arrows[M_LTARROW].ob_state |= DISABLED;
	else
		arrows[M_LTARROW].ob_state &= (~DISABLED);

	if (window->first_menu==menu[THEACTIVE].ob_tail)	/* Auf letzem Men */
		arrows[M_RTARROW].ob_state |= DISABLED;
	else
		arrows[M_RTARROW].ob_state &= (~DISABLED);

	/* Koordinaten fr Linie unter Men */
	xy[0] = window->work.x;
	xy[1] = window->work.y+menu[THEACTIVE].ob_height-1;
	xy[2] = xy[0]+window->work.w-1;
	xy[3] = xy[1];

	/* Nur Bereich der Menzeile betrachten */
	r = window->work;
	r.h = menu[THEACTIVE].ob_height;

	/* Men erst ab offset-Position malen */
	r2 = r;
	r2.x += menu_offset+menu[THEACTIVE].ob_x;

	if (!rc_intersect (d, &r)) return;		/* Nichts zu tun */

	if (rc_first(wh,d,&r1))
	{
		Hide_mouse();
		do
		{
			set_clip (TRUE,&r1);
			clr_area (&r);
			objc_draw (arrows, ROOT, 1, r1.x, r1.y, r1.w, r1.h);
			if (rc_intersect (&r2, &r1))
				objc_draw (menu, THEBAR, 2, r1.x, r1.y, r1.w, r1.h);
			v_pline (vdi_handle, 2, xy);		/* Line unter Menzeile */
		}while (rc_next(wh,&r1));
		Show_mouse();
	}
} /* draw_mbar */

/***************************************************************************/

VOID menu_normal (WINDP window, WORD title, BOOLEAN normal)
{
	if (window->flags&WI_MAIN_MENU)
	{
		menu_tnormal (menu, title, normal);						/* Benutze globales Men */
	}
	else
	{
		OBJECT	*menu;

		menu = window->menu;
		if (menu!=NULL)
		{
			BOOLEAN state = get_state(menu,title);

			if (state != normal) return;							/* nderung ? */
			set_state(menu,title,!normal);

			if (window->first_menu <= title)		 				/* Im Fenster ? */
				draw_mtitle (window, title);
		}
	}
} /* menu_normal */

/***************************************************************************/

LOCAL VOID hndl_mscroll (WINDP window, WORD obj, WORD breturn)
{
	WORD old, new, thelast, offset;
	WORD mox, moy, mobutton, mokstate;
	RECT r;

	thelast = window->menu[THEACTIVE].ob_tail;
	new = window->first_menu;
	do
	{
		old = new;

		switch (obj)
		{
			case M_LTARROW :	if (breturn == 2)				/* Doppelklick */
										new = THEFIRST;
									else if (new > THEFIRST)
										new--;
									break;
			case M_RTARROW :	if (breturn == 2)				/* Doppelklick */
										new = thelast;
									else if (new < thelast)
										new++;
									break;
		}
		if (old != new)
		{
			offset   = ((old == THEFIRST) || (new == THEFIRST) ||
							(old == thelast)	|| (new == thelast)) ? 0 : menu_offset;
			r.x		= window->work.x + offset;
			r.y		= window->work.y;
			r.w		= window->work.w - offset;
			r.h		= window->menu[THEACTIVE].ob_height - 1;

			window->first_menu = new;
			just_menu (window);							/* Objekte korrigieren */
			draw_mbar (window, &r);
		}

		graf_mkstate (&mox, &moy, &mobutton, &mokstate);
		obj = objc_find (arrows, ROOT, 1, mox, moy);	/* In Menpfeilen ? */

	}while (mobutton & 1);			 /* Bis kein Knopf mehr gedrckt ist */
} /* hndl_mscroll */

/***************************************************************************/

LOCAL VOID fix_menu (WINDP window)
{
	OBJECT	*menu;
	WORD		title, menubox;
	WORD		tdiff, ddiff, border;
	RECT		bbox, tbox, mbox;

	menu	  = window->menu;
	menubox = menu[ROOT].ob_tail;
	menubox = menu[menubox].ob_head;
	title	  = THEFIRST;

	objc_rect (menu, THEBAR, &bbox, FALSE);						/* Rechteck der Menzeile */

	if (!(window->flags & WI_MAIN_MENU))				/* Keine Accessories */
	{																/* Menbaum umhngen */
		menu[menubox].ob_height	= menu[menubox+1].ob_height;
		menu[menubox].ob_tail	= menu[menubox].ob_head;
		menu[menubox+1].ob_next = menubox;
	}

	do
	{
		menu[menubox].ob_x = menu[THEACTIVE].ob_x + menu[title].ob_x;	/* Normalstellung */
		menu[menubox].ob_y = 0;														/* Normalstellung */

		objc_rect (menu, title, &tbox, FALSE);
		objc_rect (menu, menubox, &mbox, FALSE);

		if ((mbox.y+mbox.h > desk.y+desk.h) &&			/* Mu nach oben klappen */
				(bbox.y > ((desk.y+desk.h)>>1)))			/* Oben mehr Platz als unten */
		{
			tdiff	= 0;
			border = (WORD)((menu[menubox].ob_spec.index >> 16) & 0x00FFL);

			if (border & 0x0080) border |= 0xFF00;				/* Rand negativ */

			if (border < 0) tdiff = - border;					/* Wegen Rand */

			if (menu[menubox].ob_state & SHADOWED)				/* Schatten bercksichtigen */
				tdiff += 2 * abs(border);

			if (menu[menubox].ob_state & OUTLINED)				/* Outlined bercksichtigen */
				if (border >= 0)
					tdiff += 3;											/* Wegen Rand */
				else
					if (border > -3) tdiff += 3 + border;

			menu[menubox].ob_y = - (menu[menubox].ob_height + menu[title].ob_height + tdiff);
		}

		tdiff = mbox.x + mbox.w - (tbox.x + tbox.w);
		ddiff = mbox.x + mbox.w - (desk.x + desk.w);			/* Rechts heraushngend ? */

		if (ddiff > 0) menu[menubox].ob_x -= max (tdiff, ddiff);

		menubox = menu[menubox].ob_next;							/* Nchstes Drop-Down-Men */
		title	 = menu[title].ob_next;								/* Nchster Titel */
	}while (title != THEACTIVE);
} /* fix_menu */

int objc_change( OBJECT *ob_ctree, int ob_cobject,
                 int ob_cresvd, int ob_cxclip, int ob_cyclip,
                 int ob_cwclip, int ob_chclip,
                 int ob_cnewstate, int ob_credraw );

LOCAL VOID Objc_change (OBJECT *ptr, WORD objc, WORD new_value, BOOLEAN draw)
{
	if (draw)
	{
		WORD	old_value;
	
		old_value = ptr[objc].ob_state;
		if ((old_value^new_value)==SELECTED && !(new_value&DISABLED))
			objc_change(ptr, objc, 0, desk.x, desk.y, desk.w, desk.h, new_value, TRUE);
		else
		{
			ptr[objc].ob_state = new_value;
			objc_draw(ptr, objc, 0, desk.x, desk.y, desk.w, desk.h);
		}
	}
	else
		ptr[objc].ob_state = new_value;
}

/***************************************************************************/

BOOLEAN menu_manager (WINDP window, WORD mox, WORD moy, WORD breturn)
{
	MFDB		buffer;
	WORD		title, item, oldtitle, olditem;
	WORD		menubox, obj;
	RECT		r, d;
	WORD		i;
	WORD		event, kreturn, ret, mobutton;
	BOOLEAN		in_title;
	OBJECT	*menu;
	MKINFO	mk;

	just_menu (window);	 							/* Menzeile fr Fenster korrigieren */

	menu = window->menu;
	if (moy >= window->work.y+menu[THEACTIVE].ob_height)
		return (FALSE);												/* Nicht in Menbereich */

	obj = objc_find (arrows, ROOT, 1, mox, moy);				/* In Menpfeilen ? */
	if (obj != NIL)													/* Menpfeile */
	{
		hndl_mscroll (window, obj, breturn);
		return (TRUE);
	}

	if (desk.w < 640)													 /* Menzeile angleichen */
	{
		menu[ROOT].ob_width						= 640;
		menu[THEBAR].ob_width					= 640;
		menu[menu[ROOT].ob_tail].ob_width	= 640;
	}
	if (window->updt_menu!=NULL)
		(*window->updt_menu) (window); 							/* Mens einstellen */

	oldtitle = NIL;
	olditem	= NIL;
	item		= NIL;
	menubox	= NIL;
	title		= objc_find (menu, THEACTIVE, MAX_DEPTH, mox, moy); /* In Men ? */

	if (title==NIL) return TRUE;

	if ((menu[title].ob_state&DISABLED) || (title < window->first_menu))
		return (TRUE);

	fix_menu (window);

	Arrow_mouse ();
	graf_mkstate(&ret, &ret, &mobutton, &ret);

	do
	{
		if (oldtitle!=title && title!=NIL)
		{
			menu_normal (window, title, FALSE);

			menubox = menu[ROOT].ob_tail;
			menubox = menu[menubox].ob_head;

			for (i=THEFIRST; i<title; i++)
				menubox = menu[menubox].ob_next;		/* Durchhangeln */

			background (menu, menubox, TRUE, &buffer, &d);
			draw_Objc (menu, menubox, 1);
		}

		if (item!=NIL)										/* In Meneintrag */
			objc_rect (menu, item, &r, FALSE);
		else if (title!=NIL)								/* In Mentitel */
			objc_rect (menu, title, &r, FALSE);
		else
		{
			r.x = mox;	r.y = moy;						/* Sonstwo */
			r.w = 1;		r.h = 1;
		}

		event = evnt_multi (MU_BUTTON | MU_M1,
								  1, 0x01, ~mobutton & 0x01,
								  1, r.x, r.y, r.w, r.h,
								  0, 0, 0, 0, 0,
								  NULL, 0, 0,
								  &mk.mox, &mk.moy,
								  &mk.mobutton, &mk.kstate,
								  &kreturn, &mk.breturn);

		mox = mk.mox;
		moy = mk.moy;

		oldtitle = title;
		olditem	= item;

		if (wind_find (mox, moy) == window->handle || menubox != NIL && 
										objc_find (menu, menubox, 0, mox, moy) != NIL)
		{
			title = objc_find (menu, THEACTIVE, MAX_DEPTH, mox, moy);
			if (title < window->first_menu) 
				title = NIL;

			item = (menubox==NIL) ? NIL : objc_find (menu, menubox, MAX_DEPTH, mox, moy);
		}
		else
		{																	/* Nicht im Fenster */
			title = NIL;
			item	= NIL;
		}

		in_title = (title!=NIL);

		if (menubox != NIL)
			if (title==NIL) 
				title = oldtitle;					 /* Auerhalb bei gewhltem Men */

		if (title != NIL)
			if (menu[title].ob_state&DISABLED) 
				title = NIL;

		if (item != NIL)
			if (menu[item].ob_state&DISABLED) 
				item = NIL;

		if (olditem != item)
		{
			if (olditem != NIL)
				Objc_change(menu, olditem, menu[olditem].ob_state&(~SELECTED), TRUE);
			if (item != NIL)
				Objc_change(menu, item, menu[item].ob_state|SELECTED, TRUE);
		}

		if (oldtitle != title && oldtitle != NIL)
		{
			background (menu, menubox, FALSE, &buffer, &d);
			menu_normal (window, oldtitle, TRUE);
			menubox = NIL;
		}
	}
	while (!(event & MU_BUTTON) || ((~mobutton&1) && in_title));
	Last_mouse ();

	if (menubox != NIL)
		background (menu, menubox, FALSE, &buffer, &d);

	if (item == NIL)
		menu_normal (window, title, TRUE);					/* Titel wieder normal */
	else
	{
		set_state(menu, item, FALSE);
		if (~mobutton & 1)
			evnt_button (1, 0x01, 0x00, &ret, &ret, &ret, &ret); /* Warte auf Mausknopf */

		if (window->hndl_menu != NULL)
			(*window->hndl_menu) (window, title, item);
	}

	return (TRUE);
} /* menu_manager */

/***************************************************************************/

BOOLEAN menu_key (WINDP window, MKINFO *mk)
{
	OBJECT	*lmenu;
	WORD		title, item, kreturn, kstate;

	lmenu = window->menu;

	if (lmenu==NULL && window->class == DESK)
		lmenu = menu;														/* Globales Men */

	if (lmenu!=NULL)
	{
		if (window->updt_menu!=NULL)
			(*window->updt_menu) (window);							/* Mens einstellen */

		if (mk->shift)				/* eventuelle SHIFT-Tasten ausblenden */
		{
			global_shift = TRUE;
			mk->shift = FALSE;
			kstate = mk->kstate;
			mk->kstate &= ~3;
			kreturn = mk->kreturn;
			mk->kreturn &= ~NKF_SHIFT;
		}
		if (my_menu_key (lmenu, mk, &title, &item))
		{
			(*window->hndl_menu) (window, title, item);			/* Men aufrufen */
			return (TRUE);													/* fertig */
		}
		if (global_shift)			/* und wieder einblenden */
		{
			mk->shift = TRUE;
			mk->kstate = kstate;
			mk->kreturn = kreturn;
		}
	}
	return (FALSE);
} /* menu_key */


/***************************************************************************/
/* Initialisieren des Moduls																*/
/***************************************************************************/

VOID init_windows (VOID)
{
	WINDP	window;
	WORD	wattr, hattr, i, *ptr;

	sel_window = NULL;									/* Kein Fenster angewhlt */
	setclr (sel_objs);									/* Keine Objekte selektiert */

	used_list = NULL;
	age = 0;
	ptr = (WORD*)&windrec[MAX_WINDOW];				/* letzen (von hinten) lschen */
	for (i= (short) sizeof(WINDOW)/2; (--i)>=0; )
		*(--ptr) = 0;
	free_list = window = &windrec[0];
	for (i=MAX_WINDOW-1; (--i)>=0; window++)
	{
		COPYW(window,ptr, (short)sizeof(WINDOW));
		window->age = age++;
		window->next = &window[1];
	}
	window->age = age++;
	window->next = NULL;

	wattr	= sys_wbox-2;									/* Rnder abziehen */
	hattr	= sys_hbox-2;
	arrows[ROOT].ob_width			= 2*wattr+1;	/* Pfeile anpassen */
	arrows[ROOT].ob_height			= hattr+1;
	arrows[M_LTARROW].ob_width		= wattr;
	arrows[M_LTARROW].ob_height	= hattr+1;
	arrows[M_RTARROW].ob_x			= wattr+1;
	arrows[M_RTARROW].ob_width		= wattr;
	arrows[M_RTARROW].ob_height	= hattr+1;

	menu_offset = (2 * wattr + 8) & (~7);			/* Offset Menzeile */
} /* init_windows */
